Summary: Oprogramowanie do monitorowania UPSow firmy Fideltronik
Name: upsfid
Version: 3.1.0
Release: 1
Copyright: freeware
Group: System Environment/Daemons
BuildRoot: /var/tmp/%{name}-buildroot

%description
Program UPS Monitor suy do monitorowania pracy UPSw
firmy Fideltronik, do ich konfiguracji oraz do zamykania
systemu i wyczania UPSa w razie awarii zasilania.
Informowanie uytkownika obejmuje komunikaty, logi, stron
www, uruchamianie wasnych programw oraz e-maile/SMSy.
Oprogramowanie skada si z 2 czci: klient i serwer, ktre
mog si komunikowa przez sie, a take pozwalaj na
monitorowanie wielu UPSw rwnoczenie na wielu komputerach.

%prep

%build

%pre
mkdir -p /var/log/fideltronik

%install
rm -rf %{buildroot}

#katalog instalacji
PATH_INSTALL=/home/ltokarski/install

#######################################
#Tworzenie katalogow
mkdir -p %{buildroot}/etc/init.d
mkdir -p %{buildroot}/etc/X11/xinit/xinitrc.d
mkdir -p %{buildroot}%{_sbindir}/
mkdir -p %{buildroot}/etc/ups/fideltronik
mkdir -p %{buildroot}/usr/share/doc/upsfid-3.1.0
#mkdir -p %{buildroot}/var/log/fideltronik
mkdir -p %{buildroot}/var/www/html/fideltronik
mkdir -p %{buildroot}/var/www/html/fideltronik/images.temp

ARG1="-m 744 -o root -g root"
ARG2="-m 644 -o root -g root"
ARG3="-m 755 -o root -g root"

install $ARG1 $PATH_INSTALL/bin/upsmonc     %{buildroot}%{_sbindir}/
install $ARG1 $PATH_INSTALL/bin/upsmons     %{buildroot}%{_sbindir}/
install $ARG1 $PATH_INSTALL/bin/upsoff      %{buildroot}%{_sbindir}/
install $ARG1 $PATH_INSTALL/bin/shutdown.sh %{buildroot}%{_sbindir}/
install $ARG1 $PATH_INSTALL/bin/xmess       %{buildroot}%{_sbindir}/
install $ARG1 $PATH_INSTALL/upsfid          %{buildroot}/etc/init.d
install $ARG3 $PATH_INSTALL/xhostfid.sh     %{buildroot}/etc/X11/xinit/xinitrc.d
install $ARG1 $PATH_INSTALL/README          %{buildroot}/usr/share/doc/upsfid-3.1.0/README
install $ARG2 $PATH_INSTALL/cfg/*.cfg       %{buildroot}/etc/ups/fideltronik
install $ARG2 $PATH_INSTALL/cfg/upsmonc.dat %{buildroot}/etc/ups/fideltronik
install $ARG2 $PATH_INSTALL/images/*.jpg    %{buildroot}/var/www/html/fideltronik/images.temp
install $ARG2 $PATH_INSTALL/images/*.gif    %{buildroot}/var/www/html/fideltronik/images.temp

%post
#######################################
#echo "Dowiazanie pliku startowego w celu automatycznego uruchamiania"
ln -s /etc/init.d/upsfid /etc/rc3.d/S61upsfid
ln -s /etc/init.d/upsfid /etc/rc5.d/S61upsfid

#######################################
# Skopiowanie obrazkow, zeby potem nie zostaly skasowane
#mkdir /var/www/html/fideltronik/images 2> /dev/nul
#cp -rf /var/www/html/fideltronik/images.temp/* /var/www/html/fideltronik/images/
rm -fr /var/www/html/fideltronik/images 2> /dev/nul
mv -f /var/www/html/fideltronik/images.temp /var/www/html/fideltronik/images

#######################################
# Odtworzenie poprzedniej konfiguracji
if [ -f /etc/ups/fideltronik/options.cfg.rpmsave ]; then
	mv -f /etc/ups/fideltronik/options.cfg /etc/ups/fideltronik/options.cfg.orig
	mv /etc/ups/fideltronik/options.cfg.rpmsave /etc/ups/fideltronik/options.cfg
fi
if [ -f /etc/ups/fideltronik/ups.cfg.rpmsave ]; then
	mv -f /etc/ups/fideltronik/ups.cfg /etc/ups/fideltronik/ups.cfg.orig
	mv /etc/ups/fideltronik/ups.cfg.rpmsave /etc/ups/fideltronik/ups.cfg
fi

%preun
#echo "Zatrzymywanie programu"
killall -9 upsmonc 2>/dev/nul
killall -9 upsmons 2>/dev/nul
sleep 1

#echo "Kasowanie plikw utworzonych przez program"
#rm -f /etc/ups/fideltronik/xmessage.pid
#rm -f /etc/ups/fideltronik/upsoff.conf
#rm -f /var/www/html/fideltronik/ups*
#rm -f /var/www/html/fideltronik/index.html

%clean
rm -rf %{buildroot}

%postun
rm -f /etc/rc3.d/S61upsfid
rm -f /etc/rc5.d/S61upsfid
#echo "Program wyinstalowany"

%files
#%defattr(-,root,root)
%doc /usr/share/doc/upsfid-3.1.0/README

/var/www/html/fideltronik
%config  /etc/ups/fideltronik/*

%{_sbindir}/upsmons
%{_sbindir}/upsmonc
%{_sbindir}/upsoff
%{_sbindir}/shutdown.sh
%{_sbindir}/xmess

/etc/init.d/upsfid
/etc/X11/xinit/xinitrc.d/xhostfid.sh

%changelog
