///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/09 11:31:07 $
//         $Locker:  $
//         $Revision: 1.10 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Obsuga wysyania emaili
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: mailcln.cpp,v $
// Revision 1.10  2004/06/09 11:31:07  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/un.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <netdb.h>
#include <pthread.h>
#include <signal.h>

#include "cstr.h"
#include "linux_ty.h"
#include "netdatag.h"
#include "upsmon.h"
#include "upsconfig.h"
#include "upslog.h"
#include "mailcln.h"
#include "smem.h"
#include "main.h"
#include "threads.h"

//#define DEBUG_S

extern int __debug;
extern int __ncurr;
extern void DbLine(char *str);


/////////////////////////////////////////////////////////////////////////////
#define SMTP_PORT       25

#define SMTP_READY      "220"
#define SMTP_CLOSE      "221"
#define SMTP_OK         "250"
#define SMTP_START_MAIL "354"
#define ERROR_SMTP_1	"553"


/////////////////////////////////////////////////////////////////////////////
CSMTPClient::CSMTPClient()
{
	m_Socket=0;
	m_GetHostByName=0;
	m_SendingState=0;
	m_Domain=".";
	char hostname[1255]=".";
	int res=gethostname(hostname,sizeof(hostname));
	if(res==0)
	{
		struct hostent *h=gethostbyname(hostname);
		if(h==NULL)
			return;
		if(!strncmp(h->h_name,hostname,strlen(hostname)))
		{
			if(h->h_name[strlen(hostname)]=='.')
				m_Domain=(char *)h->h_name+strlen(hostname)+1;
			else
				m_Domain=(char *)h->h_name;
		}
	}
	else
	{
		perror("Gethostname :");
		if(__debug)
			printf(" EINVAL=%d, EPERM=%d,EFAULT=%d,errno=%d\n",EINVAL,EPERM,EFAULT,errno);
	}
} // CSMTPClient::CSMTPClient


/////////////////////////////////////////////////////////////////////////////
CSMTPClient::~CSMTPClient()
{
	//printf("Desc maila sock=%d\n",m_Socket);
	//if(m_GetHostByName!=0) WSACancelAsyncRequest(m_GetHostByName);
	//if(m_Socket!=NULL) Disconnect(MAIL_DISCONNECT_QUIETABORT,TRUE);
	//POSITION pos=m_Mails.GetHeadPosition();
	//while(pos!=NULL) delete m_Mails.GetNext(pos);
	//m_Mails.RemoveAll();
} // CSMTPClient::~CSMTPClient


/////////////////////////////////////////////////////////////////////////////
void CSMTPClient::Init(CDlgMain *Main)
{
	m_Main=Main;
} // CSMTPClient::Init


/////////////////////////////////////////////////////////////////////////////
void CSMTPClient::Stop()
{
	//if(m_Socket!=NULL) Disconnect(MAIL_DISCONNECT_ABORT,TRUE);
	if(m_Socket != 0) 		//LT tymcz
		Disconnect(MAIL_DISCONNECT_OK, TRUE);
} // CSMTPClient::Stop


void *sendEmailThread(void *UPS)
{
	ThreadCount |= THREAD_MAIL;
	CSMTPClient m_Clinet;
	if(m_Clinet.SendMail((CUPSConfig *)UPS) < 0)
	{
		ThreadCount &= ~THREAD_MAIL;
		raise(SIGTERM);
		exit(1);
		return (void *)0;
	}
	ThreadCount &= ~THREAD_MAIL;
	return (void *)0;
}


int sendEmail(CUPSConfig *UPS)
{
	pthread_t mythread;

	//sendEmailThread(UPS); //zjada pamiec
	//return ;


	UPS->m_DataReady=0;
	if ( pthread_create( &mythread,(pthread_attr_t  *)0,sendEmailThread,(void *)UPS))
	{ //watek obsluguje RS
		perror("error creating thread sendEmail.");
		return -1;
	}
	while(UPS->m_DataReady==0)
	{ //czekam na kopie danych
		usleep(10000);
	};
	//sleep(1);
	int res=pthread_detach(mythread);
	if(__debug)
		printf("Send detach %d\n",res);
	return 1;
}

/////////////////////////////////////////////////////////////////////////////
int CSMTPClient::SendMail(CUPSConfig *UPS)
{
	strcpy(m_IP,UPS->m_IP);
	m_pathLogWWW=UPS->m_pathLogWWW;
	m_UPSId=UPS->m_UPSId;
	m_SMTPServer=(char *)UPS->m_Events[UPS->m_CurrEvent].m_SendMailSMTP;
	m_From=UPS->m_Events[UPS->m_CurrEvent].m_SendMailFrom;
	m_From+="@";
	m_From+=m_SMTPServer;
	m_To=(char *)UPS->m_Events[UPS->m_CurrEvent].m_SendMailTo;
	m_Subject=(char *)UPS->m_Events[UPS->m_CurrEvent].m_SendMailSubject;
	m_Msg=(char *)UPS->m_Events[UPS->m_CurrEvent].m_SendMailMessage;
	m_Abort=0;
// dane kopia
	UPS->m_DataReady=1;

	if(__debug)
		printf("Send email to %s sub %s\n",(char *)m_To,(char *)m_Subject);

	if(__debug)
	{
		printf("m_SMTPServer=-%s-\n",(char *)m_SMTPServer);
		printf("m_From=-%s- \n",(char *)m_From);
		printf("m_To=-%s- \n",(char *)m_To);
		printf("m_Subject=-%s- \n\r\n\r",(char *)m_Subject);
	}
	if(strlen(m_SMTPServer)==0)
	{
		printf("Nie podano nazwy serwera SMTP\n");
		return -1;
	}
	if(!Connect(m_SMTPServer))
	{
		//m_Main->OnSendMailEnd(STATUS_GETTING_DATA ,m_UPSId); //tu blad gdyz jestesmy kopia klasy
		if(__debug)
			printf("Blad 1\n");
		// kopia dla loga
		strcpy(UpsLog.m_IP,m_IP);
		UpsLog.m_pathLogWWW=m_pathLogWWW;
		UpsLog.m_UPSId=m_UPSId;
		m_Log.Add(&UpsLog,STATUS_GETTING_DATA,LOG_ERR_SEND_MAIL);
		Disconnect(MAIL_DISCONNECT_CANTCONNECT);
	}
	if(__debug)
		printf("Email sended\n");
	return 0;
} // CSMTPClient::SendMail

/////////////////////////////////////////////////////////////////////////////
void CSMTPClient::CheckState()
{

	if(m_Socket==0)
		return;
	if((m_clock()-m_StartTime)>SEND_MAIL_TIMEOUT)
	{
		if(__debug)
			printf("Disconet time_out start=%ld  timeout=%d clock=%ld\n",m_StartTime,SEND_MAIL_TIMEOUT,m_clock());
		Disconnect(MAIL_DISCONNECT_TIMEOUT);
	}
} // CSMTPClient::CheckState


/////////////////////////////////////////////////////////////////////////////
void CSMTPClient::CancelSend(DWORD Id)
{
	// przegladamy liste m_Mails i oznaczamy wszystkie elementy z m_UPSId==Id
	// jako m_Abort=1, usunieto ten UPS, wiec nie nalezy wysylac tych wiadomosci
} // CSMTPClient::CancelSend


//////////////////////////
time_t CSMTPClient::m_clock()
{
	time_t t1;
	static time_t tm_s;
	static time_t t_start=0;

	time(&t1);
	if(t_start==0)
	{
		t_start=1;
		time(&tm_s);
		return 0;
	}
	else
		return t1-tm_s;
}

/////////////////////////////////////////////////////////////////////////////
BOOL CSMTPClient::Connect(LPCTSTR Address)
{
	struct hostent *he;
	m_StartTime=m_clock();
	m_Socket=socket(AF_INET,SOCK_STREAM,0);
	if(m_Socket<0)
	{
		//delete m_Socket;
		perror("mailcln socket err: ");
		m_Socket=0;
		return FALSE;
	}

	if(inet_addr(Address)==INADDR_NONE)
	{
		strncpy(m_HostName,Address,MAX_HOST_NAME);
	}
	add.sin_port=htons(SMTP_PORT);
	if( (he=gethostbyname(Address))==NULL)
	{
		perror("gethostbyname2 ");
		printf("Addr -%s-\n",Address);
		close(m_Socket);
		m_Socket=0;
		return FALSE;
	}
	char **adresy;
	adresy=he->h_addr_list;
	//while(*adresy){
	//	printf("\n\r adresy -%s- ",inet_ntoa(*(struct in_addr*)*adresy));
	//	adresy++;
	//	getchar();
	//}

	add.sin_addr.s_addr=inet_addr(inet_ntoa(*(struct in_addr*)*adresy));
	add.sin_family=AF_INET;
	add.sin_port=htons(SMTP_PORT);
	memset(&(add.sin_zero),0,8);

	int res=connect(m_Socket,(struct sockaddr *)&add,sizeof(add));
	if(res==-1)
	{
		perror("Connect ");
		printf("Blad polaczenia z serwerem poczty: %s\n",Address);
		close(m_Socket);
		m_Socket=0;
		//m_Log.Add(this,"aa","aa");
		return FALSE;
	}
	if(__debug)
		printf("Conenct OK sock=%d res=%d\n",m_Socket,res);

	//int res=sendto(m_Socket,buff,4+DataLen,0,(struct sockaddr *)&add,sizeof(sockaddr));

	/*if(!m_Socket->Connect(Address,SMTP_PORT))
	{
		if(GetLastError()==WSAEWOULDBLOCK) return TRUE; // reszta w funkcji ProcessPendingConnect()

		delete m_Socket;
		m_Socket=NULL;
		return FALSE;
	}
	*/
	m_SendingState=1;
	m_BuffLen=sizeof(m_Buff);
	m_BuffOffset=0;
	res	=0;

	OnReceive(res);
	return TRUE;
} // CSMTPClient::Connect


/////////////////////////////////////////////////////////////////////////////

void CSMTPClient::ProcessPendingConnect(int ErrorCode)
{
	if(ErrorCode==0)
	{
		m_SendingState=1;
		m_BuffLen=sizeof(m_Buff);
		m_BuffOffset=0;
	}
	else
	{
		if(__debug)
			printf("Disconnect ProcessPending %d\n",ErrorCode);
		Disconnect(MAIL_DISCONNECT_CANTCONNECT);
	}
} // CSMTPClient::ProcessPendingConnect


/////////////////////////////////////////////////////////////////////////////
void CSMTPClient::Disconnect(BYTE ErrorCode, BOOL DisconnectAll)
{
	if(m_Socket!=0)
	{
		Send("QUIT\r\n");
		BYTE buff[255];
		//	m_Socket->ShutDown();
		//while(m_Socket->Receive(buff,50)>0);
		clilen=sizeof(struct sockaddr);

		struct timeval tv;
		fd_set rset;
		FD_ZERO(&rset);
		time_t s=m_clock();
		int result=-1;
		int res;
		do
		{
			FD_SET(m_Socket,&rset);

			tv.tv_sec = SEND_MAIL_TIMEOUT;
			tv.tv_usec = 0; //100ms
			res=select(m_Socket+1,&rset,NULL,NULL,&tv);
			result=0;
			if(FD_ISSET(m_Socket,&rset))
				res=recvfrom(m_Socket,buff,sizeof(buff),0,(struct sockaddr *)&add_cli,(socklen_t *)&clilen);
		}
		while(res<=0 && (m_clock()-s)<SEND_MAIL_TIMEOUT);
		if(/*res<=0*/ ErrorCode != MAIL_DISCONNECT_OK)
		{
			//m_Main->OnSendMailEnd(STATUS_GETTING_DATA ,m_UPSId);
			CUPSConfig UpsLog;
			// kopia dla loga
			strcpy(UpsLog.m_IP,m_IP);
			UpsLog.m_pathLogWWW=m_pathLogWWW;
			UpsLog.m_UPSId=m_UPSId;
			m_Log.Add(&UpsLog,STATUS_GETTING_DATA,LOG_ERR_SEND_MAIL);
			if(res==-1)
				perror("MailCl rec close : ");
		}
		//delete m_Socket;
		res=close(m_Socket);
		m_Socket=0;
		if(res==-1)
			perror("Close Socket :");
	}
} // CSMTPClient::Disconnect


char CSMTPClient::EncodePl(char b)
{
	return b;
}

/////////////////////////////////////////////////////////////////////////////
// koduje In do Out zgodnie ze standardem =?iso-8859-2?Q?text?= (RFC1522)
void CSMTPClient::EncodePlSubject(CString In, CString &Out)
{

	if(!IsPl(In[0]))
	{

		//Out.Debug=1;
		//In.Debug=1;
		Out=In;
		//Out.Debug=0;
		//In.Debug=0;

		return;
	}

	int len=In.GetLength();
	Out="=?iso-8859-2?Q?";
	int lineLen=Out.GetLength();
	CString txt;
	for(int i=0; i<len; i++)
	{
		if(IsPl(In[i]))
		{
			//txt.Format("=%02X",EncodePl(In[i]));
			char t[10];
			sprintf(t,"=%02X",EncodePl(In[i]));
			txt=t;
			Out=Out+txt;
			lineLen+=2; // bo na koncu jest lineLen++;
		}
		else if(!isprint(In[i]) || In[i]=='=' || In[i]=='?' || In[i]=='_')
		{
			txt.Format("=%02X",(BYTE)In[i]);
			Out=Out+txt;
			lineLen+=2; // bo na koncu jest lineLen++;
		}
		else if(In[i]==' ')
			 Out+="_";
		else
			Out=Out+In[i];
		lineLen++;
		if(lineLen>70) // wedlug RFC1522 linia nie powninna przekraczac 75 znakow
		{
			Out+="?=\r\n =?iso-8859-2?Q?";
			lineLen=15;
		}
	}
	Out+="?=";
} // CSMTPClient::EncodePlSubject


char CSMTPClient::IsPl(char b)
{
	if(b>'}')
		return 1;
	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// tworzy Out z In zamieniajac polskie znaki w standardzie cp1250 na znaki
// w standardzie iso-8859-2, zwraca TRUE gdy In zawiera jakies polskie znaki
BOOL CSMTPClient::EncodePlMsg(LPCTSTR In, LPCTSTR Out)
{
	int len=strlen(In);
	BOOL retVal=FALSE;
	//Out.Empty();
	memset(Out,0,sizeof(Out));
	for(int i=0; i<len; i++)
	{
		if(IsPl(In[i]))
		{
			Out[i]=EncodePl(In[i]);
			retVal=TRUE;
		}
		else
			Out[i]=In[i];
	}
	return retVal;
} // CSMTPClient::EncodePlMsg


/////////////////////////////////////////////////////////////////////////////
BOOL CSMTPClient::SendMsg(LPCTSTR Str)
{
	CString txt;
	txt=Str;

	if(!Send(txt))
		return FALSE;
	return TRUE;
} // CSMTPClient::SendMsg


/////////////////////////////////////////////////////////////////////////////
BOOL CSMTPClient::Send(LPCTSTR Str)
{
	if(m_Socket==0)
		return FALSE;
	int len=strlen(Str);
	char Address[128];
	strcpy(Address,m_HostName);
	int res=sendto(m_Socket,Str,len,0,(struct sockaddr *)&add,sizeof(sockaddr));
	if(res==-1)
	{
		perror("MailCln send :");
		return FALSE;
	}
	//if(m_Socket->Send(Str,len)!=len) return FALSE;
	return TRUE;
} // CSMTPClient::Send


/////////////////////////////////////////////////////////////////////////////
void CSMTPClient::ProcessPendingRead(int &ErrorCode)
{
	time_t  s=m_clock();
	struct timeval tv;

	fd_set rset;
	FD_ZERO(&rset);
	int result=-1;
	int res;
	do
	{
		FD_SET(m_Socket,&rset);
		tv.tv_sec = SEND_MAIL_TIMEOUT;
		tv.tv_usec = 0; //100ms
		int res=select(m_Socket+1,&rset,NULL,NULL,&tv);
		if(res==-1)
		{
			if(__debug)
				printf("select Res =%d \n",res);
			perror("Select ");
		}
		result=0;
		if(FD_ISSET(m_Socket,&rset))
		{
			result=recvfrom(m_Socket,m_Buff+m_BuffOffset,120,0,(struct sockaddr *)&add_cli,(socklen_t *)&clilen);
//			if(result==-1){
//				;//printf("Read result=%d,time2 =%ld buff=-%s-\n",result,m_clock()-s,m_Buff);
//			}
		}
	}
	while(res==-1 && (m_clock()-s)<SEND_MAIL_TIMEOUT && result==0);

	if(res==-1 || result==-1)  //timeout
	{
		if(result==-1)
		{
			if(__debug)
				perror("MailClRead rec ");
			m_Log.Add(&UpsLog,STATUS_GETTING_DATA,LOG_ERR_SEND_MAIL);
		}
		//printf("Disconet Mail error or timeout %ld \n",m_clock()-s);
		Disconnect(MAIL_DISCONNECT_SENDERROR);
		ErrorCode=1;
		//printf("Error %d=\n",ErrorCode);
		//getchar();
		return;
	}
	ErrorCode=0;
	m_BuffOffset+=result;
	if(m_BuffOffset>1 && m_Buff[m_BuffOffset-2]=='\r'&& m_Buff[m_BuffOffset-1]=='\n')
	{
		m_Buff[m_BuffOffset-2]='\0';
		ChangeState(m_Buff);
		m_BuffOffset=0;
	}
	//return 0;
} // CSMTPClient::ProcessPendingRead


/////////////////////////////////////////////////////////////////////////////
void CSMTPClient::ChangeState(char *Buff)
{
	CString txt;
	BOOL error=FALSE;
	if(m_SendingState==1)
	{
		if(strncmp(Buff,SMTP_READY,strlen(SMTP_READY)))
			error=TRUE;
		else
		{
			txt.Format("HELO %s\r\n",m_Domain);
			if(!Send(txt))
				error=TRUE;
			else
				m_SendingState++;
		}
	}
	else if(m_SendingState==2)
	{
		if(strncmp(Buff,SMTP_OK,strlen(SMTP_OK)))
			error=TRUE;
		else
		{
			txt.Format("MAIL FROM: <%s>\r\n",m_From);
			if(!Send(txt))
				error=TRUE;
			else
				m_SendingState++;
		}
	}
	else if(m_SendingState==3)
	{
		if(strncmp(Buff,SMTP_OK,strlen(SMTP_OK)))
			error=TRUE;
		else
		{
			txt.Format("RCPT TO: <%s>\r\n",m_To);
			if(!Send(txt))
				error=TRUE;
			else
				m_SendingState++;
		}
	}
	else if(m_SendingState==4)
	{
		if(strncmp(Buff,SMTP_OK,strlen(SMTP_OK)))
			error=TRUE;
		else
		{
			txt="DATA\r\n";
			if(!Send(txt))
				error=TRUE;
			else
				m_SendingState++;
		}
	}
	else if(m_SendingState==5)
	{
		if(strncmp(Buff,SMTP_START_MAIL,strlen(SMTP_START_MAIL)))
			error=TRUE;
		else
		{
			// RFC822 - header fields should be sent in the order: "Return-Path",
			// "Received", "Date", "From", "Subject", "Sender", "To", "cc", etc.
			time_t t2;
			time(&t2);

			CString d;
			d=ctime(&t2);
#define SIZE_DATE 120
			char date[SIZE_DATE];
			memset(date,0,sizeof(date));
			strncpy(date,d,strlen(d)-1);

			//date[strlen(date)]=0;
			//"Wed Jun 30 21:49:08 1993\n";
			CString subject;
			CString  msg;
			//LPCTSTR In, CString &Out

			msg=m_Msg;
			subject=m_Subject;
			BOOL pl=FALSE;
			char m[255];
			sprintf(m,"Date: %s\r\nFrom: <%s>\r\nSubject: %s\r\nTo: <%s>\r\nX-Priority: 1 (Highest)",(char *)date,(char *)m_From,(char *)subject,(char *)m_To);
			txt=m;

			if(pl)
			{
				CString polData;
				polData="MIME-Version: 1.0\r\nContent-Type: text/plain; charset=\"iso-8859-2\"\r\nContent-Transfer-Encoding: 8bit\r\n\r\n";
				txt=txt+polData;
			}
			else
				txt+="\r\n\r\n";
			if(!Send(txt))
				error=TRUE;
			if(!error && !SendMsg(msg))
				error=TRUE;
			if(!error)
			{
				txt="\r\n.\r\n";
				if(!Send(txt))
					error=TRUE;
				else
					m_SendingState++;
			}
		}
	} //if(m_SendingState==5)
	else if(m_SendingState==6)
	{
		if(strncmp(Buff,SMTP_OK,strlen(SMTP_OK)))
			error=TRUE;
		else
		{
			Disconnect(MAIL_DISCONNECT_OK);
			m_SendingState++;
		}
	}
	else if(m_SendingState==7)
	{
		if( strncmp(Buff,SMTP_CLOSE,strlen(SMTP_CLOSE))/* && strncmp(Buff,SMTP_OK,strlen(SMTP_OK))*/)
			error=TRUE;
		else
		{
			Disconnect(MAIL_DISCONNECT_OK);
			return;
		}
	}
	else
		error=TRUE;

	if(error)
	{
		Disconnect(MAIL_DISCONNECT_SENDERROR);
		return;
	}
} // CSMTPClient::ChangeState


/////////////////////////////////////////////////////////////////////////////
void CSMTPClient::ProcessPendingClose(int ErrorCode)
{
	if(m_SendingState==7)
		Disconnect(MAIL_DISCONNECT_OK);
	else
		Disconnect(MAIL_DISCONNECT_SENDERROR);
} // CSMTPClient::ProcessPendingClose


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
void CSMTPClient::OnReceive(int ErrorCode1)
{

	if(__debug)
		printf("OnReceive Start\n");

	int ErrorCode=ErrorCode1;
	do
	{
		ProcessPendingRead(ErrorCode);
		//printf("Stan %d err=%d\n",m_SendingState,ErrorCode);
	}
	while(m_SendingState<7 && ErrorCode==0);
}


/////////////////////////////////////////////////////////////////////////////
//void CSMTPClientSocket::OnClose(int ErrorCode)
//{
	//CAsyncSocket::OnClose(ErrorCode);
	//m_SMTPCln->ProcessPendingClose(ErrorCode);
//} // CSMTPClientSocket::OnClose

// EOF //////////////////////////////////////////////////////////////////////
