///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/09 11:31:07 $
//         $Locker:  $
//         $Revision: 1.4 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Obsuga wysyania emaili
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: mailcln.h,v $
// Revision 1.4  2004/06/09 11:31:07  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////

#ifndef _MailCln_h_
#define _MailCln_h_

#include <time.h>

class CDlgMain;
class CUPSConfig;
//class CString;

/////////////////////////////////////////////////////////////////////////////
#define MAIL_DISCONNECT_QUIETABORT  0
#define MAIL_DISCONNECT_ABORT       1
#define MAIL_DISCONNECT_CANTCONNECT 2
#define MAIL_DISCONNECT_SENDERROR   3
#define MAIL_DISCONNECT_TIMEOUT     4
#define MAIL_DISCONNECT_OK          5


class CMailMessage
{
public:
   DWORD m_UPSId;
   CString m_SMTPServer;
   CString m_From;
   CString m_To;
   CString m_Subject;
   CString m_Msg;
   BYTE m_Abort;         // ==1 gdy mamy nie wysylac tej wiadomosci (patrz CancelSend())
};


class CSMTPClient
{
//friend class CSMTPClientSocket;
public:
   CSMTPClient();
   ~CSMTPClient();

   CUPSLog m_Log;   //log dla klienta poczty
   void OnReceive(int ErrorCode);
   void Init(CDlgMain *Main);
   void Stop();
   int SendMail(CUPSConfig *UPS);
   //void ProcessPendingGetHostByName(WPARAM wParam, LPARAM lParam);
   void CheckState();
   void CancelSend(DWORD Id);
   char EncodePl(char b);
   time_t m_clock();
   CUPSConfig UpsLog;

protected:

   int                  serlen,clilen;
   struct sockaddr_in	add;
   struct sockaddr_in	add_cli;


   int m_Socket;
   CDlgMain *m_Main;
   //CTypedPtrList<CPtrList,CMailMessage*> m_Mails;
   //CMailMessage m_Mails[1]; //100 wiadomosci do 2002.11.18

   //CSMTPClientSocket *m_Socket;

   char m_HostName[MAX_HOST_NAME+1];   // bufor na nazwe hosta
   char m_HostEntry[MAXGETHOSTSTRUCT]; // bufor przekazywany do WSAAsyncGetHostByName()
   HANDLE m_GetHostByName;             // HANDLE zwracany przez WSAAsyncGetHostByName()

   DWORD m_UPSId;
   char m_IP[50]; //PA
   CString m_pathLogWWW; //PA dla loga
   CString m_Null;
   CString m_SMTPServer;
   CString m_From;
   CString m_To;
   CString m_Subject;
   CString m_Msg;
   BYTE m_Abort;
   clock_t m_StartTime;  // czas rozpoczecia wysylania wiadomosci

   CString m_Domain;
   int m_SendingState;   // 0 - not connected
                         // 1 - connected
                         // 2 - sending HELO
                         // 3 - sending MAIL FROM
                         // 4 - sending RCPT TO
                         // 5 - sending DATA
                         // 6 - sending message
                         // 7 - sending QUIT

   char m_Buff[512+1];   // maksymalna dlugosc odpowiedzi 512 bajtow bylo 1024 2002.11.18
   int m_BuffLen;
   int m_BuffOffset;

   BOOL Connect(LPCTSTR Address);
   void ProcessPendingConnect(int ErrorCode);
   void Disconnect(BYTE ErrorCode, BOOL DisconnectAll=FALSE);
   void ProcessPendingRead(int &ErrorCode);
   void EncodePlSubject(CString In, CString &Out);
   BOOL EncodePlMsg(LPCTSTR In, LPCTSTR Out);

   BOOL SendMsg(LPCTSTR Str);
   BOOL Send(LPCTSTR Str);

   void ChangeState(char *Buff);
   void ProcessPendingClose(int ErrorCode);
   char IsPl(char b);
};

/*
class CSMTPClientSocket //: public CAsyncSocket
{
public:
   CSMTPClientSocket(CSMTPClient *SMTPCln);

protected:
   virtual void OnConnect(int ErrorCode);
   virtual void OnReceive(int ErrorCode);
   virtual void OnClose(int ErrorCode);

private:
   CSMTPClient *m_SMTPCln;
};
*/
#endif // _MailCln_h_

// EOF //////////////////////////////////////////////////////////////////////
