///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/23 13:43:34 $
//         $Locker:  $
//         $Revision: 1.37 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: main.cpp,v $
// Revision 1.37  2004/07/23 13:43:34  ltokarski
// Z0020 - poprawiony sporadyczny blad zwiazany z niezwolnieniem socketa i perror po Connect
//
// Revision 1.36  2004/07/20 12:06:04  ltokarski
// Z0019 - umozliwienie wywolania programu z parametrami
//
// Revision 1.35  2004/07/20 10:17:35  ltokarski
// wyrownanie "okienek" przy starcie i w statusie
//
// Revision 1.34  2004/07/12 13:35:24  ltokarski
// Z0017 - komunikowanie w X-ach
//
// Revision 1.32  2004/07/09 11:20:47  ltokarski
// Z0015 - dodane pozostale parametry do statusu
//
// Revision 1.31  2004/07/07 15:07:35  ltokarski
// Z0013 - wartosci domyslne parametrow w ups.cfg (zaraz po UPS_NR, przed eventami)
//
// Revision 1.30  2004/07/05 11:20:56  ltokarski
// Z0012 - wyswietlanie statusu na zadanie
//
// Revision 1.29  2004/07/05 09:09:43  ltokarski
// Z0011 - rozne drobne poprawki (html cd., blad waitpid, taby przed warningiem, CString operator ==, wyciete debugi)
//
// Revision 1.28  2004/06/30 16:43:15  ltokarski
// Z0009 - uporzadkowanie pamieci dzielonej
//
// Revision 1.27  2004/06/29 16:16:09  ltokarski
// Z0008 - przechodzenie do tla dopiero po zainicjowaniu i zwracanie kodu bledu
//
// Revision 1.26  2004/06/23 14:07:10  ltokarski
// no message
//
// Revision 1.25  2004/06/23 08:40:32  ltokarski
// Z0003 - czytanie pliku options.cfg
// Z0005 - zmienne sciezki instalacji
// Z0006 - zmienne numery portow
//
// Revision 1.23  2004/06/09 14:16:29  ltokarski
// Z0002 - zwracanie bdw do KillAll
//
// Revision 1.22  2004/06/09 11:31:07  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// Name:		UPS Monitor 3.0 dla Linux
// Set up:		2002.09.01
// Autor:		Pawel Abramczuk
// Company:		Fideltronik Krakow
// Operating system(s):
//				RedHat 7.1
//				RedHat 8.0
// Compiler:	gcc version 2.96 20020731 (Red Hat Linux 7.1 2.96-98)
// Compiler:	g++ version 3.2 (Red Hat Linux 8.0)
////////////////////////////////////////////////////////////////////////////
// History:
// 2002.10.21 version 0.9
//
// 2002.11.18 version 0.91
//
// 2002.11.19 version 0.92
// zwalanianie pamieci przy wysylaniu mail-a (pthread i detach) mailcln.cpp
// 2003.01.21 ver 3.0.0.2
// poprawiono wylaczanie stykowego
// 2003.02.10 ver 3.0.0.4
// drobne zmiany. wpisano sciezke /etc/ups (i /etc/ups/sripts) na stale
// 2003.02.18 ver 3.0.0.4
// Zmiany w www. Dodano wyswietlanie wersji ups-a i stanu ups-a
// wypelnianie listy z ups-ami (sciezki do loga) dla wszystkich
// 2003.02.24 ver 3.0.0.4
// Zmiana napisy w logo na 3.0.0.4
// m_CS.Lock sprawdzona
// blad w wykrywaniu klienta lokalnego
/////////////////////////////////////////////////////////////////////////////
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <pthread.h>
//#include <curses.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/un.h>
#include <sys/time.h>
#include <sys/file.h>  //flock
#include <sys/ioctl.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <unistd.h>
#include <netdb.h>
#include <pthread.h>
#include <sys/times.h>  //clock_t
#include <sys/types.h>  //waitpid
#include <sys/wait.h>	//waitpid


#include <signal.h>
#include <termios.h>
#include <time.h>

#include "cstr.h"
#include "linux_ty.h"
#include "netdatag.h"
#include "upsmon.h"
#include "html.h"
#include "upsconfig.h"
#include "upslog.h"
#include "mailcln.h"
#include "smem.h"
#include "main.h"
#include "threads.h"

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <errno.h>	//Z0011, LT

#define DEBUG_1

int __debug=0;
int __ncurr=1;

char ver[]="3.1.0";
char datReal[]="2004.07.09";

extern  char **environ;

CDlgMain UpsDlg;
static int end_process=0; //flaga zakonczenia procesow
int	Killing = 0;
int	ThreadCount = 0;
int	tickTimer = 0;

/////////////// semafory //////////////////////
int set_sem(void);
int del_sem(void);
int p_sem(void);
int v_sem(void);
int sem_id;

union semun {
	int val;
	struct semid_ds *buf;
	unsigned short *array;
};
/////////////////////////////
int p_sem(void)
{
return 1;

	struct sembuf b_sem;
	b_sem.sem_num=0;
	b_sem.sem_op=-1;
	b_sem.sem_flg=SEM_UNDO;
//printf("\n\r p_sem");
	if(semop(sem_id,&b_sem,1)==-1){
		perror("Error 1:");
		//getchar();
		return 0;
	}
	return 1;
}
///////////////////////////
int v_sem(void)
{
return 1;

	struct sembuf b_sem;
	b_sem.sem_num=0;
	b_sem.sem_op=1;
	b_sem.sem_flg=SEM_UNDO;
//printf("\n\r v_sem");
	if(semop(sem_id,&b_sem,1)==-1){
		perror("Error 2:");
		//getchar();
		return 0;
	}
	return 1;
}
////////////////////////
int set_sem(void)
{
	union semun u_sem;
	u_sem.val=1;
	if(semctl(sem_id,0,SETVAL,u_sem)==-1)
	{
		perror("Error 3:");
		//getchar();
		return 0;
	}
	return 1;
}
////////////////////////
int del_sem(void)
{
	union semun u_sem;
	u_sem.val=1;
	if(semctl(sem_id,0,IPC_RMID,u_sem)==-1)
	{
		perror("Error 3:");
		//getchar();
		return 0;
	}
	return 1;
}



///////////////////////////////////////////////




void sighandler(int); /* Signal handling function prototype */
int sendEmail(CUPSConfig *UPS);

void sighandler(int signo)
{
	if(__debug)
		printf("\n\rCaught signal %d \n\r",signo);
	//    fflush(stdout);
	//return;
	switch(signo)
	{
		case SIGHUP:
		case SIGTERM:
//			UpsDlg.Restart=1;
			Killing = 1;	//sygnalizuj pierwsz faz zamykania: akcje przed zamkn.
			break;
		case SIGCHLD:		//Z0008, LT - musze umozliwic poprawne zakonczenie procesu potomnego
			wait(NULL);
			break;
		case SIGUSR1:	//Z0012, LT
			UpsDlg.printStatus();
			break;
		default:
			exit(1);
	}
//	for(int i = 0; i < 100 && ThreadCount; i++)
//	{
//		delay(300);
//	}
}

//Z0012, LT - nowa funkcja do wypisywania statusu UPSw do pliku
void	CDlgMain::printStatus()
{
	const char *statusText[] = {
		STATUS_NORMAL_TEXT,
		STATUS_BAT_TEXT,
		STATUS_BAT_LOW_TEXT,
		STATUS_AVR_UP_TEXT,
		STATUS_AVR_DOWN_TEXT,
		STATUS_OFF_TEXT,
		STATUS_UPS_GOING_OFF_TEXT,
		STATUS_BYPASS_TEXT,
		STATUS_NO_COMMUNICATION_TEXT,
		"Brak",
		""
	};
	CString s = m_Cfg.m_pathCfg + UPS_STATUS_FILE;
	FILE *f = fopen(s, "w");
	if(f == NULL)
	{
		perror(UPS_STATUS_FILE);
		return;
	}
	fprintf(f, "--------------------------------------------------------\n");
	fprintf(f, "|              UPS Monitor Klient wersja %-10s    |\n",ver);
	fprintf(f, "--------------------------------------------------------\n");//\n\n");
	for(int i = 0; i <= SizeAllUps; i++)
	{
		CUPSConfig *u = &m_AllUPS[i];
		if(u->m_Status <= STATUS_GETTING_DATA)
		{
			fprintf(f, "--- UPS %d \"%s\" ---\n", i+1, u->m_Location);
			if(u->m_UPSStatus != UPS_JOINT_ACTIVE && u->m_Status != STATUS_NO_COMMUNICATION)	//tylko szeregowe
			{
				fprintf(f, "Producent:              %s\n", u->m_Manufacturer);
				fprintf(f, "Model                   %s wersja %s\n", u->m_Model, u->m_SoftVer);
				if(u->m_UPSStatus == UPS_BCHARGER_FAULT)
					fprintf(f, ">>> AWARIA ADOWARKI <<<\n");
				if(u->m_UPSStatus == UPS_BATTERY_FAULT)
					fprintf(f, ">>> BATERIE NIESPRAWNE <<<\n");
			}
			fprintf(f, "Stan pracy:             %s\n", statusText[u->m_Status]);
			if(u->m_UPSStatus != UPS_JOINT_ACTIVE && u->m_Status != STATUS_NO_COMMUNICATION)	//tylko szeregowe
			{
				fprintf(f, "Napicie zasilania:     %.1fV\n", u->m_InVol/10.0);
				fprintf(f, "Napicie akumulatorw:  %.1fV\n", u->m_BatVol/10.0);
				fprintf(f, "Prd wyjciowy:         %.1fA\n", u->m_OutCurrent/10.0);
				fprintf(f, "Moc wyjciowa:          %luW\n", u->m_OutPower);
				fprintf(f, "Napicie wyjciowe:     %.1fV\n", u->m_OutVol/10.0);
				if(u->m_UPSShutdownTime < 0 && u->m_SecToClose < 0)
					fprintf(f, "Czas pracy:             %s\n", STR_VAL_NOT_APPLY);
				else
				{
					long t = u->m_SecToClose;
					if(t < 0)
						t = u->m_UPSShutdownTime;
					fprintf(f, "Czas pracy:             %02d:%02d:%02d\n",
						(UINT)(t/3600), (UINT)((t%3600)/60), (UINT)(t%60));
				}
				char *batst[] = { ODCZYT_SB_TEXT0, ODCZYT_SB_TEXT1, ODCZYT_SB_TEXT2};
				fprintf(f, "Kondycja baterii:       %s\n", u->m_BatCondition < 3 ? batst[(UINT)u->m_BatCondition]: "???");
			}
			fprintf(f, "\n");
		}
	}
	fclose(f);
}
//Z0012, LT - koniec

//////////////////////////
time_t CDlgMain::m_clock()
{
	time_t t1;
	static time_t tm_s;
	static time_t t_start=0;

	time(&t1);
	if(t_start==0)
	{
		t_start=1;
		time(&tm_s);
		return 0;
	}
	else
		return t1-tm_s;
}

void CDlgMain::initNCurses(void)
{

#ifdef NCURRSESS
	initscr();
	cbreak();
	nonl();
	intrflush(stdscr, FALSE);
	start_color();

	 init_pair(1,COLOR_WHITE,COLOR_BLUE);
	 init_pair(2,COLOR_BLUE,COLOR_WHITE);
	 init_pair(3,COLOR_RED,COLOR_WHITE);
	 init_pair(4,COLOR_BLUE,COLOR_WHITE);
	 init_pair(5,COLOR_MAGENTA,COLOR_WHITE);
	 init_pair(6,COLOR_BLACK,COLOR_WHITE);

	 curs_set(0);
	 noecho();
	keypad(stdscr, TRUE);
#endif
}


void CDlgMain::removeSpace(char *t)
{
char *tmp;
tmp=new char[strlen(t)+2];//nowy
	memset(tmp,0,strlen(t)+2);
	int j=0;
	for(int i=0; t[i];i++){
		if(t[i]!=' ' && t[i]!='\n' && t[i]!='\r' ){
			if(t[i]=='\n' || t[i]=='\r'){
				tmp[j]=0;
				break;
			}else{
				tmp[j++]=t[i];
				tmp[j]=0;
			}
		}
	}
	//printf(" 1=-%s-\n",t);
	memset(t,0,strlen(t));
	strcpy(t,tmp);
	//printf(" 2=-%s-\n",tmp);
delete tmp;
}

void CDlgMain::removeEndWhite(char *t)
{
//char *tmp;

//	int j=0;
	int len=strlen(t);
	for(int i=len;i>0;i--){
		if(t[i]=='\n' || t[i]=='\r'){
			t[i]=0; //odcinam eneter na koncu
			break;
		}
	}
}

void CDlgMain::showList(int idx)
{

if(__ncurr){

}else{

#ifdef NCURRSESS
	wbkgd(list,COLOR_PAIR(2));
	wattron(list,COLOR_PAIR(3));
	wmove(list,1,1);
	wprintw(list," ......  Lista Ups-w  ....... ");
	wattroff(list,COLOR_PAIR(3));

	for(int i=0;i<10;i++){

		//getchar();
		//(list);
		wmove(list,2+i,1);
		char nr[10];
		sprintf(nr,"%d",i);
		if(i<(SizeAllUps-1)){
			if(strlen(m_AllUPS[i].m_IP)>0){
				if(idx==i){
					if(strlen(m_AllUPS[i].m_Location)>0){
						wattron(list,COLOR_PAIR(3));
						wprintw(list," %2s >%-15s +         ",nr,m_AllUPS[i].m_IP);
						wattroff(list,COLOR_PAIR(3));
					}
					else
						wprintw(list," %2s >%-15s -         ",nr,m_AllUPS[i].m_IP);
			}
			else{
				if(strlen(m_AllUPS[i].m_Location)>0)
					wprintw(list," %2s  %-15s +        ",nr,m_AllUPS[i].m_IP);
				else
					wprintw(list," %2s  %-15s -        ",nr,m_AllUPS[i].m_IP);
			}
		}
		else
			wprintw(list," %2s- %-15s    ",nr,"........................");
		}
	}
	box(list,ACS_VLINE,ACS_HLINE);
	wrefresh(list);
#endif
}	//ncurr
}

void CDlgMain::showParam(int idx)
{

}



void CDlgMain::initUpsPanel(int idx)
{
//int i;


if(__ncurr){
		//printf("\n\n\n UPS Monityor 3.0                              \n\n\n");
	}else{
#ifdef NCURRSESS
	//       LINE_Y LINE_X  Y   X
	win=subwin(stdscr,30,80,0,0);
	wbkgd(win,COLOR_PAIR(2));
	box(win,ACS_VLINE,ACS_HLINE);
	wmove(win,0,15);

	wprintw(win," UPS Monitor 3.0 %s ",ver);
	wrefresh(win);

	icon=subwin(stdscr,4,75,25,2);

	wmove(win,29,45);
	wprintw(win," Fideltronik Krakw %s ",datReal);
	wrefresh(win);


	//getchar();
	//werase(win);
	//       LINE_Y LINE_X  Y   X
#define LINE_Y_LIST 15
#define LINE_X_LIST 32
#define Y_LIST		2
#define X_LIST		45

	list=subwin(stdscr,LINE_Y_LIST,LINE_X_LIST,Y_LIST,X_LIST);
	wbkgd(list,COLOR_PAIR(1));
	showList(idx);

#define LINE_Y_T 6
#define LINE_X_T 32
#define Y_T		 18
#define X_T		 45
	ti=subwin(stdscr,LINE_Y_T,LINE_X_T,Y_T,X_T);
	wbkgd(ti,COLOR_PAIR(1));
	wmove(ti,2,4);
	wprintw(ti," Debug ");
	box(ti,ACS_VLINE,ACS_HLINE);
	wrefresh(ti);


#define LINE_Y_STAT 22
#define LINE_X_STAT 40
#define Y_STAT		2
#define X_STAT		2

	//       LINE_Y LINE_X  Y   X
	params=subwin(stdscr,LINE_Y_STAT,LINE_X_STAT,Y_STAT,X_STAT);
#endif
}//ncur

}


/////////////////////////////////////////////////////////////////////////////
//void CDlgMain::SetCurrEvent(CUPSConfig *UPS, char CurrEvent)
void CDlgMain::SetCurrEvent(CUPSConfig *UPS, int CurrEvent)
{
	UPS->m_CurrEvent=CurrEvent;


	if(CurrEvent==-1)
	{
		UPS->m_LogDone=1;
		UPS->m_WarningDone=1;
		UPS->m_RunDone=1;
		UPS->m_SendMailDone=1;
		UPS->m_CloseSystemDone=1;
//printf("2--\n");
	}
	else
	{
		UPS->m_EventTime=m_clock();
		UPS->m_LogDone=(UPS->m_Events[UPS->m_CurrEvent].m_WriteToLog==0);
		UPS->m_WarningDone=(UPS->m_Events[UPS->m_CurrEvent].m_Warning==0);
		UPS->m_RunDone=(UPS->m_Events[UPS->m_CurrEvent].m_Run==0);
		UPS->m_SendMailDone=(UPS->m_Events[UPS->m_CurrEvent].m_SendMail==0);
		UPS->m_CloseSystemDone=(UPS->m_Events[UPS->m_CurrEvent].m_CloseSystem==0);
		if(UPS->m_WarningDone==0)
			UPS->m_WarningShowTime=UPS->m_EventTime+(UPS->m_Events[UPS->m_CurrEvent].m_WarningFirstDelay)/**CLOCKS_PER_SEC*/;
		if(UPS->m_CloseSystemDone==0)
		{
			UPS->m_SecToClose=UPS->m_Events[UPS->m_CurrEvent].m_CloseSystemDelay-(m_clock()-UPS->m_EventTime)/*/CLOCKS_PER_SEC*/;
			if(UPS->m_SecToClose<0)
				UPS->m_SecToClose=0;
		}
		else
			UPS->m_SecToClose=VAL_NOT_APPLY;
	}



} // CDlgMain::SetCurrEvent

/////////////////////////////////////////////////////////////////////////////
//BOOL CDlgMain::ChangeStatus(CUPSConfig *UPS, BYTE NewStatus)
bool CDlgMain::ChangeStatus(CUPSConfig *UPS, BYTE NewStatus)
{
	if(UPS->m_Status==NewStatus || NewStatus > STATUS_GETTING_DATA)
		return FALSE; // status nie zmienil sie

	if(NewStatus==STATUS_NORMAL)
	{
		if(UPS->m_Status!=STATUS_GETTING_DATA && UPS->m_Status!=STATUS_OFF)
		{
			// zmienil sie status wiec chowamy stare okno z ostrzezeniem
			//if(UPS->m_WarningWindow) UPS->m_WarningWindow->DestroyWindow();
			SetCurrEvent(UPS,EVENT_NORMAL);
		}
		UPS->m_Status=NewStatus;
		return TRUE; // status zmienil sie
	}

	if(NewStatus==STATUS_OFF)
	{
		// zmienil sie status wiec chowamy stare okno z ostrzezeniem
		//if(UPS->m_WarningWindow) UPS->m_WarningWindow->DestroyWindow();
		SetCurrEvent(UPS,-1);
		UPS->m_Status=NewStatus;
		return TRUE; // status zmienil sie
	}

	int currEvent;
	if(NewStatus==STATUS_UPS_GOING_OFF)
		currEvent=EVENT_UPS_GOING_OFF;
	else if(NewStatus==STATUS_AVR_UP || NewStatus==STATUS_AVR_DOWN)
		currEvent=EVENT_AVR_START;
	else if(NewStatus==STATUS_BYPASS)
		currEvent=EVENT_BYPASS;
	else if(NewStatus==STATUS_BAT)
		currEvent=EVENT_BAT;
	else if(NewStatus==STATUS_BAT_LOW)
		currEvent=EVENT_BAT_LOW;
	else // NewStatus==STATUS_NO_COMMUNICATION
	{
		if(UPS->m_Status==STATUS_BAT || UPS->m_Status==STATUS_BAT_LOW)
			currEvent=EVENT_NO_COMM_BAT;
		else
			currEvent=EVENT_NO_COMMUNICATION;
	}
	// zmienil sie status wiec chowamy stare okno z ostrzezeniem
	//if(UPS->m_WarningWindow) UPS->m_WarningWindow->DestroyWindow();
	SetCurrEvent(UPS,currEvent);
	UPS->m_Status=NewStatus;
	return TRUE; // status zmienil sie

} // CDlgMain::ChangeStatus

/////////////////////////////////////////////////////////////////////////////
BOOL CDlgMain::AnalizeDoTaskPacket(BYTE *Buff, int Len, CUPSConfig *UPS, int Idx)
{
	BYTE type=(Buff[0]&UDP_MASK_PACKET_TYPE);

	if(__debug)
		printf("Analiza doTaskPac len=%d type=%d=%d czas=%d\n",Len,type,UDP_PACKET_DO_TASK,(int)m_clock());
	if(type==UDP_PACKET_DO_TASK)
	{
		if(Len!=4) return FALSE; // bledny pakiet
		// wyznaczamy kolejne do wykonania zadanie z terminarza
		m_TaskInProgress=FALSE;
		SelectFirstTask();
	}
	else return FALSE; // nieznany pakiet (ta sytuacja nie powinna wystapic)
	return TRUE;
} // CDlgMain::AnalizeDoTaskPacket


/////////////////////////////////////////////////////////////////////////////
void CDlgMain::CheckLocalUPS(BOOL FirstCheck)
{
	BOOL oldIsLocalUPS=m_IsLocalUPS;
	// sprawdzamy czy na liscie monitorowanych zasilaczy znajduje sie lokalny UPS


	m_IsLocalUPS=FALSE;
	for(int i=SizeAllUps; i>=0; i--)
	{
		if(m_AllUPS[i].m_IsLocal)
		{
			if(__debug)
				printf("  It is Local UPS %s\n",m_AllUPS[i].m_IP);
			m_IsLocalUPS=TRUE;
			break;
		}
	}
	// jezeli nie ma lokalnego UPSa to kasujemy liste zadan
	if(!m_IsLocalUPS)
	{
		//for(i=m_Tasks.GetSize()-1;i>=0;i--)
			// delete m_Tasks[i];
		//m_Tasks.RemoveAll();
	}

	// jezeli jest to pierwsze wywolanie funkcji, lub zmienil sie
	// stan m_IsLocalUPS, to trzeba uaktualnic zmienna m_TaskType
	// oraz uaktualnic menu
	if(FirstCheck || (m_IsLocalUPS!=oldIsLocalUPS))
	{
		SelectFirstTask();
		SetupMenu();
	}
} // CDlgMain::CheckLocalUPS


/////////////////////////////////////////////////////////////////////////////
void CDlgMain::ReadUPSModelsConfig()
{
FILE *f;
CString man, mod, txt;
char buff_txt[200];
int bat, curr, power, level=0;      // czytamy zawartosc pliku

//Z0005, LT - sciezka nie jest stala, tylko czytana z pliku
//	if ((f = fopen(UPSMONC_MODELS_FILE, "r")) == NULL)
	CString s = m_Cfg.m_pathCfg + UPSMONC_MODELS_FILE;
	if ((f = fopen(s.str(), "r")) == NULL)
	{
//		printf("- Blad otwarcia pliku %s\n",UPSMONC_MODELS_FILE);
//		perror("Error open cfg file :");
		perror(UPSMONC_MODELS_FILE);
		return;
	}
	int idx=0;
	UpsDlg.m_UPSModelsIdx=0;
	while(fgets(buff_txt,sizeof(buff_txt),f) != NULL)
	{/* search until EOF */
		buff_txt[strlen(buff_txt)-1]=0;	//bez enetr
		txt=buff_txt;
		//printf("Odczyt -%s-\n",(char *)txt);
		txt.TrimLeft();
		//printf("Odczyt1 -%s-\n",(char *)txt);
		txt.TrimRight();
		//printf("Odczyt2 -%s-\n",(char *)txt);
		if(txt.IsEmpty())
		{
			level=0;  // pusta linie traktujemy jak separator i zaczynamy od nowa
			continue;
		}
		if(level==0)
			man=txt;
		else if(level==1)
			mod=txt;
		else if(level==2)
			bat=atoi(txt);
		else if(level==3)
			curr=atoi(txt);
		else
			power=atoi(txt);
		level++;
		if(level==5)
		{
			m_UPSModels[idx].m_Manufacturer=man;
			m_UPSModels[idx].m_Manufacturer.MakeUpper();
			m_UPSModels[idx].m_Model=mod;
			m_UPSModels[idx].m_Model.MakeUpper();
			m_UPSModels[idx].m_MaxBatVol=bat;
			m_UPSModels[idx].m_MaxCurrent=curr;
			m_UPSModels[idx].m_MaxPower=power;
			UpsDlg.m_UPSModelsIdx++;
			idx++;
			level=0; // zaczynamy od nowa
		}
		memset(buff_txt,0,sizeof(buff_txt));
	}
	fclose(f);
} // CDlgMain::ReadUPSModelsConfig

//////////////////////////////////
void CDlgMain::SetupMenu()
{
}

//////////////////////////////////
time_t CDlgMain::GetCurrentTime()
{
	time_t t2;

	time(&t2);
	return t2; //ilosc sekund
}

/////////////////////////////////////////////////////////////////////////////
void CDlgMain::SelectFirstTask()
{
//printf("Select TaskInProgres %d\n",m_TaskInProgress);

	if(m_TaskInProgress)
		return;   // gdy zadanie jest wykonywane to nic nie robimy
	if(!m_IsLocalUPS || (m_TasksGetSize==0))
	{
		m_TaskType=TASK_NONE;   // gdy nie ma lokalnego UPSa, lub lista zadan jest
		return;                 // pusta, to nic nie nalezy robic
	}

	time_t now;
	now=GetCurrentTime(); //ilosc sekund
	time_t taskDate;

	// m_Tasks zawiera przynajmniej jeden element, wiec
	// mozemy odwolywac sie do elementu o indeksie 0

	if(GetTaskDate(&m_Tasks[0],now,m_TaskDate))
	{

		m_TaskType=m_Tasks[0].m_Task;
		if(m_TaskType==TASK_RESTART)
			m_TaskTurnOnDelay=m_Tasks[0].m_TurnOnDelay;
		if(__debug)
		{
			time_t tt=m_TaskDate;
			printf("task[0] typ=%d data=%s ",(int)now,ctime(&tt));
		}
	}
	else
		m_TaskType=TASK_NONE; //dananie przedawnione
	time_t t1,t2;
	t1=now;
	t2=m_TaskDate;
	//printf("Pierwsze \n now=%s task=%s ",ctime(&t1),ctime(&t2));   	//zadanie na przyszlosc
	//printf("pierwsze przedawnione dif=%d\n",now-m_TaskDate);
	// sprawdzamy pozostale zdarzenia
	for(int i=1; i<m_TasksGetSize; i++)
	{
		if(!GetTaskDate(&m_Tasks[i],now,taskDate))
			continue;
		//printf("kolejne i=%d Ilosc=%d \n",i,m_TasksGetSize);
		//printf("taskDate=%d m_TaskDate typ=%d NONE=%d\n",taskDate,m_TaskDate,m_TaskType,TASK_NONE);
		if((taskDate<m_TaskDate) || (m_TaskType==TASK_NONE))
		{
			if(__debug)
			{
				time_t t=taskDate;
				printf("TASK[n=%d] %s  typ=%d delay=%ld\n",i,ctime(&t),m_Tasks[i].m_Task,m_Tasks[i].m_TurnOnDelay);
			}
			m_TaskDate=taskDate;
			m_TaskType=m_Tasks[i].m_Task;
			if(m_TaskType==TASK_RESTART)
				m_TaskTurnOnDelay=m_Tasks[i].m_TurnOnDelay;
		}
	}
} // CDlgMain::SelectFirstTask

/////////////////////////////////////////////////////////////////////////////
void CDlgMain::DoTask()
{
	//if(__debug)
	///	printf("TaskInProg %d\n",m_TaskInProgress);
	if(m_TaskInProgress)
		return; // gdy zadanie jest wykonywane to nic nie robimy
	if(m_TaskType==TASK_NONE)
		return; // gdy nie mamy nic zrobic to koniec
	if(__debug)
	{
		time_t tt;
		tt=GetCurrentTime();
		printf("DoTask roz=%ld task_d=%s \n",GetCurrentTime()-m_TaskDate,ctime(&m_TaskDate));
		//printf("DoTask curr_t=%s curr_t=%d task_t=%d \n",ctime(&tt),tt,m_TaskDate);
	}

	if(GetCurrentTime()<m_TaskDate)
		return; // za wczesnie na wykonanie zadania

	// szukamy lokalnego UPSa i jak znajdziemy to przygotowujemy pakiet do wyslania

//	for(int i=UpsDlg.GetSize()-1; i>=0; i--){
	for(int i=UpsDlg.GetSize(); i>=0; i--)
	{
		if(m_AllUPS[i].m_IsLocal)
		{
			// przygotowujemy dane pakietu
			m_AllUPS[i].m_DoTaskPacketOutBuff[0]=m_TaskType;
			u_long ul=htonl((u_long)m_TaskTurnOnDelay);
			//memcpy(m_AllUPS[i].m_DoTaskPacketOutBuff+1,&ul,4);
		 // 2003.01.13, MW, do bufora wpisywana jest dodatkowo flaga, czy zamykac system
		 //	UWAGA: zostanie wpisana flaga taka, jaka jest ustawiona aktualnie, a nie
		 // taka, jak byla w momencie wpisywania zdarzenia do terminarza. Ale podczas
		 // dodawania zadania nie bardzo jest jak to zrobic, bo nie widac konfiguracji
		 // UPS-a lokalnego, a dopisywanie ich potem w fumcji OnKonfiguracjaTerminarz
		 // tez nie jest super. Trudno powiedziec, ktora opcja jest lepsza. Wybrana jest
		 // latwiejsza w implementacji.
			//memcpy(m_AllUPS[i]->m_DoTaskPacketOutBuff+1,&ul,4);
			 m_AllUPS[i].m_DoTaskPacketOutBuff[1] = GetLocalUPSCloseSysFlag();
			 memcpy(m_AllUPS[i].m_DoTaskPacketOutBuff+2,&ul,4);
			//if(__debug)
			//printf("l=%02X %02X,%02X,%02X,[5]=%02X\n",m_AllUPS[i].m_DoTaskPacketOutBuff[1],m_AllUPS[i].m_DoTaskPacketOutBuff[2],m_AllUPS[i].m_DoTaskPacketOutBuff[3],m_AllUPS[i].m_DoTaskPacketOutBuff[4],m_AllUPS[i].m_DoTaskPacketOutBuff[5]);
			// zaznaczamy ze nalezy wyslac pakiet (bedzie on wyslany w funkcji OnTimer())
			// zaznaczamy ze nalezy wyslac pakiet (bedzie on wyslany w funkcji OnTimer())
			m_AllUPS[i].m_DoTaskPacketOut=UDP_PACKET_DO_TASK;
			m_AllUPS[i].m_DoTaskPacketOutNum=0;
			// zaznaczamy ze trwa wykonywanie zadania z terminarza
			m_TaskInProgress=TRUE;
		}
	}
} // CDlgMain::DoTaskBOOL CDlgMain::GetTaskDate(/*CTaskConfig *Task, COleDateTime &Now,COleDateTime &TaskDate*/)

/////////////////////////////////////////////////////////////////////////////
BOOL CDlgMain::GetTaskDate(CTaskConfig *Task, time_t &Now, time_t &TaskDate)
{
	//time_t t1,t2;
	time_t t2;
	//t1=Now;
	//t2=Task->m_DateTime;
	//printf("--------------GetTaskDate\n Now=%d %d,roznica=%d \n",Now,Task->m_DateTime,(Now-Task->m_DateTime));
	//printf("Now=%s",ctime(&t1));
	//printf("task=%s",ctime(&t2));

	if(Task->m_Period==PERIOD_ONCE)
		if(Task->m_DateTime<Now)
	{
		if(__debug)
		{
			t2=Task->m_DateTime;
			if(__debug)
				printf("Zapozno ONCE %s\n",ctime(&t2));
		}
		return FALSE; // to zdarzenie jest juz za stare
	}

	// bez wzgledu na okres zadania, jezel data jest przyszla
	// to zwracamy ja jako date zadania
	if(Task->m_DateTime>=Now)
	{
		TaskDate=Task->m_DateTime;
		if(__debug)
		{
			t2=Task->m_DateTime;
			printf(" ONCE %s\n",ctime(&t2));
		}
		return TRUE;
	}

	time_t time_local;
	time(&time_local);//czas lokalny
//printf("Czas lokalny %d\n",time_local);

	tm ti_task,*t;
	t=0;
//printf("T=%d\n",t);
	t=localtime(&time_local);
//printf("T=%d\n",t);
	//printf("Czas lokalny %d.%d.%d %d:%d:%d \n",t->tm_year,t->tm_mon,t->tm_mday,t->tm_hour,t->tm_min,t->tm_sec);

	ti_task.tm_year=t->tm_year;
	ti_task.tm_year+=1900;
	ti_task.tm_mon=t->tm_mon;
		//ti_task.tm_mon+=1;
	ti_task.tm_mday=t->tm_mday;
	time_t tt=Task->m_DateTime;
	t=localtime(&tt);
//printf("Czas Zadania %d.%d.%d %d:%d:%d \n",t->tm_year,t->tm_mon,t->tm_mday,t->tm_hour,t->tm_min,t->tm_sec);
	ti_task.tm_hour=t->tm_hour;
	ti_task.tm_min=t->tm_min;
	ti_task.tm_sec=0;
//printf("Czas Zadania %d.%d.%d %d:%d:%d \n",ti_task.tm_year,ti_task.tm_mon,ti_task.tm_mday,ti_task.tm_hour,ti_task.tm_min,ti_task.tm_sec);
	ti_task.tm_year-=1900;
	//ti_task.tm_mon-=1;
	time_t res=mktime(&ti_task);
	if(res==-1)
		perror(" mktime :");
//printf("Czas zadania %d %s\n"   ,res,ctime(&res));
	TaskDate=res;

	if(Task->m_Period==PERIOD_DAILY)
	{
		if(TaskDate<Now)
			TaskDate+=24*60*60; //+dzien
		if(__debug)
		{
			t2=TaskDate;
			printf("DAILY na  %s\n",ctime(&t2));
		}
		return TRUE;
	}

	if(TaskDate<Now)
		TaskDate+=24*60*60*7; //+tydzien
	if(__debug)
	{
		t2=TaskDate;
		printf("Weakle na  %s\n",ctime(&t2));
	}

	return TRUE;
} // CDlgMain::GetTaskDate

//////////////////////
//
//
//
int CDlgMain::AnalizeNormalPacket(BYTE *Buff, int Len, CUPSConfig *UPS, int Idx)
{
	BYTE type=(Buff[0]&UDP_MASK_PACKET_TYPE);

	if(type==UDP_PACKET_CONNECT)
	{
		if(Len!=MAX_LOC_LEN+6)
			return FALSE; // bledny pakiet
		char loc[MAX_LOC_LEN+1]={0};
		memcpy(loc,Buff+2,MAX_LOC_LEN);
		loc[MAX_LOC_LEN]=0;
		strcpy(UPS->m_Location,(const char *)loc);

		UPS->m_CanAutostart=Buff[MAX_LOC_LEN+2];
		UPS->m_CanTurnOff=Buff[MAX_LOC_LEN+3];
		//UPS->m_CanBeRestarted=Buff[MAX_LOC_LEN+2]; // ATR
		//UPS->m_CanShutDown=(BYTE)(Buff[MAX_LOC_LEN+3]>0 && Buff[MAX_LOC_LEN+4]>0); // SDA>0 i PSD>0
		//FillActiveUPSList();
		//m_UPSList.UpdateAll();
	}
	else if(type==UDP_PACKET_GET_STATIC_DATA)
	{
		if(Len!=LEN_MAN+LEN_MODEL+LEN_SOFT_VER+7)
			return FALSE; // bledny pakiet
		if(Buff[2])
		{
			char man[LEN_MAN+1]={0};
			memset(man,0,sizeof(man));
			memcpy(man,Buff+3,LEN_MAN);
			man[LEN_MAN]=0;
			if(__debug)
				printf("  Manu -%s-\n",man);
			strcpy(UPS->m_Manufacturer,(const char *)man);
		}
		else
		 //UPS->m_Manufacturer=STR_VAL_UNAVAILABLE;
		 	strcpy(UPS->m_Manufacturer,STR_VAL_UNAVAILABLE);
		if(Buff[LEN_MAN+3])
		{
			char model[LEN_MODEL]={0};
			memcpy(model,Buff+LEN_MAN+4,LEN_MODEL);
			model[LEN_MODEL]=0;
			strcpy(UPS->m_Model,model);

		}
		else
			strcpy(UPS->m_Model,STR_VAL_UNAVAILABLE);

		if(Buff[LEN_MAN+LEN_MODEL+4])
		{
			char softVer[LEN_SOFT_VER+1]={0};
			memcpy(softVer,Buff+LEN_MAN+LEN_MODEL+5,LEN_SOFT_VER);
			strcpy(UPS->m_SoftVer,softVer);
		}
		else
			strcpy(UPS->m_SoftVer,STR_VAL_UNAVAILABLE);
	}
	else if(type==UDP_PACKET_GET_DYNAMIC_DATA)
	{
		//      if(Len!=25)
		if(Len!=31)		// 25(stare) + m_BatAutonomy(4) i m_UPSStatus(2) (2003.01.02, MW)
			return FALSE; // bledny pakiet
		memcpy(&UPS->m_BatStatus,Buff+2,1);
		u_short us;
		memcpy(&us,Buff+3,2);
		UPS->m_BatVol=(short)ntohs(us);
		memcpy(&us,Buff+5,2);
		UPS->m_InVol=(short)ntohs(us);
		memcpy(&us,Buff+7,2);
		UPS->m_OutCurrent=(short)ntohs(us);
		memcpy(&us,Buff+9,2);
		UPS->m_OutLoad=(short)ntohs(us);
		u_long ul;
		memcpy(&ul,Buff+11,4);
		UPS->m_OutPower=(long)ntohl(ul);
		memcpy(&UPS->m_OutSource,Buff+15,1);
		memcpy(&us,Buff+16,2);
		UPS->m_OutVol=(short)ntohs(us);
		memcpy(&UPS->m_BatCondition,Buff+18,1);
		memcpy(&ul,Buff+19,4);
		UPS->m_UPSShutdownTime=(long)ntohl(ul);

//	Dodanie odczytu zmiennych m_BatAutonomy i m_UPSStatus	(2003.01.02, MW)
		memcpy(&ul, Buff+23, 4);
		UPS->m_BatAutonomy = (long)ntohl(ul);
		memcpy(&us, Buff+27, 2);
		UPS->m_UPSStatus = (short)ntohs(us);
		// koniec zmian (2003.01.02, MW)
	  // okreslamy aktualny status

		// okreslamy aktualny status
		BYTE status;
		if(UPS->m_UPSDoShutdown==0 && UPS->m_UPSShutdownTime>=0)
			status=STATUS_UPS_GOING_OFF;
		else if(UPS->m_OutSource==-1 || UPS->m_BatStatus==-1)
		{
			status=STATUS_NO_COMMUNICATION;
//printf("NO communictioon %d\n",Idx); //tylko jak batery -1
			UPS->InitData();
		}
		else if(UPS->m_OutSource==0)
			status=STATUS_NORMAL;
		else if(UPS->m_OutSource==2)
			status=STATUS_BYPASS;
		else if(UPS->m_OutSource==3)
			status=STATUS_AVR_UP;
		else if(UPS->m_OutSource==4)
			status=STATUS_AVR_DOWN;
		else if(UPS->m_OutSource==5)
			status=STATUS_OFF;
		else if(UPS->m_OutSource==1)
		{
			if(UPS->m_BatStatus>0)
				status=STATUS_BAT_LOW;
			else
				status=STATUS_BAT;
		}
//		else	//tymcz
//		{
//			char s[100];
//			sprintf(s, "Tu nie powinien wej!!! source %d, Sh %d, ShTime %d, BatSt %d\n",
//				(int)UPS->m_OutSource, (int)UPS->m_UPSDoShutdown,
//				(int)UPS->m_UPSShutdownTime, (int)UPS->m_BatStatus);
//			printf(s);
//			m_Log.Add(NULL, 0, s);
//			sleep(10);
//		}

		BOOL changed=ChangeStatus(UPS,status);
//printf("Odswierzam c=%d stat=%d\n",changed,status);
		//if(m_Cfg.m_CurrUPS==Idx)
		UpdateScreen(UPS,Idx,changed);
		if(changed)
		{
			if(DoAction(UPS,Idx) < 0)
				return -1;		//bd fatalny!
		}
	}
	else
		return FALSE; // nieznany pakiet (ta sytuacja nie powinna wystapic)
  // UpdateScreen(UPS,Idx,1);
	return TRUE;
} // CDlgMain::AnalizeNormalPacket


/////////////////////////////////////////////////////////////////////////////
int CDlgMain::AnalizeTurnOffPacket(BYTE *Buff, int Len, CUPSConfig *UPS, int Idx)
{
	BYTE type=(Buff[0]&UDP_MASK_PACKET_TYPE);

	if(type==UDP_PACKET_UPS_OFF)
	{
		if(Len!=4)
		    return FALSE; // bledny pakiet
		// ten pakiet wysylany jest tylko w trakcie rozpoczynania zamkniecia
		// systemu, zatem teraz nalezy dokonczyc zamkniecie systemu
		//printf("Pakiet ZAMNIJ SYTEM %d \n",UPS->m_CloseSystemMode);
		if(CloseSystem(UPS->m_CloseSystemMode) < 0)
			return -1;		//bd fatalny!
	}
	else
		return FALSE; // nieznany pakiet (ta sytuacja nie powinna wystapic)
	return TRUE;
} // CDlgMain::AnalizeTurnOffPacket

/////////////////////////////////////////////////////////////////////////////
int CDlgMain::CloseSystem(BYTE Force)
{
	if(__debug)
		printf("Close system\n");

	static BOOL wasClose=FALSE;
	if(wasClose)
		return 1; // zabezpieczenie przed podwojnym wykonaniem
	wasClose=TRUE;

	// przed zamknieciem systemu wykonujemy akcje EVENT_SYS_CLOSE
	// i wolamy StopUPSMon()poniewaz po ExitWindowsEx() nie zostanie
	// wywolane OnDestroy()
	for(int i=0; i<=SizeAllUps; i++)
	{
		SetCurrEvent(&m_AllUPS[i],EVENT_SYS_CLOSE);
		if(DoAction(&m_AllUPS[i],i) < 0)
			return -1;
	}
//	StopUPSMon();

	if(__debug)
		printf("----------------- BEZ ZAMYKANIA ------------\n");
//   sleep(10);
//   exit(0);

	if(__debug==0)
	{
// 2003.02.04
// pelna sciazka do scryptu
//
		//Z0009, LT - niewlasciwa sciezka do skryptu
//		int res=system("/etc/ups/scripts/shutdown.sh");
		//Z0016, LT - hibernacje uzyskuje sie podajac mode 2 w opcjach zamykania w ups.cfg
		//reszte robi skrypt w zaleznosci od konkretnej maszyny
		char *mode[] = { " normal", " forced", " hibernate", " reserved3", " reserved4" };
		CString s = m_Cfg.m_pathBinary + UPS_SHUTDOWN_SCRIPT;
		if(Force <= 4)
			s += mode[Force];
		//Z0016, LT - koniec
		int res=system(s.str());
		//Z0009, LT - koniec
		if(res==-1)
			perror("ShutDown");
	}
//	m_Log.Add(NULL, 0, "CloseSystem");
	exit(0);
	return 1;
} // CDlgMain::CloseSystem


///*
///////////////
//BOOL CDlgMain::Add(CUPSConfig *UPS, BYTE Color, LPCTSTR Str)
//{
//	return m_Log.Add(UPS,Color,Str);
//}
//*/

/////////////////////////////////////////////////////////////////////////////
//
//
char	text[300];

int CDlgMain::DoAction(CUPSConfig *UPS, int Idx)
{
	if(UPS->m_CurrEvent==-1)
		return 1; // brak akcji do wykonania

	if(UPS->m_LogDone==1 && UPS->m_WarningDone==1 && UPS->m_RunDone==1
		&& UPS->m_SendMailDone==1 && UPS->m_CloseSystemDone==1)
	{
		SetCurrEvent(UPS,-1); // wykonano juz wszystko
		//printf("Wykonano \n");
		return 1;
	}
//if(__debug)
//	printf("Zdarzenie[Idx=%d] l=%d w=%d r=%d m=%d c=%d\n",Idx,UPS->m_LogDone,UPS->m_WarningDone,UPS->m_RunDone,UPS->m_SendMailDone,UPS->m_CloseSystemDone);

	if(UPS->m_LogDone==0)
	{
		char msg[255];
		BYTE color=UPS->m_Status;
		if(UPS->m_CurrEvent==EVENT_NORMAL)
			strcpy(msg,LOG_EVENT_NORMAL);
		else if(UPS->m_CurrEvent==EVENT_BAT)
			strcpy(msg,LOG_EVENT_BAT);
		else if(UPS->m_CurrEvent==EVENT_BAT_LOW)
			strcpy(msg,LOG_EVENT_BAT_LOW);
		else if(UPS->m_CurrEvent==EVENT_SYS_CLOSE)
		{
			strcpy(msg,LOG_EVENT_SYS_CLOSE);
			color=STATUS_GETTING_DATA;
		}
		else if(UPS->m_CurrEvent==EVENT_NO_COMMUNICATION)
			strcpy(msg,LOG_EVENT_NO_COMMUNICATION);
		else if(UPS->m_CurrEvent==EVENT_PRG_START)
		{
			strcpy(msg,LOG_EVENT_PRG_START);
			color=STATUS_GETTING_DATA;
		}
		else if(UPS->m_CurrEvent==EVENT_PRG_STOP)
		{
			strcpy(msg,LOG_EVENT_PRG_STOP);
			color=STATUS_GETTING_DATA;
		}
		else if(UPS->m_CurrEvent==EVENT_NO_COMM_BAT)
			strcpy(msg,LOG_EVENT_NO_COMM_BAT);
		else if(UPS->m_CurrEvent==EVENT_AVR_START)
			strcpy(msg,LOG_EVENT_AVR_START);
		else if(UPS->m_CurrEvent==EVENT_BYPASS)
			strcpy(msg,LOG_EVENT_BYPASS);
		else /* UPS->m_CurrEvent==EVENT_UPS_GOING_OFF */
		//else if(UPS->m_CurrEvent==EVENT_NO_COMM_BAT) strcpy(msg,LOG_EVENT_NO_COMM_BAT);
		//else if(UPS->m_CurrEvent==EVENT_AVR_START) strcpy(msg,LOG_EVENT_AVR_START);
		//else /* UPS->m_CurrEvent==EVENT_AVR_STOP */ /*strcpy(msg,LOG_EVENT_AVR_STOP);*/
		{
			strcpy(msg,LOG_EVENT_UPS_GOING_OFF);
			color=STATUS_GETTING_DATA;
		}
		m_Log.Add(UPS,color,msg);
		UPS->m_LogDone=1;
	}

	if(UPS->m_WarningDone==0)
	{
		if(m_clock()>=UPS->m_WarningShowTime)
		{
			if(!UPS->m_Events[UPS->m_CurrEvent].m_WarningText.IsEmpty())
			{
				char 	*pwarn = UPS->m_Events[UPS->m_CurrEvent].m_WarningText;
				char	*ptext = text;
				strcpy(text, UPS->m_Events[UPS->m_CurrEvent].m_WarningText);
				while((pwarn = strstr(pwarn, "%")) != NULL)
				{
					ptext = strstr(ptext, "%");
					switch(pwarn[1])
					{
					case '%':
						sprintf(ptext, "%c%s", '%', pwarn+2);
						break;
					case 'd':
						if(UPS->m_SecToClose >= 0)
							sprintf(ptext, "%ld%s", UPS->m_SecToClose, pwarn+2);
						else
							sprintf(ptext, "---%s", pwarn+2);
						break;
					case 't':
					{
						  time_t time_e;
						  time_e = time(&time_e);
						sprintf(ptext, "%s%s", ctime(&time_e), pwarn+2);
						break;
					}
					case 's':
						sprintf(ptext, "%s%s", UPS->m_Location, pwarn+2);
						break;
					default:
						break;
					}
					pwarn++;	//eby nie szuka cigle w tym miejscu
					ptext++;
				}
////////////////////////////// watek
// musi byc watek
				int pid=fork();
				if(pid==0)
				{
//					int res=execlp("wall","wall",(char *)UPS->m_Events[UPS->m_CurrEvent].m_WarningText,(void *)0);
					int res=execlp("wall", "wall", text, NULL);
					if(res==-1)
						perror("Execlp ");
//					m_Log.Add(NULL, 0, "warning");
					exit(127);
				}
				else
				{
					int status,options=0;
					int res=waitpid(pid,&status,options); //czekamy na zakonczenie procesu
					if(res == -1 && errno != ECHILD)	//Z0011, LT - nie zglaszam, jak juz sie skonczyl
					{
						perror("Wysyanie komunikatu");	//Z0011, LT - rozwinalem opis bledu
						if(__debug)
							printf("Parent ERR res=%d pid=%d\n",res,pid);
					}
				}
				//Z0017, LT - posylam okienko do Xw (wymaga "xhost + local:" np. w xinitrc)
				pid=fork();
				if(pid==0)
				{
					if(execlp("xmess", "xmess", text, NULL) < 0)
						perror("xmess");
				}
				else
				{
					int status,options=0;
					int res=waitpid(pid,&status,options); //czekamy na zakonczenie procesu
					if(res == -1 && errno != ECHILD)	//Z0011, LT - nie zglaszam, jak juz sie skonczyl
					{
						perror("Wysyanie komunikatu do Xw");	//Z0011, LT - rozwinalem opis bledu
						if(__debug)
							printf("Parent ERR res=%d pid=%d\n",res,pid);
					}
				}
				//Z0017, LT - koniec
/////////////////////////////// watek
				if(UPS->m_Events[UPS->m_CurrEvent].m_WarningShowNext==0)
					UPS->m_WarningDone=1;
				else
					UPS->m_WarningShowTime+=(UPS->m_Events[UPS->m_CurrEvent].m_WarningNextDelay)/**CLOCKS_PER_SEC*/;
			}
		}
	}
	if(UPS->m_RunDone==0)
	{
		if(m_clock()>=UPS->m_EventTime+((clock_t)UPS->m_Events[UPS->m_CurrEvent].m_RunDelay)/**CLOCKS_PER_SEC*/)
		{
			if(!UPS->m_Events[UPS->m_CurrEvent].m_RunProg.IsEmpty())
			{
				CString path=UPS->m_Events[UPS->m_CurrEvent].m_RunProg;

///////////////////// fork
				int pid=fork();
				//printf("Pid %d\n",pid);
				if(pid==0)
				{
					//Z0019, LT - podzial na parametry
//					int res=execlp(path,path,(void *)0); //jesli sukces nie wraca tu
					char	s[101];
					char	*args[20], *ptr;
					int		i = 0;
					strncpy(s, path, 100);
					s[100] =  0;
					args[i++] = s;
					for(ptr = s; *ptr; ptr++)
					{
						if(*ptr == ' ' || *ptr == '\t')
						{
							*ptr = 0;
							do
								ptr++;
							while(*ptr && (*ptr == ' ' || *ptr == '\t'));
							if(*ptr == 0)
								break;
							args[i++] = ptr;
						}
					}
					args[i] = 0;
					int res=execvp(args[0], args); //jesli sukces nie wraca tu
					//Z0019, LT - koniec
					//int res=system(path);
					//printf("Potomoek run End res=%d\n",res);
					if(res==-1)
					{
						if(__debug)
						{
							printf("Path =-%s-\n",(char *)path);
							perror("Exec :");
						}
						char t[125];
						sprintf(t,"Blad uruchomienia %s\n",(char *)path);
						m_Log.Add(UPS,STATUS_GETTING_DATA,t);
					}
//					m_Log.Add(NULL, 0, "run");
					exit(1);
				}
				else
				{
					int status,options=0;
					int res=waitpid(pid,&status,options);
					if(res == -1 && errno != ECHILD)	//Z0011, LT - nie zglaszam, jesli sie juz skonczyl
					{
						perror("Uruchomienie skryptu");		//Z0011, LT - bledny opis bledu, bylo: Wall
						if(__debug)
							printf("Parent ERR res=%d pid=%d\n",res,pid);
					}
				}
			}
			else
				m_Log.Add(UPS,STATUS_GETTING_DATA,LOG_ERR_RUN_EMPTY);
			UPS->m_RunDone=1;
		}
	}

	if(UPS->m_SendMailDone==0)
	{
		if(m_clock()>=UPS->m_EventTime+((clock_t)UPS->m_Events[UPS->m_CurrEvent].m_SendMailDelay)/**CLOCKS_PER_SEC*/)
		{
			if(UPS->m_Events[UPS->m_CurrEvent].m_SendMailSMTP.IsEmpty()
			//if(strlen(*UPS->m_Events[UPS->m_CurrEvent].m_SendMailSMTP)==0
			|| UPS->m_Events[UPS->m_CurrEvent].m_SendMailFrom.IsEmpty()
			|| UPS->m_Events[UPS->m_CurrEvent].m_SendMailTo.IsEmpty() )
			{
				m_Log.Add(UPS,STATUS_GETTING_DATA,LOG_ERR_SEND_MAIL);
			}
			else
			{
				if(sendEmail(UPS) < 0)
					return ERR_DOACTION_SENDEMAIL;      //Z0002, LT
			}
			UPS->m_SendMailDone=1;
		}
	}

	if(UPS->m_CloseSystemDone==0)
	{
		if(__debug)
			printf("Close system1 clock=%ld i %d \n",UPS->m_EventTime+(int)UPS->m_Events[UPS->m_CurrEvent].m_CloseSystemDelay,(int)m_clock());
		UPS->m_SecToClose=UPS->m_Events[UPS->m_CurrEvent].m_CloseSystemDelay-(m_clock()-UPS->m_EventTime);///CLOCKS_PER_SEC;
		if(UPS->m_SecToClose<0)
			UPS->m_SecToClose=0;
		//SetOdczytyValue(UPS);

		if(m_clock()>=UPS->m_EventTime+((clock_t)UPS->m_Events[UPS->m_CurrEvent].m_CloseSystemDelay)/**CLOCKS_PER_SEC*/)
		{
			if(__debug)
			{
				printf("Close system GO RunUps=%d, turnOff=%d\n",UPS->m_Events[UPS->m_CurrEvent].m_CloseSystemRunUPS,UPS->m_Events[UPS->m_CurrEvent].m_CloseSystemTurnOffUPS);
			}
			// sprawdzamy czy nalezy wyslac do UPS rozkaz UDP_PACKET_UPS_OFF,
			// wysylamy tylko do lokalnego serwera i jezeli to nie jest zdarzenie
			// planowego wylaczenia UPSa - dla zdarzenia planowego wylaczenia UPSa
			// pakiet z rozkazem wylaczajacym zostal juz wyslany i wyslanie rozkazu
			// UDP_PACKET_UPS_OFF mogloby sie zkonczyc bledem (gdyby serwer nie
			// zdazyl odpowiedziec) i wtedy pojawilby sie wpis w logu o tym bledzie
			if(UPS->m_IsLocal && (UPS->m_CurrEvent!=EVENT_UPS_GOING_OFF))
			{
				if(__debug)
					printf("Local close\n");
				char autostart=0; // nie uruchamiaj po powrocie zasilania
				if(UPS->m_Events[UPS->m_CurrEvent].m_CloseSystemRunUPS)
					autostart=1; // uruchamiaj po powrocie zasilania
				char turnoff=0; // nie wylaczaj UPS
				if(UPS->m_Events[UPS->m_CurrEvent].m_CloseSystemTurnOffUPS)
					turnoff=1; // wylacz UPS
				// prygotowujemy pakiet i wysylamy go, wlasciwe zamkniecie systemu
				// bedzie po odebraniu odpowiedzi (lub po timeout)
				UPS->m_TurnOffPacketOutBuff[0]=autostart;
				UPS->m_TurnOffPacketOutBuff[1]=turnoff;
//				if(__debug)
//					printf("Local close auto=%d ,turn=%d \n",autostart,turnoff);
				// zaznaczamy ze nalezy wyslac pakiet (bedzie on wyslany w funkcji OnTimer())
				UPS->m_TurnOffPacketOut=UDP_PACKET_UPS_OFF;
				UPS->m_TurnOffPacketOutNum=0;
				// zapamietujemy tryb zamkniecia systemu
				UPS->m_CloseSystemMode=UPS->m_Events[UPS->m_CurrEvent].m_CloseSystemMode;
				// zaznaczamy czy to my rozkazalismy wylaczyc UPS
				if(UPS->m_Events[UPS->m_CurrEvent].m_CloseSystemTurnOffUPS)
					UPS->m_UPSDoShutdown=1;
			}
			else
			{
				// nie nalezy wyslac do UPS rozkazu UDP_PACKET_UPS_OFF,
				// wiec od razu zamykamy system
				if(CloseSystem(UPS->m_Events[UPS->m_CurrEvent].m_CloseSystemMode) < 0)
					return ERR_DOACTION_CLOSESYSTEM;               //Z0002, LT
			}
			UPS->m_CloseSystemDone=1;
		}
	}

	if(UPS->m_LogDone==1 && UPS->m_WarningDone==1 && UPS->m_RunDone==1
	&& UPS->m_SendMailDone==1 && UPS->m_CloseSystemDone==1)
		SetCurrEvent(UPS,-1); // wykonano juz wszystko
	return 1;
} // CDlgMain::DoAction


/////////////////////////////////////////////////////////////////////////////
// po otrzymaniu pakietu od wybranego UPS
//
//
void CDlgMain::UpdateUPSStatus(CUPSConfig *UPS)
{
	if(!p_sem())
	{
		printf("Error B\n\r");
		//getchar();
	}
	if(__ncurr)
	{
		//printf("-  Wybrany Ups %d  -%s-     \n",m_Cfg.m_CurrUPS,UPS->m_IP);
		if(strlen(UPS->m_Location)==0)
		{
			if(__debug)
				printf("Niedostpny %s.\n",(char *)UPS->m_IP);
		}
		else
		{
			//printf("%-10s ... %d .......\n","Baterie stan",UPS->m_BatStatus);
			//printf("%-10s .... %d,%d [V]\n","Napiecie baterii",UPS->m_BatVol/10,UPS->m_BatVol%10);
			//printf("%s ....... %d,%d [V]\n","Napicie wej ",UPS->m_InVol/10,UPS->m_InVol%10);
			//printf("%s .......... %d,%d [A]\n","Prd wyj. ",UPS->m_OutCurrent/10,UPS->m_OutCurrent%10);
			//printf("%s ......... %d,%d [V]\n","Obciazenie ",UPS->m_OutLoad/10,UPS->m_OutLoad%10);
			//printf("%s ............ %d,%d [W]\n","Moc wyj ",UPS->m_OutPower/10,UPS->m_OutPower%10);
			//printf("%s ....... %d,%d [V]\n","Napiecie wyj ",UPS->m_OutVol/10,UPS->m_OutVol%10);
			//printf("%s ... %02d:%02d min ","Czas na bateriach\n",UPS->m_SecOnBat/60,UPS->m_SecOnBat%60);
		}
	}
	else
	{

#ifdef NCURRSESS
		box(params,ACS_VLINE,ACS_HLINE);
		wbkgd(params,COLOR_PAIR(2));
		wattron(params,COLOR_PAIR(3));
		wmove(params,1,1);//m_Cfg.m_CurrUPS
		//wprintw(params,"           Wybrany Ups %d  -%s-     ",m_Cfg.m_CurrUPS,UPS->m_IP);
		wprintw(params,"           Wybrany Ups %d      ",m_Cfg.m_CurrUPS);
		wattroff(params,COLOR_PAIR(3));
		//(params);
		for(int i=1;i<20;i++)
		{
			wmove(params,i+1,1);
			wprintw(params,"....................................");
		}
		if(strlen(UPS->m_Location)==0)
		{
			wmove(params,2,1);
			wprintw(params,"Niedostpny.");
		}
		else
		{
			wmove(params,2,1);
			wprintw(params,"%10s.. %s .......","Lokalizacja",UPS->m_Location);
			wmove(params,3,1);
			wprintw(params,"%10s.. %s .......","Producent",UPS->m_Manufacturer);
			wmove(params,4,1);
			wprintw(params,"%-10s.. %s.......","Model",(LPCTSTR)UPS->m_Model);
			wmove(params,5,1);
			wprintw(params,"%-10s.. %s ........","Soft wer",(LPCTSTR)UPS->m_SoftVer);
			wmove(params,5,1);
		}
		//if(UPS->m_Location.IsEmpty())
		if(strlen(UPS->m_Location)==0 || UPS->m_Status==STATUS_NO_COMMUNICATION)
		{

		}
		else
		{
			wmove(params,7,1);
			wprintw(params,"%-10s ... %d .......","Baterie stan",UPS->m_BatStatus);
			wmove(params,8,1);
			wprintw(params,"%-10s .... %d,%d [V]","Napiecie baterii",UPS->m_BatVol/10,UPS->m_BatVol%10);
			wmove(params,9,1);
			wprintw(params,"%s ....... %d,%d [V]","Napicie wej ",UPS->m_InVol/10,UPS->m_InVol%10);
			wmove(params,10,1);
			wprintw(params,"%s .......... %d,%d [A]","Prd wyj. ",UPS->m_OutCurrent/10,UPS->m_OutCurrent%10);
			wmove(params,11,1);
			wprintw(params,"%s ......... %d,%d [V]","Obciazenie ",UPS->m_OutLoad/10,UPS->m_OutLoad%10);
			wmove(params,12,1);
			wprintw(params,"%s ............ %ld [W]","Moc wyj ",UPS->m_OutPower);	//Z0015, LT - dzielil przez 10
			wmove(params,13,1);
			wprintw(params,"%s ....... %d,%d [V]","Napiecie wyj ",UPS->m_OutVol/10,UPS->m_OutVol%10);
			wmove(params,14,1);
			switch(UPS->m_BatCondition)
			{
				case 0:
					wprintw(params,"%s ....... %s  ","Bat cond ","Good");
					break;
				case 1:
					wprintw(params,"%s ....... %s  ","Bat cond ","Weak");
					break;
				case 2:
					wprintw(params,"%s ....... %s  ","Bat cond ","Replace");
					break;
				default:
					wprintw(params,"%s ....... %s  ","Bat cond ","---");
			}

			wmove(params,15,1);
			if(UPS->m_UPSShutdownTime>=0)
				wprintw(params,"%s ....... %d:%d [sec]","shutdown",UPS->m_UPSShutdownTime/60,UPS->m_UPSShutdownTime%60);
			else
				wprintw(params,"%s ....... %d  ","shutdown",0);
			//wmove(params,16,1);
			//wprintw(params,"%s ....... %d","m_Status",UPS->m_Status);
			//wprintw(params,"%s ... %02d:%02d min ","Czas na bateriach",UPS->m_SecOnBat/60,UPS->m_SecOnBat%60);
		}
#endif
	}//__ncur
	if(UPS==NULL)
	{
		  // odswierzanie pustego okna
		//if(oldStatus!="") m_UPSStatus.SetWindowText("");
		if(!v_sem())
		{
			printf("Error B\n\r");
			//getchar();
		}
		return;
	}
	if(strlen(UPS->m_Location)==0)
	{

	}
	else
	{

		if(__ncurr==0)
		{
#ifdef NCURRSESS
			wmove(params,17,1);
			wbkgd(params,COLOR_PAIR(4));
			switch(UPS->m_Status)
			{
			case STATUS_NORMAL:
			  // if(oldStatus==STATUS_NORMAL_TEXT) return;
			  // m_UPSStatus.SetColor(STATUS_NORMAL_COLOR);
				//m_UPSStatus.SetWindowText(STATUS_NORMAL_TEXT);
			 wprintw(params,"%s ..... %s .......","Status",STATUS_NORMAL_TEXT);
				break;
			case STATUS_BAT:
				//if(oldStatus==STATUS_BAT_TEXT) return;
				//m_UPSStatus.SetColor(STATUS_BAT_COLOR);
				//m_UPSStatus.SetWindowText(STATUS_BAT_TEXT);
				wattron(params,COLOR_PAIR(5));
				wprintw(params,"%s ..... %s .......","Status",STATUS_BAT_TEXT);
				wattroff(params,COLOR_PAIR(5));
				break;
			case STATUS_BAT_LOW:
				//if(oldStatus==STATUS_BAT_LOW_TEXT) return;
				//m_UPSStatus.SetColor(STATUS_BAT_LOW_COLOR);
				wattron(params,COLOR_PAIR(3));
				wprintw(params,"%s ..... %s .......","Status",STATUS_BAT_LOW_TEXT);
				wattroff(params,COLOR_PAIR(3));
				break;
			case STATUS_AVR_UP:
				//if(oldStatus==STATUS_AVR_UP_TEXT) return;
				//m_UPSStatus.SetColor(STATUS_AVR_UP_COLOR);
				wprintw(params,"%s ..... %s .......","Status",STATUS_AVR_UP_TEXT);
				break;
			case STATUS_AVR_DOWN:
				//if(oldStatus==STATUS_AVR_DOWN_TEXT) return;
				//m_UPSStatus.SetColor(STATUS_AVR_DOWN_COLOR);
				wprintw(params,"%s ..... %s .......","Status",STATUS_AVR_DOWN_TEXT);
				break;
			case STATUS_OFF:
				//if(oldStatus==STATUS_OFF_TEXT) return;
				//m_UPSStatus.SetColor(STATUS_OFF_COLOR);
				wattron(params,COLOR_PAIR(3));
				wprintw(params,"%s ..... %s .......","Status",STATUS_OFF_TEXT);
				wattroff(params,COLOR_PAIR(3));
				break;
			case STATUS_UPS_GOING_OFF:
				wattron(params,COLOR_PAIR(3));
				wprintw(params,"%s ..... %s .......","Status",STATUS_UPS_GOING_OFF_TEXT);
				wattroff(params,COLOR_PAIR(3));
				break;
			case STATUS_BYPASS:
				wattron(params,COLOR_PAIR(3));
				wprintw(params,"%s ..... %s .......","Status",STATUS_BYPASS_TEXT);
				wattroff(params,COLOR_PAIR(3));
				break;

			case STATUS_NO_COMMUNICATION:
				//if(oldStatus==STATUS_NO_COMMUNICATION_TEXT) return;
				//m_UPSStatus.SetColor(STATUS_NO_COMMUNICATION_COLOR);
				wattron(params,COLOR_PAIR(6));
				wprintw(params,"%s ..... %s .......","Status",STATUS_NO_COMMUNICATION_TEXT);
				wattroff(params,COLOR_PAIR(6));
				break;
			default: // STATUS_GETTING_DATA
				//if(oldStatus==STATUS_GETTING_DATA_TEXT) return;
				//m_UPSStatus.SetColor(STATUS_GETTING_DATA_COLOR);
				wprintw(params,"%s ..... %s .......","Status",STATUS_GETTING_DATA_TEXT);
				break;
			}
#endif
		}//__ncurr
	}//strlen

	if(!__ncurr)
	{
#ifdef NCURRSESS
		wrefresh(params);
#endif
		if(!v_sem())
			printf("Error B\n\r");
	}//__ncur
} // CDlgMain::UpdateUPSStatus


int CDlgMain::GetSize(void)
{
	return SizeAllUps;
}

////////////////////////////////
void DbLine(char *str)
{
	UpsDlg.putLine(str);
}


void CDlgMain::putLine(char *str)
{
	//icon=subwin(stdscr,4,75,25,2);
	if(__ncurr && __debug)
		printf("H: %s\n",str);
	else
	{
#ifdef NCURRSESS
		  if(__ncurr==0){
			  wbkgd(icon,COLOR_PAIR(4));
			  box(icon,ACS_VLINE,ACS_HLINE);
			  wmove(icon,1,1);
			  wprintw(icon,"%s",str);
			  wrefresh(icon);
		  }
#endif
}
}


/////////////////////////////////////////////////////////////////////////////
void CDlgMain::ChangeIconOnTaskBar(int error)
{

	//printf("Change Icon on Task Bar %d\n",error);
	//params=subwin(stdscr,20,40,2,2);
	//       LINE_Y LINE_X  Y   X
	//icon=subwin(stdscr,4,75,25,2);
if(__ncurr){

}else{
#ifdef NCURRSESS
	wbkgd(icon,COLOR_PAIR(4));
	box(icon,ACS_VLINE,ACS_HLINE);
	wmove(icon,2,2);
	wprintw(icon," Komunikaty %d ",error);
	wrefresh(icon);
#endif
}//__ncur
}

/////////////////////////////////////////////////////////////////////////////
void CDlgMain::UpdateScreen(CUPSConfig *UPS, int Idx, BOOL StatusChanged)
{
static int old_idx=-1;

	if(old_idx!=m_Cfg.m_CurrUPS){
		old_idx=m_Cfg.m_CurrUPS;
		showList(m_Cfg.m_CurrUPS);
	}

	UpdateUPSStatus(UPS);
	//if(Idx==m_Cfg.m_CurrUPS/* && m_Cfg.m_HideMonTab==0*/)
	//{
	//   UpdateUPSStatus(UPS);
	//}
	//m_UPSList.UpdateStatus(Idx,UPS->m_Status);

	if(StatusChanged)
	{
		if(UPS->m_Status!=STATUS_NORMAL && UPS->m_Status!=STATUS_GETTING_DATA)
			ChangeIconOnTaskBar(TRUE);
		else
		{
			BOOL error=FALSE;
			for(int i=SizeAllUps; i>=0; i--){

				if(m_AllUPS[i].m_Status!=STATUS_NORMAL && m_AllUPS[i].m_Status!=STATUS_GETTING_DATA)
				{
					error=TRUE;
					break;
				}
				ChangeIconOnTaskBar(error);
			}
		}
	}

	//wmove(params,16,3);
	//wprintw(params,"11111111");
	//wrefresh(params);

} // CDlgMain::UpdateScreen


/////////////////////////////////////////////////////////////////////////////
void CDlgMain::SetOdczytyValue(CUPSConfig *UPS)
{
	/*
	CString oldText, newText;
	if(UPS==NULL)   // lista UPS'ow jest pusta
	{
		m_Odczyt1Value.GetWindowText(oldText);
		if(oldText!="") m_Odczyt1Value.SetWindowText("");
		m_Odczyt2Value.GetWindowText(oldText);
		if(oldText!="") m_Odczyt2Value.SetWindowText("");
		m_Odczyt3Value.GetWindowText(oldText);
		if(oldText!="") m_Odczyt3Value.SetWindowText("");
		m_Odczyt4Value.GetWindowText(oldText);
		if(oldText!="") m_Odczyt4Value.SetWindowText("");
		return;
	}

	GetOdczytyValueText(newText,0,UPS);

	m_Odczyt1Value.GetWindowText(oldText);
	if(oldText!=newText) m_Odczyt1Value.SetWindowText(newText);
	GetOdczytyValueText(newText,1,UPS);
	m_Odczyt2Value.GetWindowText(oldText);
	if(oldText!=newText) m_Odczyt2Value.SetWindowText(newText);
	GetOdczytyValueText(newText,2,UPS);
	m_Odczyt3Value.GetWindowText(oldText);
	if(oldText!=newText) m_Odczyt3Value.SetWindowText(newText);
	GetOdczytyValueText(newText,3,UPS);
	m_Odczyt4Value.GetWindowText(oldText);
	if(oldText!=newText) m_Odczyt4Value.SetWindowText(newText);
	*/
} // CDlgMain::SetOdczytyValue


/////////////////////////////////////////////////////////////////////////////
void CDlgMain::GetOdczytyValueText(char  *Txt, int Pos, CUPSConfig *UPS)
{
/*
	switch(UPS->m_Odczyty[Pos])
	{
		case ODCZYT_MODEL:
			Txt=UPS->m_Model;
			break;
		case ODCZYT_PRODUCENT:
			Txt=UPS->m_Manufacturer;
			break;
		case ODCZYT_LOKALIZACJA:
			Txt=UPS->m_Location;
			break;
		case ODCZYT_CZAS_PRACY:
			if(UPS->m_SecOnBat==VAL_UNAVAILABLE)
			{
				Txt=STR_VAL_UNAVAILABLE;
				break;
			}
			if(UPS->m_SecOnBat==VAL_GETTING_DATA)
			{
				Txt=STR_VAL_GETTING_DATA;
				break;
			}
			if(Odczyt[ODCZYT_CZAS_PRACY].Type==TYPE_INT)
				Txt.Format("%d %s",UPS->m_SecOnBat,Odczyt[ODCZYT_CZAS_PRACY].Unit);
			else
				Txt.Format("%0d.%0d %s",UPS->m_SecOnBat/10,UPS->m_SecOnBat%10,Odczyt[ODCZYT_CZAS_PRACY].Unit);
			break;
		case ODCZYT_NAPIECIE_ZASILANIA:
			if(UPS->m_InVol==VAL_UNAVAILABLE)
			{
				Txt=STR_VAL_UNAVAILABLE;
				break;
			}
			if(UPS->m_InVol==VAL_GETTING_DATA)
			{
				Txt=STR_VAL_GETTING_DATA;
				break;
			}
			if(Odczyt[ODCZYT_NAPIECIE_ZASILANIA].Type==TYPE_INT)
				Txt.Format("%d %s",UPS->m_InVol,Odczyt[ODCZYT_NAPIECIE_ZASILANIA].Unit);
			else
				Txt.Format("%0d.%0d %s",UPS->m_InVol/10,UPS->m_InVol%10,Odczyt[ODCZYT_NAPIECIE_ZASILANIA].Unit);
			break;
		case ODCZYT_MOC_WYJSCIOWA:
			if(UPS->m_OutPower==VAL_UNAVAILABLE)
			{
				Txt=STR_VAL_UNAVAILABLE;
				break;
			}
			if(UPS->m_OutPower==VAL_GETTING_DATA)
			{
				Txt=STR_VAL_GETTING_DATA;
				break;
			}
			if(Odczyt[ODCZYT_MOC_WYJSCIOWA].Type==TYPE_INT)
				Txt.Format("%d %s",UPS->m_OutPower,Odczyt[ODCZYT_MOC_WYJSCIOWA].Unit);
			else
				Txt.Format("%0d.%0d %s",UPS->m_OutPower/10,UPS->m_OutPower%10,Odczyt[ODCZYT_MOC_WYJSCIOWA].Unit);
			break;
		case ODCZYT_PRAD_WYJSCIOWY:
			if(UPS->m_OutCurrent==VAL_UNAVAILABLE)
			{
				Txt=STR_VAL_UNAVAILABLE;
				break;
			}
			if(UPS->m_OutCurrent==VAL_GETTING_DATA)
			{
				Txt=STR_VAL_GETTING_DATA;
				break;
			}
			if(Odczyt[ODCZYT_PRAD_WYJSCIOWY].Type==TYPE_INT)
				Txt.Format("%d %s",UPS->m_OutCurrent,Odczyt[ODCZYT_PRAD_WYJSCIOWY].Unit);
			else
				Txt.Format("%0d.%0d %s",UPS->m_OutCurrent/10,UPS->m_OutCurrent%10,Odczyt[ODCZYT_PRAD_WYJSCIOWY].Unit);
			break;
		case ODCZYT_NAPIECIE_WYJSCIOWE:
			if(UPS->m_OutVol==VAL_UNAVAILABLE)
			{
				Txt=STR_VAL_UNAVAILABLE;
				break;
			}
			if(UPS->m_OutVol==VAL_GETTING_DATA)
			{
				Txt=STR_VAL_GETTING_DATA;
				break;
			}
			if(Odczyt[ODCZYT_NAPIECIE_WYJSCIOWE].Type==TYPE_INT)
				Txt.Format("%d %s",UPS->m_OutVol,Odczyt[ODCZYT_NAPIECIE_WYJSCIOWE].Unit);
			else
				Txt.Format("%0d.%0d %s",UPS->m_OutVol/10,UPS->m_OutVol%10,Odczyt[ODCZYT_NAPIECIE_WYJSCIOWE].Unit);
			break;
		case ODCZYT_AKUMULATOR:
			if(UPS->m_BatVol==VAL_UNAVAILABLE)
			{
				Txt=STR_VAL_UNAVAILABLE;
				break;
			}
			if(UPS->m_BatVol==VAL_GETTING_DATA)
			{
				Txt=STR_VAL_GETTING_DATA;
				break;
			}
			if(Odczyt[ODCZYT_AKUMULATOR].Type==TYPE_INT)
				Txt.Format("%d %s",UPS->m_BatVol,Odczyt[ODCZYT_AKUMULATOR].Unit);
			else
				Txt.Format("%0d.%0d %s",UPS->m_BatVol/10,UPS->m_BatVol%10,Odczyt[ODCZYT_AKUMULATOR].Unit);
			break;
		case ODCZYT_STAN_ZASILACZA:
			if(UPS->m_OutSource==VAL_UNAVAILABLE) Txt=STR_VAL_UNAVAILABLE;
			else if(UPS->m_OutSource==VAL_GETTING_DATA) Txt=STR_VAL_GETTING_DATA;
			else if(UPS->m_OutSource==0) Txt=ODCZYT_SZ_TEXT0;
			else if(UPS->m_OutSource==1) Txt=ODCZYT_SZ_TEXT1;
			else if(UPS->m_OutSource==2) Txt=ODCZYT_SZ_TEXT2;
			else if(UPS->m_OutSource==3) Txt=ODCZYT_SZ_TEXT3;
			else if(UPS->m_OutSource==4) Txt=ODCZYT_SZ_TEXT4;
			else Txt=ODCZYT_SZ_TEXT5;
			break;
		case ODCZYT_OBCIAZENIE:
			if(UPS->m_OutLoad==VAL_UNAVAILABLE)
			{
				Txt=STR_VAL_UNAVAILABLE;
				break;
			}
			if(UPS->m_OutLoad==VAL_GETTING_DATA)
			{
				Txt=STR_VAL_GETTING_DATA;
				break;
			}
			if(Odczyt[ODCZYT_OBCIAZENIE].Type==TYPE_INT)
				Txt.Format("%d %s",UPS->m_OutLoad,Odczyt[ODCZYT_OBCIAZENIE].Unit);
			else
				Txt.Format("%0d.%0d %s",UPS->m_OutLoad/10,UPS->m_OutLoad%10,Odczyt[ODCZYT_OBCIAZENIE].Unit);
			break;
		default: // ODCZYT_WYLACZONY
			Txt="";
			break;
	}
*/
} // CDlgMain::GetOdczytyValueText

//////////////////// watek czekajacy na zakonczenie innych procesow
//LT - nieuywana
//void *defuncProcess(void *p)
//{
//	do
//	{
//		int status,options=0;
//		int pid=-1;
//		int my_pid=getpid();
//		if(__debug)
//			printf("Moj pid %d\n",my_pid);
//		int res=waitpid(my_pid,&status,options);
//		//int res=wait(&status);
//		if(res==-1)
//			perror("wait pid ");
//
//		if(__debug)
//			printf("Parent OK res=%d, pid=%d,sta=%d\n",res,pid,status);
//
//		sleep(1);
//	}
//	while(UpsDlg.Restart==0);
//	return (void *)0;
//}

void *onTimerTask(void *UpsDlg1)
{
	ThreadCount |= THREAD_TIMER;
	do
	{
// pomiar czasu
//		UpsDlg.OnTimer(1);
		tickTimer = 1;
		sleep(1);
	}
//	while(UpsDlg.Restart==0);
	while(end_process==0);
	if(__debug)
		printf("End onTimer thread\n");
	ThreadCount &= ~THREAD_TIMER;
	return (void *)0;
}


/////////////////////////////////////////////////////////////////////////////
int	CDlgMain::OnTimer(UINT nIDEvent)
{
    int res = 0;    //Z0002, LT
	for(int i=SizeAllUps; i>=0; i--)
	{
		if(m_AllUPS[i].m_IsIPInitialized==0)
		{
			if((res = DoAction(&m_AllUPS[i],i)) < 0) // jedyna mozliwa akcja to rozpczecie programu
				return res;     //Z0002, LT
			continue; // pomijamy, czekajac na zainicjowanie adresu
		}

		if(++(m_AllUPS[i].m_NormalPacketOutNum)>UPSMON_MAX_RETRY)
		{
			m_AllUPS[i].InitData();
			//LT: brakujce wywoanie:
			ChangeStatus(&m_AllUPS[i], STATUS_NO_COMMUNICATION);
		}
		if(strlen(m_AllUPS[i].m_IP))
		{ // gdy adres IP jest pusty to nie ma sensu wysylac pakietu

			m_Net.SendTo((LPCTSTR)m_AllUPS[i].m_IP,/*m_Cfg.m_PortTCP,*/m_AllUPS[i].m_NormalPacketOutType|UDP_TYPE_REQUEST);
//          printf("SendTo %s\n",m_AllUPS[i].m_IP);
			usleep(10000);
		}
		if(m_AllUPS[i].m_PacketOut<10)
		{
			m_AllUPS[i].m_PacketOut++;
			DoWWW(m_AllUPS,i,SizeAllUps); //zapis do plikow htm gdy mamy odpowiedz
		}
		if(OnTimerOff(i) < 0)
			return ERR_ONTIMEROFF;      //Z0002, LT
		if(OnTimerTask(i) < 0)
			return ERR_ONTIMERTASK;     //Z0002, LT
		if((res = DoAction(&m_AllUPS[i],i)) < 0)    //Z0002, LT
			return res;
	}
	if(__ncurr==0)
	{
#ifdef NCURRSESS
		wmove(ti,5,5);//m_Cfg.m_CurrUPS
		wprintw(ti,"DoTask ");
		wrefresh(ti);
#endif
	}
	DoTask(); // wykonujemy akcje z terminarza
	if(__ncurr==0)
	{
#ifdef NCURRSESS
		wrefresh(ti);
#endif
	}
	return 1;
} // CDlgMain::OnTimer

int	CDlgMain::OnTimerOff(int i)
{
	if(m_AllUPS[i].m_TurnOffPacketOut == 0)
		return 0;
	if(++(m_AllUPS[i].m_TurnOffPacketOutNum)>UPSMON_MAX_RETRY)
	{
		m_AllUPS[i].m_TurnOffPacketOut=0;    // oznaczamy ze nie nalezy juz wysylac pakietu
		// ten pakiet wysylany jest tylko w trakcie rozpoczynania zamkniecia
		// systemu, zatem teraz zglaszamy blad blad i konczymy zamkniecie systemu
		//m_Log.Add(m_AllUPS[i],STATUS_GETTING_DATA,LOG_ERR_CLOSE_SYSTEM_UPS,m_Cfg.m_CurrUPS==i?&m_LogList:NULL);
		m_Log.Add(&m_AllUPS[i],STATUS_GETTING_DATA,LOG_ERR_CLOSE_SYSTEM_UPS);
		if(CloseSystem(m_AllUPS[i].m_CloseSystemMode) < 0)
			return -1;
	}
	if(m_AllUPS[i].m_TurnOffPacketOut!=0
	&& strlen(m_AllUPS[i].m_IP))
	{ // gdy adres IP jest pusty to nie ma sensu wysylac pakietu
		// m_TurnOffPacketOutBuff[1] zawiera flage wylaczenia UPSa
		if(__debug)
			printf("Flaga wylUps %d\n",m_AllUPS[i].m_TurnOffPacketOutBuff[1]);
		if(m_AllUPS[i].m_TurnOffPacketOutBuff[1])
		{
			// przed wyslaniem rozkazu wylaczenia UPSa zapisujemy pamiec dzielona
			//Z0008, LT - wystarczy 1 bajt
			BYTE    memBuff = SHARED_MEM_VALUE;
			m_SharedMem.Write(&memBuff, 1, SHARED_MEM_OFFSET);
			if(__debug)
				printf("Zapis p.  %d\n",SHARED_MEM_VALUE);
		}
		m_Net.SendTo((LPCTSTR)m_AllUPS[i].m_IP,/*m_Cfg.m_PortTCP,*/m_AllUPS[i].m_TurnOffPacketOut/*m_NormalPacketOutType*/|UDP_TYPE_REQUEST,m_AllUPS[i].m_TurnOffPacketOutBuff,2);
	}
	return 1;
}

int	CDlgMain::OnTimerTask(int i)
{
	if(m_AllUPS[i].m_DoTaskPacketOut == 0)
		return 0;
	if(++(m_AllUPS[i].m_DoTaskPacketOutNum)>UPSMON_MAX_RETRY)
	{
		m_AllUPS[i].m_DoTaskPacketOut=0;    // oznaczamy ze nie nalezy juz wysylac pakietu
		// zapisujemy informacje o bledzie
		//m_Log.Add(m_AllUPS[i],STATUS_GETTING_DATA,LOG_ERR_DO_TASK,m_Cfg.m_CurrUPS==i?&m_LogList:NULL);
		// wyznaczamy kolejne do wykonania zadanie z terminarza

		m_Log.Add(&m_AllUPS[i],STATUS_GETTING_DATA,LOG_ERR_DO_TASK);
		m_TaskInProgress=FALSE;
		SelectFirstTask();
	}
	if(m_AllUPS[i].m_DoTaskPacketOut!=0
	&& strlen(m_AllUPS[i].m_IP))
	{ // gdy adres IP jest pusty to nie ma sensu wysylac pakietu
		// przed wyslaniem rozkazu zapisujemy pamiec dzielona
		if(__debug)
			printf("Zapis pamieci v=%d off=%d\n",SHARED_MEM_VALUE,SHARED_MEM_OFFSET);
		//Z0008, LT - przy okazji dodawania kodu wyjscia, robie porzadki w pamieci dzielonej
		//teraz 1 bajt danych
		BYTE memBuff;
		memBuff = SHARED_MEM_VALUE;
		m_SharedMem.Write(&memBuff, 1, SHARED_MEM_OFFSET);
		//Z0008, LT - koniec
		if(__debug)
		{
			printf("Wysylam pakiet z zadaniem %s n=%d",(LPCTSTR)m_AllUPS[i].m_IP,i);
			printf(" %d L=%d %d %d %d ",m_AllUPS[i].m_DoTaskPacketOutBuff[0],m_AllUPS[i].m_DoTaskPacketOutBuff[1],m_AllUPS[i].m_DoTaskPacketOutBuff[2],m_AllUPS[i].m_DoTaskPacketOutBuff[3],m_AllUPS[i].m_DoTaskPacketOutBuff[4]);
			printf(" [5]=%d  \n",m_AllUPS[i].m_DoTaskPacketOutBuff[5]);
		}
		// 2003.01.13, MW, zmiana ilosci wysylanych bajtw z 5 na 6 w zwiazku z
		// dodaniem flagi zamykania systemu (istone dla UPS-ow stykowych, pozostale pomijaja ten parametr)
		m_Net.SendTo((LPCTSTR)m_AllUPS[i].m_IP,/*m_Cfg.m_PortTCP,*/m_AllUPS[i].m_DoTaskPacketOut|UDP_TYPE_REQUEST,m_AllUPS[i].m_DoTaskPacketOutBuff,6);
	}
	return 1;
}

//////////////////////////////
// wysyla i odczytuje
int CDlgMain::getData()
{
	UCHAR 	Addr[100];
	UCHAR 	Buff_in[2000];
	int 	DataLen=0;
	int 	i=0;

	memset(Addr,0,sizeof(Addr));
	memset(Buff_in,0,sizeof(Buff_in));
	int res=m_Net.OnReceive(Addr,Buff_in,&DataLen);
//	printf("Received code == %02X, res == %d\n", (int)(Buff_in[0]), res);
	if(!res)
		return 0;
	for(i=0;i<=SizeAllUps;i++)
	{
		if(strlen((LPCTSTR)m_AllUPS[i].m_IP) <= 5
		|| strcmp((const char *)m_AllUPS[i].m_IP,(const char *)Addr))
			continue;
		m_AllUPS[i].m_PacketOut=0;
		if((m_AllUPS[i].m_NormalPacketOutType|UDP_TYPE_ANSWER)==Buff_in[0])
		{
			res = AnalizeNormalPacket(Buff_in,DataLen,&m_AllUPS[i],i);
			if(res < 0)		//fatalny!
				return ERR_ANALIZENORMALPACKET;
			else if(!res)
			{
				if(__debug)
					printf("Zly pakiet analize len=%d\n",DataLen);
				break;
			}
			DoWWW(m_AllUPS,i,SizeAllUps); //zapis do plikow htm gdy mamy odpowiedz

			//return; // bledny pakiet, ignorujemy go
			if(m_AllUPS[i].m_NormalPacketOutType==UDP_PACKET_CONNECT)
				m_AllUPS[i].m_NormalPacketOutType=UDP_PACKET_GET_STATIC_DATA;
			else if(m_AllUPS[i].m_NormalPacketOutType==UDP_PACKET_GET_STATIC_DATA)
				m_AllUPS[i].m_NormalPacketOutType=UDP_PACKET_GET_DYNAMIC_DATA;
			// w przypadku UDP_PACKET_GET_DYNAMIC_DATA nie zmieniamy typu
			// i nie wysylamy kolejnego pakietu (pakiety UDP_PACKET_GET_DYNAMIC_DATA
			// sa wysylane cyklicznie z funkcji OnTimer())
			else
			{ // m_AllUPS[i]->m_NormalPacketOutType==UDP_PACKET_GET_DYNAMIC_DATA
				m_AllUPS[i].m_NormalPacketOutNum=0;
				continue; // continue zamiast return bo moga byc 2 UPS o roznych polach
						 // m_Address a o takim samy polu m_IP
			}
			//printf("8--\n");
			m_AllUPS[i].m_NormalPacketOutNum=1;
			//m_Net.SendTo((LPCTSTR)m_AllUPS[i].m_IP,/*m_Cfg.m_PortTCP*/m_AllUPS[i].m_NormalPacketOutType|UDP_TYPE_REQUEST);
			m_Net.SendTo((LPCTSTR)m_AllUPS[i].m_IP,/*m_Cfg.m_PortTCP,*/m_AllUPS[i].m_NormalPacketOutType|UDP_TYPE_REQUEST);
		}//if
		else if((m_AllUPS[i].m_TurnOffPacketOut|UDP_TYPE_ANSWER)==Buff_in[0])
		{
			res = AnalizeTurnOffPacket(Buff_in,DataLen,&m_AllUPS[i],i);
			if(res < 0)
				return ERR_ANALIZETURNOFFPACKET; //bd fatalny
			if(res == 0)
				break; //bledny pakiet, ignorujemy go
			m_AllUPS[i].m_TurnOffPacketOut=0;    // oznaczamy ze nie nalezy juz wysylac pakietu
		}
		else if((m_AllUPS[i].m_DoTaskPacketOut|UDP_TYPE_ANSWER)==Buff_in[0])
		{
			if(!AnalizeDoTaskPacket(Buff_in,DataLen,&m_AllUPS[i],i))
			{
				if(__debug)
					printf("Blad AnalizeDoTaskPacket\n");
				break; // bledny pakiet, ignorujemy go
			}
			if(__debug)
				printf("AnalizeDoTaskPacket OK\n");
			m_AllUPS[i].m_DoTaskPacketOut=0;    // oznaczamy ze nie nalezy juz wysylac pakietu
		}
	}
	m_Net.Acknowledge();
	return 0;
}

/////////////////////////////////////////
CDlgMain::CDlgMain()
{
	m_TasksGetSize=0;
//	UpsDlg.Restart=0; //restart
	if(__debug)
		printf("Kont CDlgMain::CDlgMain\n");
}

CDlgMain::~CDlgMain()
{
	if(__debug)
		printf("Dest CDlgMain::CDlgMain\n");
	m_Net.Disconnect();
	// pozamykac inne
}

//Z0003, LT - czytanie pliku options.cfg
#define LINE_LEN    80
#define VALUE_LEN   60

//int CDlgMain::ReadGlobalConfig(CString *cfg, UINT *sPortIP, UINT *cPortIP, CString *log, CString *logWWW, UINT *refresh)
int CDlgMain::ReadGlobalConfig(CUPSMonConfig *cfg)	//Z0009, LT - upraszczam, bo sie zrobilo za duzo parametrow
{
    FILE *f = fopen(OPTIONS_FILE, "r");   //sciezka na sztywno!
    if(f == NULL)
    {
	    perror("Blad w funkcji readOptions: ");
        return ERR_FOPEN_GLOBAL_CONFIG;
    }
    char    variable[LINE_LEN];
    while(fgets(variable, LINE_LEN, f))
    {
        if(variable[0] == '#')      //komentarz lub pusta
            continue;
        char *value = strchr(variable, '=');
        if(value == NULL)       //nie jest to przypisanie zmiennej (np. pusta)
            continue;
        //wyodrebnienie zmiennej i wartosci przez wyciecie '=' '"' i '\n'
        *value = 0;
        value++;
        char *p = strchr(value, '\n');
        if(p)
            *p = 0;
        p = strchr(value, '\"');
        if(p)
        {
            value = p + 1;
            p = strrchr(value, '\"');
            if(p)
                *p = 0;
        }
        //przepisanie wartoci do odpowiedniej zmiennej w programie
        if(strcmp(variable, "PATH_CONFIG") == 0)
            cfg->m_pathCfg = value;				//Z0009, LT
        else if(strcmp(variable, "SERVER_PORT_IP") == 0)
            cfg->m_PortTCP = atoi(value);		//Z0009, LT
        else if(strcmp(variable, "CLIENT_PORT_IP") == 0)
            cfg->m_MyPortTCP = atoi(value);		//Z0009, LT
        else if(strcmp(variable, "PATH_LOG") == 0)
            cfg->m_pathLog = value;				//Z0009, LT
        else if(strcmp(variable, "PATH_WWW") == 0)
            cfg->m_pathLogWWW = value;			//Z0009, LT
        else if(strcmp(variable, "REFRESH_WWW") == 0)
            cfg->m_refresh = atoi(value);		//Z0009, LT
        else if(strcmp(variable, "PATH_BINARY") == 0)	//Z0009, LT - teraz potrzebuje sciezke do shutdown
            cfg->m_pathBinary = value;			//Z0009, LT
//        if(__debug)
//            printf("variable: %s, value: %s\n", variable, value);
    }
	printf("  [CFG]   Port IP serwera: %d\n", cfg->m_PortTCP);		//Z0009, LT
	printf("  [CFG]   Port IP klienta: %d\n", cfg->m_MyPortTCP);	//Z0009, LT
    return 0;
}
//Z0003 - koniec

int CDlgMain::ReadConfig()
{
	FILE *f;
	int res = 0;

	char sBuffer[256];
	char sParam[255];
	char sTmpBuffer[255];
	unsigned int v = 0;
	char sReturnValue[255];
	char t[255];
	int  event_nr = EVENT_DEFAULT;	//Z0013, LT bylo:		=EVENT_BYPASS+1;
	char eve[][30] = {"[EVENT_NORMAL]", "[EVENT_BAT]", "[EVENT_BAT_LOW]", "[EVENT_SYS_CLOSE]", "[EVENT_NO_COMMUNICATION]", "[EVENT_PRG_START]", "[EVENT_PRG_STOP]", "[EVENT_NO_COMM_BAT]", "[EVENT_AVR_START]", "[EVENT_UPS_GOING_OFF]", "[EVENT_BYPASS]", "[EVENT_DEFAULT]"};
	//char eve[][30]={"EVENT_NORMAL","EVENT_BAT","EVENT_BAT_LOW"};
	int  eved[]={EVENT_NORMAL, EVENT_BAT, EVENT_BAT_LOW, EVENT_SYS_CLOSE, EVENT_NO_COMMUNICATION, EVENT_PRG_START, EVENT_PRG_STOP, EVENT_NO_COMM_BAT, EVENT_AVR_START, EVENT_UPS_GOING_OFF, EVENT_BYPASS, EVENT_DEFAULT};		//Z0013, LT - dodany domyslny

	//Z0005, LT - sciezka nie jest stala, lecz pobierana z pliku opcji
//	if ((f = fopen(UPS_CFG_FILE,"r")) == NULL)
	CString s = m_Cfg.m_pathCfg + UPS_CFG_FILE;
	if ((f = fopen(s.str(), "r")) == NULL)
	{
//		printf("- Blad otwarcia pliku konfiguracji %s\n",UPS_CFG_FILE);
//		perror("Error open cfg file:");
		perror(UPS_CFG_FILE);
		return ERR_FOPEN_CONFIG; //Z0002 - can't open file
	}

	if(__debug)
		printf(" Configuration\n");
//	SizeAllUps=1;
	SizeAllUps = 0;		//LT - przecie 1 to s 2 UPSy!
	//Z0013, LT - zainicjowanie parametrow domyslnych
	//Istnieja parametry domyslne dla wszystkich UPSow (DefaultEvent)
	//i dla poszczegolnych UPSow (pod indeksem EVENT_DEFAULT).
	//Poniewaz na poczatku parametry ida do UPSa 0 (w pliku jest to UPS_NR 1),
	//inicjuje jego dane domyslne, czytam parametry do jego danych domyslnych
	//a po pojawieniu sie biezacego 0  (UPS_NR 1) skopiuje je do DefaultEvent.
	//Po pojawieniu sie UPS_NR 2 itd kopiuje dane z DefaultEvent do domyslnych dla danego UPSa.
	CUPSEventCfg DefaultEvent;
	//Z0013, LT - koniec
	while(fgets(sBuffer,sizeof(sBuffer),f) != NULL)
	{/* serach until EOF */
		if(sBuffer[0]=='#')
			continue;
//Z0013, LT		for(int i=0; i<=EVENT_BYPASS;i++)
		for(int i = 0; i < EVENT_DEFAULT; i++)
		{
			strcpy(sParam,eve[i]);
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{
				event_nr=i;
				//Z0013, LT - inicjuje wartosciami domyslnymi dla tego UPSa
				m_AllUPS[v].m_Events[i] = m_AllUPS[v].m_Events[EVENT_DEFAULT];
				//Z0013, LT - koniec
				sscanf(sBuffer,"%s %s",sTmpBuffer,t);	/* read varible */
				if(strstr(sBuffer,"WriteToLog")!=NULL)
				{
					//printf("[CFG]   WriteToLog	YES \n");
					m_AllUPS[v].m_Events[eved[event_nr]].m_WriteToLog=1;
				}
				if(strstr(sBuffer,"Warning")!=NULL)
				{
					//printf("[CFG]   Warning		YES\n");
					m_AllUPS[v].m_Events[eved[event_nr]].m_Warning=1;
				}
				if(strstr(sBuffer,"Run")!=NULL)
				{
					m_AllUPS[v].m_Events[eved[event_nr]].m_Run=1;
					//printf("[CFG]   Run			YES UPS=%d ,nrEv=%d  %s\n",v,event_nr,eve[event_nr]);
				}
				if(strstr(sBuffer,"SendMail")!=NULL)
				{
					//printf("[CFG]   SendMail	YES\n");
					m_AllUPS[v].m_Events[eved[event_nr]].m_SendMail=1;
				}
				if(strstr(sBuffer,"CloseSystem")!=NULL)
				{
					if(__debug)
						printf("[CFG] %d   CloseSystem	YES %d %s\n",v,event_nr,eve[event_nr]);
					m_AllUPS[v].m_Events[eved[event_nr]].m_CloseSystem=1;
				}
				break;
			}//strncmp
		}//for
////////// zdarzenia event_nr
		//Z0013, LT - przewiduje jeszcze jedna pozycje w tabeli na parametry domyslne dla danego UPSa
//		if(event_nr<=EVENT_BYPASS)
		if(event_nr <= EVENT_DEFAULT)
		//Z0013, LT - koniec
		{
////////////////////////////////////////////////////////////// warning
			strcpy(sParam,"[CLOSE_SYSTEM_DELAY]");
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{
				sscanf(sBuffer,"%s %d",sTmpBuffer,&m_AllUPS[v].m_Events[event_nr].m_CloseSystemDelay);
				//printf("[CFG]   CLOSE_SYS_DELAY %d\n",m_AllUPS[v].m_Events[event_nr].m_CloseSystemDelay);
			}
			strcpy(sParam,"[CLOSE_SYSTEM_RUNUPS]");
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{
				sscanf(sBuffer,"%s %d",sTmpBuffer,&m_AllUPS[v].m_Events[event_nr].m_CloseSystemRunUPS);
				//printf("[CFG]   CLOSE_SYS_RUNUPS %d\n",m_AllUPS[v].m_Events[event_nr].m_CloseSystemRunUPS);
			}
			strcpy(sParam,"[CLOSE_SYSTEM_TURNOFFUPS]");
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{
				sscanf(sBuffer,"%s %d",sTmpBuffer,&m_AllUPS[v].m_Events[event_nr].m_CloseSystemTurnOffUPS);
				//printf("[CFG]   CLOSE_SYS_TURNOFF %d\n",m_AllUPS[v].m_Events[event_nr].m_CloseSystemTurnOffUPS);
			}
			strcpy(sParam,"[CLOSE_SYSTEM_MODE]");
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{
				sscanf(sBuffer,"%s %d",sTmpBuffer,&m_AllUPS[v].m_Events[event_nr].m_CloseSystemMode);
				//printf("[CFG]   CLOSE_SYS_MODE %d\n",m_AllUPS[v].m_Events[event_nr].m_CloseSystemMode);
				//getchar();
			}
			strcpy(sParam,"[WARNING_TEXT]");
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{
				//sscanf(sBuffer,"%s %s",sTmpBuffer,t);
				//removeSpace(t);
				//Z0011, LT - wycinam poczatkowe spacje i tabulacje
				char *s = sBuffer+strlen(sParam)+1;
				while(*s == ' ' || *s == '\t')
					s++;
				m_AllUPS[v].m_Events[event_nr].m_WarningText=(LPCTSTR)s;
				//Z0011, LT - koniec
				//printf("[CFG]   WARNING_TXT -%s- e=%d\n",(char *)m_AllUPS[v].m_Events[event_nr].m_WarningText,event_nr);
            }
			strcpy(sParam,"[WARNING_FIRST_DELAY]");
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{
				sscanf(sBuffer,"%s %d",sTmpBuffer,&m_AllUPS[v].m_Events[event_nr].m_WarningFirstDelay);
				//printf("[CFG]   WARNING_FIRST_DELAY %d\n",m_AllUPS[v].m_Events[event_nr].m_WarningFirstDelay);
			}
			strcpy(sParam,"[WARNING_NEXT]");
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{
				sscanf(sBuffer,"%s %d",sTmpBuffer,&m_AllUPS[v].m_Events[event_nr].m_WarningShowNext);
				//printf("[CFG]   WARNING_NEXT %d\n",m_AllUPS[v].m_Events[event_nr].m_WarningShowNext);
			}
			strcpy(sParam,"[WARNING_NEXT_DELAY]");
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{
				sscanf(sBuffer,"%s %d",sTmpBuffer,&m_AllUPS[v].m_Events[event_nr].m_WarningNextDelay);
				//printf("[CFG]   WARNIG_NEXT_DELAY %d\n",m_AllUPS[v].m_Events[event_nr].m_WarningNextDelay);
			}
////////////////////////////	Run
			strcpy(sParam,"[RUN_PRG]");			//	1
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{ /* string has been founded */
				//Z0019, LT - nie mozna bylo podac parametrow!
//				sscanf(sBuffer,"%s %s",sTmpBuffer,t);
//				removeSpace(t);
//				m_AllUPS[v].m_Events[event_nr].m_RunProg=t;
				char *s = sBuffer+strlen(sParam)+1;
				while(*s == ' ' || *s == '\t')
					s++;
				if(s[strlen(s)-1] == '\n')
					s[strlen(s)-1] = 0;
				m_AllUPS[v].m_Events[event_nr].m_RunProg=(LPCTSTR)s;
				//Z0019, LT - koniec
				//printf("[CFG]v=%d	RUN_PRG %s dla %s\n",v,(char *)m_AllUPS[v].m_Events[event_nr].m_RunProg,eve[event_nr]);
			}
			strcpy(sParam,"[RUN_DELAY]");
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{ /* string has been founded */
				sscanf(sBuffer,"%s %d",sTmpBuffer,&m_AllUPS[v].m_Events[event_nr].m_RunDelay);
				//printf("[CFG]v=%d RUN_DELAY %d\n",v,m_AllUPS[v].m_Events[event_nr].m_RunDelay);
			}
///////////////////////////// email;
			strcpy(sParam,"[SEND_MAIL_DELAY]"); 	//	1
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{ /* string has been founded */
				sscanf(sBuffer,"%s %d",sTmpBuffer,&m_AllUPS[v].m_Events[event_nr].m_SendMailDelay);
				//printf("[CFG]   SEND_MAIL_DELAY %d \n",m_AllUPS[v].m_Events[0].m_SendMailDelay);
			}
			strcpy(sParam,"[SEND_MAIL_TO]");		//	"pabramczuk@fideltronik.com.pl"
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{ /* string has been founded */
				sscanf(sBuffer,"%s %s",sTmpBuffer,t);	/* read varible */
				removeSpace(t);
				m_AllUPS[v].m_Events[event_nr].m_SendMailTo=t;
//				m_AllUPS[v].m_Events[event_nr].m_SendMail=1;
				//printf("[CFG]   SEND_MAIL_TO %s\n",(char *)m_AllUPS[v].m_Events[event_nr].m_SendMailTo);
			}
			strcpy(sParam,"[SEND_MAIL_SMTP]");		//	"213.25.149.162"
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{ /* string has been founded */
				sscanf(sBuffer,"%s %s",sTmpBuffer,t);
				removeSpace(t);
				m_AllUPS[v].m_Events[event_nr].m_SendMailSMTP=t;
				//printf("[CFG]   SEND_MAIL_SMTP %s\n",(char *)m_AllUPS[v].m_Events[event_nr].m_SendMailSMTP);
            }
			strcpy(sParam,"[SEND_MAIL_FROM]");		//		"Nadawca :"
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{ /* string has been founded */
				sscanf(sBuffer,"%s %s",sTmpBuffer,t);	/* read varible */
				removeSpace(t);
				m_AllUPS[v].m_Events[event_nr].m_SendMailFrom=t;
				//printf("[CFG]   SEND_MAIL_FROM %s\n",(char *)m_AllUPS[v].m_Events[event_nr].m_SendMailFrom);
			}
			strcpy(sParam,"[SEND_MAIL_SUBJECT]");	//		"Temat mail"
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{ /* string has been founded */
				sscanf(sBuffer,"%s %s",sTmpBuffer,t);	/* read varible */
				m_AllUPS[v].m_Events[event_nr].m_SendMailSubject="aaaa";
				m_AllUPS[v].m_Events[event_nr].m_SendMailSubject=(LPCTSTR)(sBuffer+strlen(sParam)+1);
				removeEndWhite((LPCTSTR)m_AllUPS[v].m_Events[event_nr].m_SendMailSubject);
				//printf("[CFG]   SEND_MAIL_SUBJECT %s\n",(char *)m_AllUPS[v].m_Events[event_nr].m_SendMailSubject);
			}
////////////////////////// mail do zadania
			strcpy(sParam,"[SEND_MAIL_MESSAGE]");	//
			if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
			{ /* string has been founded */
				sscanf(sBuffer,"%s %s",sTmpBuffer,t);	/* read varible */
				m_AllUPS[v].m_Events[event_nr].m_SendMailMessage=(LPCTSTR)( sBuffer+strlen(sParam)+1);
				while(fgets(sBuffer,sizeof(sBuffer),f) != NULL)
				{ //dalsza czesc informacji
					strcpy(sParam,"[SEND_MAIL_MESSAGE_END]");	//
					if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
						break; //koniec informacji
					CString te=m_AllUPS[v].m_Events[event_nr].m_SendMailMessage;
					te+=sBuffer;
					m_AllUPS[v].m_Events[event_nr].m_SendMailMessage=te;
					memset(sBuffer,0,sizeof(sBuffer));
				}
				//printf("[CFG]   SEND_MAIL_MESSAGE %s\n",(char *)m_AllUPS[v].m_Events[event_nr].m_SendMailMessage);
			}
		}	//if(event_nr<=EVENT_BYPASS)
/////////////////// konfgiguracja

//////////////////// konfiguracja globalna

		//m_Cfg.m_pathLogWWW				// sciezka do loga www
	    //Z0003, LT - w ponizszych 3 ifach zamiast pobierania jest tylko porwnywanie z odczytanym options.cfg
	    //i ewentualne ostrzeganie
		strcpy(sParam,"[UPS_PORT_IP]");
		if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
		{
//			sscanf(sBuffer,"%s %d",sTmpBuffer,&m_Cfg.m_PortTCP);
//			printf("  [CFG]   Port TCP/IP %d\n",(unsigned int)m_Cfg.m_PortTCP);
            UINT tmp;
			sscanf(sBuffer,"%s %d",sTmpBuffer,&tmp);
			if(tmp != m_Cfg.m_PortTCP)
			{
			    printf("  [CFG]   Port TCP/IP: %d\n", tmp);
				printf("          niezgodnosc z opcjami globalnymi: %d\n", m_Cfg.m_PortTCP);
			}
		}
		strcpy(sParam,"[PATH_LOG]");
		if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
		{
			sscanf(sBuffer,"%s %s",sTmpBuffer,t);
			removeSpace(t);
//			m_Cfg.m_pathLog=t;
//			printf("  [CFG]   Sciezka do loga %s\n",(char *)m_Cfg.m_pathLog);
            if(strcmp(t, m_Cfg.m_pathLog.str()))
		    {
			    printf("  [CFG]   Sciezka do loga: %s\n", t);
				printf("          niezgodnosc z opcjami globalnymi: %s\n", (char *)m_Cfg.m_pathLog);
			}
		}
		strcpy(sParam,"[PATH_LOG_WWW]");
		if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
		{
			sscanf(sBuffer,"%s %s",sTmpBuffer,t);
			removeSpace(t);
//			m_Cfg.m_pathLogWWW=t;
//			printf("  [CFG]   Sciezka do loga www %s\n",(char *)m_Cfg.m_pathLogWWW);
            if(strcmp(t, m_Cfg.m_pathLogWWW.str()))
			{
    			printf("  [CFG]   Sciezka do loga www: %s\n", t);
			    printf("          niezgodnosc z opcjami globalnymi: %s\n", (char *)m_Cfg.m_pathLogWWW);
			}
/////////////////////////
// 2003.02.19
// Dodano wpis dla wszystkich ups z listy
//
//			for(v=0;v<MAX_UPS;v++)
//			{
//				m_AllUPS[v].m_pathLog=m_Cfg.m_pathLog; // kopia lokalna
//				m_AllUPS[v].m_pathLogWWW=m_Cfg.m_pathLogWWW; // kopia lokalna
//			}
		}
		//Z0003, LT - koniec
///////////////////// konkretny ups
		strcpy(sParam,"[UPS_NR]");
		if((strncmp(sBuffer,sParam,strlen(sParam))) == 0) /* string has been founded */
		{
			sscanf(sBuffer,"%s %d",sTmpBuffer,&v);	/* read varible */
			//Z0013, LT - zanim sie pojawi pierwszy event czytane parametry sa domyslne dla tego UPSa
			//i ida do n+1 pozycji w tabeli
			//sa one teraz inicjowane parametrami domyslnymi dla wszystkich UPSow
			v--;	//bylo dalej, ale teraz daje tu
			event_nr = EVENT_DEFAULT;
			if(v == 0)		//dotychczasowe parametry traktuje jako domyslne dla wszystkich UPSow
				DefaultEvent = m_AllUPS[v].m_Events[EVENT_DEFAULT];
			else			//domyslne dla wszystkich UPSow biore jako domyslne dla tego UPSa
				m_AllUPS[v].m_Events[EVENT_DEFAULT] = DefaultEvent;
			//Z0013, LT - koniec
		}
		strcpy(sParam,"[UPS_ADD_IP]");
		if((strncmp(sBuffer,sParam,strlen(sParam))) == 0)
		{ /* string has been founded */
			sscanf(sBuffer,"%s %s",sTmpBuffer,sReturnValue);	/* read varible */
//Z0013, LT - przenosze wczesniej			v-=1;
			if(v>MAX_UPS)
				printf("- Zmniejsz ilosc zasilaczy do %d\n",MAX_UPS);
			else
			{
				//m_AllUPS[v].m_pathLog=m_Cfg.m_pathLog; // kopia lokalna
				//m_AllUPS[v].m_pathLogWWW=m_Cfg.m_pathLogWWW; // kopia lokalna
				m_AllUPS[v].m_task_max=0; // inicjalizacja
				//printf("-%s- i -%s- v=%d \n",sTmpBuffer,sReturnValue,v);
				strcpy(m_Cfg.m_IP[v],sReturnValue);
				strcpy((LPCTSTR)m_AllUPS[v].m_IP,m_Cfg.m_IP[v]);
				m_AllUPS[v].m_UPSId=v;   //index UPS
				memset(m_AllUPS[v].m_Location,0,sizeof(m_AllUPS[v].m_Location));
				if((unsigned int)SizeAllUps<(unsigned int)v)
					SizeAllUps=v;//++; // ilosc UPS powiekszona o jeden
			}//else
			//SizeAllUps++; // ilosc UPS powiekszona o jeden
			//printf("Ups %d\n",v);
			//getchar();
		}
///////////////////////////// terminarz
//[TASK_UPS_OFF]    2002.10.02,16:00,DAILY
//[TASK_UPS_OFF_ON] 2002.10.03,17:15,ONCE,02:30
//[TASK_UPS_OFF_ON] 2002.10.04,1:15,WEEKLY,0:01
		int t_off=0;
		int t_restart=0;
		strcpy(sParam,"[TASK_UPS_OFF]");
		if( strncmp(sBuffer,sParam,strlen(sParam))==0 )
			t_off=1;
//printf("Linme %d %d  -%s- param -%s-%d  \n",t_o,t_o_o,sBuffer,sParam,strncmp(sBuffer,sParam,strlen(sParam)));
		strcpy(sParam,"[TASK_UPS_RESTART]");
		if( strncmp(sBuffer,sParam,strlen(sParam))==0 )
			t_restart=1;
		if(t_off || t_restart)
		{
			sscanf(sBuffer,"%s %s",sTmpBuffer,t);
			removeSpace(t);
			// jedno zdarzenie
			//PERIOD_ONCE PERIOD_DAILY PERIOD_WEEKLY
			// TASK_NONE  TASK_TURN_OFF  TASK_RESTART
			//m_Task;        // zadanie do wykonania (jedna ze stalych TASK_)
			if(t_restart)
				m_Tasks[m_AllUPS[v].m_task_max].m_Task=TASK_RESTART; //
			if(t_off)
				m_Tasks[m_AllUPS[v].m_task_max].m_Task=TASK_TURN_OFF;
////////// wczytaj czas
			int h,m;
			if((res = convertDateTask((char *)t,&m_Tasks[m_AllUPS[v].m_task_max].m_DateTime,h,m)) < 0)
		    //Z0002, LT - zwraca rezultat wyej, dotd jeli false zwraca -1
			{
				printf("Blad w konfiguracji: linia %s\n",sBuffer);
				return res;
			}
			if(strstr(t,"DAILY"))
				m_Tasks[m_AllUPS[v].m_task_max].m_Period=PERIOD_DAILY;
			if(strstr(t,"ONCE"))
				m_Tasks[m_AllUPS[v].m_task_max].m_Period=PERIOD_ONCE;
			if(strstr(t,"WEEKLY"))
				m_Tasks[m_AllUPS[v].m_task_max].m_Period=PERIOD_WEEKLY;
			if(t_restart) // opoznienie wlaczenia
				m_Tasks[m_AllUPS[v].m_task_max].m_TurnOnDelay=h*3600+m*60;
			if(m_TasksGetSize<MAX_TASKS) //ilosc zadan
				m_TasksGetSize++;
			if(m_AllUPS[v].m_task_max<MAX_TASKS)
				m_AllUPS[v].m_task_max++;
			else
				printf("- Zmniejsz ilosc zadan do %d.\n",MAX_TASKS);
		}
		memset(sBuffer,0,sizeof(sBuffer));
	} //while(fgets(sBuffer,sizeof(sBuffer),f) != NULL)
	fclose(f);
/*	for(int i = 0; i <= 1; i++)
		for(int j = 0; j <= EVENT_DEFAULT; j++)
		{
			if(m_AllUPS[i].m_Events[j].m_WarningText.IsEmpty())
				printf("U %d, e %s: %s", i, eve[j], "--------------\n");
			else
				printf("U %d, e %s: %s", i, eve[j], m_AllUPS[i].m_Events[j].m_WarningText.str());
		}
	printf("Default: %s\n", DefaultEvent.m_WarningText.str());*/
	return 1;
}


/////////////////
//
//
// odpowiednik OnRead o Marcina

void *onRead(void *UpsDlg1)
{
	ThreadCount |= THREAD_READ;
// tu rozpoczynam dzialanie i zbieram odpowiedzi
	do
	{
//		UpsDlg.getData();
		if(UpsDlg.m_Net.Receive() < 0 && !end_process)	//bd fatalny
		{
			ThreadCount &= ~THREAD_READ;
			raise(SIGTERM);
			return (void *)0;
		}
	}
//	while(/*1*/ UpsDlg.Restart==0);
	while(end_process==0);
	if(__debug)
		printf("Koniec OnRead\n");
	ThreadCount &= ~THREAD_READ;
	return (void *)0;
}

/////////////////////////////////////////////////
//
//
//
//
int CDlgMain::DlgMainInit(int argc_m,char *argv[])
{
	///// konfiguracja
	int res = 0;    //Z0002, LT
    //Z0003, LT - czytanie pliku options.cfg
//	if((res = ReadGlobalConfig(&m_Cfg.m_pathCfg, &m_Cfg.m_PortTCP, &m_Cfg.m_MyPortTCP, &m_Cfg.m_pathLog, &m_Cfg.m_pathLogWWW, &m_Cfg.m_refresh)) < 0)
	if((res = ReadGlobalConfig(&m_Cfg)) < 0)	//Z0009, LT - upraszczam, bo za duzo parametrow
	{
		printf("Blad odczytu konfiguracji globalnej.\n");
		return res;
	}
	//ponizsza petla przeniesiona z ReadConfig
	for(int v = 0; v < MAX_UPS; v++)
	{
		m_AllUPS[v].m_pathLog = m_Cfg.m_pathLog; // kopia lokalna
		m_AllUPS[v].m_pathLogWWW = m_Cfg.m_pathLogWWW; // kopia lokalna
	}
	//Z0003 - koniec
	if((res = ReadConfig()) < 0)
	{
//		//printf("Error read configuration file.\n");
//		exit(1);
//		return;
		printf("Blad odczytu konfiguracji zasilaczy.\n");
		return res;
	}
	ReadUPSModelsConfig();

	char hostname[1255]=".";
	res=gethostname(hostname,sizeof(hostname));
	if(res==0)
	{
		struct hostent *h=gethostbyname(hostname);
		if(h==NULL)
			return ERR_GETHOSTBYNAME;   //Z0002, LT
		//int i=0;
		char **adresy;
		adresy=h->h_addr_list;
		while(*adresy)
		{
			//printf("Lokal address %s %s CFG address %s\n",h->h_name,h->h_aliases[i++],inet_ntoa(*(struct in_addr*)*adresy));
			for(int j=0; j<=SizeAllUps; j++)
			{
				//printf("Przegladam 	add=-%s- IP=-%s-\n",inet_ntoa(*(struct in_addr*)*adresy),m_AllUPS[j].m_IP);
				if( (strcmp(inet_ntoa(*(struct in_addr*)*adresy),m_AllUPS[j].m_IP)==0) || (strcmp("127.0.0.1",m_AllUPS[j].m_IP)==0) || (strcmp("localhost",m_AllUPS[j].m_IP)==0))
				{
					m_AllUPS[j].m_IsLocal=1; // zakladamy ze nie jest to lokalny UPS
					//printf("---LOKALNY--\n");
				}
				else         // 2003.02.24 byl blad uzyt i zamiast j
					m_AllUPS[j].m_IsLocal=0; // zakladamy ze nie jest to lokalny UPS
				//printf("Adres %s, IP %s\n",(char *)m_AllUPS[j].m_Address,m_AllUPS[j].m_IP)	;
				//strcpy(m_AllUPS[j].m_IP,(char *)m_AllUPS[j].m_Address);
				m_AllUPS[j].m_IsIPInitialized=1;
			}
			adresy++;
		}
	}
	else
	{
		if(__debug)
			printf("Error 1\n");
	}

	for(int i=0; i<=SizeAllUps; i++)
	{
		//printf("Czy nazwa -%s-\n",m_AllUPS[i].m_IP);
		struct hostent *h=gethostbyname(m_AllUPS[i].m_IP);
		if(h==NULL)
		{
			//printf("Brak nazwy dla hosta\n");
			memcpy(m_AllUPS[i].m_Address, m_AllUPS[i].m_IP, sizeof(m_AllUPS[i].m_Address));
		}
		else
		{
			char **adresy;
			adresy=h->h_addr_list;
			while(*adresy)
			{
				//printf("\n\r adresy -%s-\n",inet_ntoa(*(struct in_addr*)*adresy));
				CString tmp;
				tmp=m_AllUPS[i].m_IP;
				//printf("Tmp %s\n",(char *)tmp);
				strcpy(m_AllUPS[i].m_IP,inet_ntoa(*(struct in_addr*)*adresy));
				//printf("IP %s  ip %s\n",m_AllUPS[i].m_IP,inet_ntoa(*(struct in_addr*)*adresy));
				strcpy(m_AllUPS[i].m_Address,(char *)tmp);
				//printf("IP %s,Adres %s\n",(char *)m_AllUPS[i].m_IP,(char *)m_AllUPS[i].m_Address);
				adresy++;
			}
			//adresy=h->h_aliases;
			//while(*adresy){
				//printf("Alias %s\n",*adresy++);}
		}
		//printf("Adresy lokalne %s %s -%s-\n",h->h_name,h->h_aliases[i++],inet_ntoa(*(struct in_addr*)*adresy));
		if(inet_addr(m_AllUPS[i].m_Address)!=INADDR_NONE)
		{ // tu wchodzi jak numerki
			//printf("Nie lokalny %d %s\n",i,m_AllUPS[i].m_Address);
			memcpy(m_AllUPS[i].m_IP, m_AllUPS[i].m_Address, sizeof(m_AllUPS[i].m_IP));
			m_AllUPS[i].m_IsIPInitialized=1;
			//m_AllUPS[i].m_IsLocal=0; // zakladamy ze nie jest to lokalny UPS
		}
		else
		{
			strncpy(m_AllUPS[i].m_HostName,m_AllUPS[i].m_Address,MAX_HOST_NAME);
			m_AllUPS[i].m_IsIPInitialized=1;
			//printf("Nazwy %s\n",m_AllUPS[i].m_Address);
			// wywolujemy asynchroniczna wersje gethostbyname
			//m_AllUPS[i]->m_GetHostByName=WSAAsyncGetHostByName(m_hWnd,WM_USER_GETHOSTBYNAME,
			//m_AllUPS[i]->m_HostName,m_AllUPS[i]->m_HostEntry,MAXGETHOSTSTRUCT);
		}
	}

	CheckLocalUPS(TRUE);
	//Z0008, LT - zainicjowanie pamieci dzielonej musi byc wczesniej - tu wyciete
	 //initNCurses();
//	if(!m_Net.Connect(UPSmon_CLN_PORT))
	if(!m_Net.Connect(m_Cfg.m_MyPortTCP, m_Cfg.m_PortTCP))	//Z0006, LT - oba porty, pobrane z pliku opcji
	{
//Z0020, LT - teraz wewnatrz		perror("Connect :");
//		exit(0);
		return ERR_CONNECT;     //Z0002, LT
	}
	if ( pthread_create( &UpsDlg.mythread,(pthread_attr_t  *)0,onRead,(void *)&UpsDlg) )
	{ //watek obsluguje RS
		perror("error creating thread onRead.");
		//getchar();
		return ERR_THREADCREATE_ONREAD;     //Z0002, LT
	}
	if(__debug)
		printf("+ Create thread onReadUdp SUCCESS [%ld]\n\r",UpsDlg.mythread);

	if(__ncurr)
	{
		;//printf("Zamiast2 initNCur\n");
	}
	else
	{
		initNCurses();
	}//__ncur

	if ( pthread_create( &UpsDlg.mythreadTask,(pthread_attr_t  *)0,onTimerTask,(void *)&UpsDlg) )
	{ //watek obsluguje RS
		perror("error creating thread onTimer.");
		//getchar();
		return ERR_THREADCREATE_ONTIMERTASK;    //Z0002, LT
	}
	if(__debug)
		printf("+ Created thread OnTimer SUCCESS \n");

	for(int i=0; i<=SizeAllUps; i++)
	{
		SetCurrEvent(&m_AllUPS[i],EVENT_PRG_START);
		if((res = DoAction(&m_AllUPS[i],i)) < 0)       //Z0002, LT
			return res;
	}
	return 1;
}

//Z0008, LT - wyodrebniona funkcja, wolana wczesniej
//ilosc bajtow zmniejszona do 1, niepotrzebne parametry wyciete
void CDlgMain::InitSharedMem()
{
//Z009, LT - jest juz w konstruktorze	m_SharedMem.Create();
	m_SharedMem.Set(0, sizeof(BYTE), SHARED_MEM_OFFSET);		//Z0009, LT - nie trzeba az 10 bajtow
	m_SharedMem.Set(0, sizeof(int), SHARED_MEM_RESULT);
}
//Z0008, LT - koniec

//////////////////////
int CDlgMain::convertDateTask(char *t, time_t *m_DateTime, int &hour, int &min)
{
	tm ti_task;
	char *ptr;
	char tmp[50];

	hour=0;
	min=0;
	ptr = strstr(t,",");
	//printf("Koniec daty %s\n",ptr);
	if(ptr==NULL)
		return ERR_CONVERTDATETASK1;    //Z0002, LT
	memset(tmp,0,sizeof(tmp));
	strncpy(tmp,t,(int)(ptr-t));
	//printf("Data -%s-\n",tmp);
	sscanf(tmp,"%d.%d.%d",&ti_task.tm_year,&ti_task.tm_mon,&ti_task.tm_mday);	/* read varible */
	ti_task.tm_year-=1900;
	ti_task.tm_mon-=1;

	t=ptr+1; //poczatek czasu
	ptr = strstr(t,",");
	if(ptr==NULL)
		return ERR_CONVERTDATETASK2;    //Z0002, LT

	memset(tmp,0,sizeof(tmp));
	strncpy(tmp,t,(int)(ptr-t));
	sscanf(tmp,"%d:%d",&ti_task.tm_hour,&ti_task.tm_min);	/* read varible */

	ti_task.tm_sec=0;

	time_t res=mktime(&ti_task);
	if(res==-1)
	{
		printf("Blad konwersji\n");
		return ERR_CONVERTDATETASK3;    //Z0002, LT
	}
	*m_DateTime=res;

	time_t time_n,time_e;
	time_e=time(&time_n);
	if(time_e!=time_n)
		perror("time error :");
	t=ptr+1; //poczatek typu ONEC
	ptr = strstr(t,",");
	if(ptr==NULL)
		return 1;
	t=ptr+1; //poczatek czasu typu
	memset(tmp,0,sizeof(tmp));
	strncpy(tmp,t,5);
	int h,m;
	sscanf(tmp,"%d:%d",&h,&m);	/* read varible */
	hour=h;
	min=m;
	return 1;
}


/////////////////////////////////////////////////////////////////////////////
// Zmienionop klada mailcln otrzymala sam zapis do loga i kopie potrzebnych zmiennych
//
void CDlgMain::OnSendMailEnd(BYTE ErrorCode, DWORD UPSId)
{
	if(ErrorCode==MAIL_DISCONNECT_OK)
		return;
	for(int i=SizeAllUps; i>=0; i--)
	{
		if(m_AllUPS[i].m_UPSId==UPSId)
		{
//			if(ErrorCode==MAIL_DISCONNECT_ABORT)
//				m_Log.Add(&m_AllUPS[i],STATUS_GETTING_DATA,LOG_ERR_SEND_MAIL_ABORT);
//			else
				m_Log.Add(&m_AllUPS[i],STATUS_GETTING_DATA,LOG_ERR_SEND_MAIL);
			return;
		}
	}
} // CDlgMain::OnSendMailEnd


/////////////////////////////////////////////////////////////////////////////
void CDlgMain::StopUPSMon()
{
	static BOOL wasStop=FALSE;
	if(wasStop)
		return; // zabezpieczenie przed podwojnym wykonaniem
	wasStop=TRUE;

	//pierwsza faza zamykania: czynnoci przy zamkniciu
	for(int i=0; i<=SizeAllUps; i++)
	{
		SetCurrEvent(&m_AllUPS[i],EVENT_PRG_STOP);
		DoAction(&m_AllUPS[i],i);
	}
	end_process = 1;
	//druga faza: zakaczanie wtkw
	m_Net.Disconnect();						//bez tego si nie skoczy
	m_Mail.Stop();
	while(ThreadCount != THREAD_MAIN)
		usleep(100000);
//	m_Mail.Stop();
//LT: tego nie wolno w kliencie!
//Z0009, LT - lepiej exit, bo wiem,ze zmniejszy raz		m_SharedMem.Destroy();	//Z0008, LT - chyba jednak wolno
	exit(0);	//Z0009, LT
	//WriteConfig();
} // CDlgMain::StopUPSMon

///////////////


void info(void)
{
//	printf("\n\n\n\n");
	printf("--------------------------------------------------------\n");
//	printf("|                                                      |\n");
	printf("|      UPS Monitor Klient wersja %-10s            |\n",ver);
	printf("|      Fideltronik www.fideltronik.com                 |\n");
//	printf("|                                                      |\n");
	printf("|                                  Krakow %-12s |\n",datReal);
//	printf("|                                                      |\n");
	printf("--------------------------------------------------------\n");//\n\n");
}

int main(int argc,char *argv[])
{
    int res = 0;
	info();

	__debug=0;
	__ncurr=1;

	if(argc>1)
	{
		if(strcmp(argv[1],"-d")==0)
		{
			__debug=1;
			printf("Wersja debug.\n");
		}
		if(strcmp(argv[1],"-n")==0)
		{
			__ncurr=0;
			printf("Wersja ncurr.\n");
		}
	}
	if(argc>2)
	{
		if(strcmp(argv[1],"-n")==0 || strcmp(argv[2],"-n")==0)
		{
			__ncurr=0;
			printf("Wersja screan.\n");
		}
	}
	//printf("\n\n\t Ups Monitor 3.0 ver %s date %s \n\n\t Fideltronik Krakow www.fideltronik.com.pl\n\n",ver,datReal);

	UpsDlg.InitSharedMem();	//Z0008, LT - musi byc przed forkiem

////////////////////////////// uruchomienie systemu jako demon
	signal(SIGCHLD, sighandler);	//Z0008, LT
	if(__debug==0)
	{
		UpsDlg.SetExitCode(ERR_INTERPROCESSTIMEOUT);	//Z0008, LT - zainicjowanie rezultatu
		int pid=fork();
		if(pid<0)
		{
			printf("Blad uruchomienia demona\n");
			perror("Start ");
			exit(-ERR_FORK);		//Z0008, LT
		}
		if(pid>0)
		{ //parent
			//printf("Parent pid=%d\n",pid);
			//Z0008, LT - czekanie na zakonczenie inicjalizacji
//			sleep(1);
//			exit(0);
			int timeout = 30;
			while(--timeout)
			{
				int	mem = UpsDlg.GetExitCode();
				if(mem != ERR_INTERPROCESSTIMEOUT)
				{
//					printf("zwracam %d\n", -mem);
					exit(-mem);		//zwracam kod wykonania operacji polaczenia z UPSem (w tym 0)
				}
				sleep(1);
			}
			exit(-ERR_INTERPROCESSTIMEOUT);
			//Z0008, LT - koniec
		}
		(void)setsid();
		setpgrp();
//tymcz Niedozwolone!!!		signal(SIGCHLD,SIG_IGN);
		//signal(SIGCLD,SIG_IGN);
		umask(0);
		//close(0); //stdin
		//close(1); //stderr
		if(__debug)
			printf("+ Deamon created SUCCESS\n");
	}
/////////////////////////////

	signal(SIGHUP,sighandler);
	signal(SIGTERM,sighandler);
	signal(SIGUSR1,sighandler);		//Z0012, LT - obsluga sygnalu w celu wypisania statusu
	ThreadCount |= THREAD_MAIN;
	if(__debug)
		printf("-----------------DialogMainInit\n");
	if((res = UpsDlg.DlgMainInit(argc,argv)) < 0 || (res = UpsDlg.OnUPSMonStart(1)) < 0)
	{
		UpsDlg.SetExitCode(res);	//Z0008, LT
		UpsDlg.KillAll(res);	//zamykanie programu na wasn rk
	}
	else
	{
		UpsDlg.SetExitCode(res);	//Z0008, LT
//		for(int j = 0; 1; j++)
		while(!Killing)			//teraz si wszystko odbywa
		{
			// tu zyjemy
			if(tickTimer)
			{
				tickTimer = 0;
				if((res = UpsDlg.OnTimer(1)) < 0)
					UpsDlg.KillAll(res);
			}
			if((res = UpsDlg.getData()) < 0)
				UpsDlg.KillAll(res);
			usleep(50000);
//			usleep(100000);

//			if(UpsDlg.Restart == 1)
//			{
//				if(__debug)
//					printf("Zakonczenie programu main\n");
//				sleep(5);
//				break;
//			}
		}
		UpsDlg.StopUPSMon();
		ThreadCount &= ~THREAD_MAIN;
	}
	if(__debug)
		printf("----------------Mon Start koniec\n");
//	UpsDlg.~CDlgMain();
//	if(__debug)
//		printf("sleep 30\n");
//	sleep(30);
//	if(__debug)
//		printf("----------------Mon Start Nowy\n");
	exit(0);
}

void	CDlgMain::KillAll(int res)
{
	int	i;
	printf("\nBlad fatalny kod %d! Program zostanie zamkniety.\n", -res);
	sleep(2);
	Killing = end_process = 1;
	m_Net.Disconnect();
	for(i = 0; i <= SizeAllUps; i++)
		m_Mail.Stop();
	//najpierw zmniejszam licznik, eby signal zadziaa
	ThreadCount &= ~THREAD_MAIN;
	raise(SIGTERM);
}


//	2003.01.13, MW
//	Funckja odczytuje i zwraca wartosc flagi CloseSystem
//	dla zdarzenia "Planowe wylaczenie zasilacza" dla lokalnego UPS-a
//  Informacja o tym potrzebna jest serwerowi, w przypadku wspolpracy
//  z UPS-em stykowym
//	Zalozono, ze UPS lokalny jest w konfiguracji, inaczej ta funkcja nie
//  bedzie wolana, bo pakiet wylaczenia zasilacza nie jest wysylany do
//  urzadzen nielokalnych
BYTE CDlgMain::GetLocalUPSCloseSysFlag()
{
//	for(int i=UpsDlg.GetSize()-1; i>=0; i--)
	for(int i = UpsDlg.GetSize(); i>=0; i--)	//LT przecie przy 1 UPS
		if(m_AllUPS[i].m_IsLocal)
			return m_AllUPS[i].m_Events[EVENT_UPS_GOING_OFF].m_CloseSystem;
	return 0;
}
