///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/23 13:43:34 $
//         $Locker:  $
//         $Revision: 1.12 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Komunikacja sieciowa
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: netdatag.cpp,v $
// Revision 1.12  2004/07/23 13:43:34  ltokarski
// Z0020 - poprawiony sporadyczny blad zwiazany z niezwolnieniem socketa i perror po Connect
//
// Revision 1.11  2004/06/23 14:07:10  ltokarski
// no message
//
// Revision 1.10  2004/06/23 08:40:32  ltokarski
// Z0006 - zmienne numery portow
//
// Revision 1.8  2004/06/09 11:31:07  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////

#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/un.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <netdb.h>

#include "cstr.h"
#include "linux_ty.h"
#include "netdatag.h"
#include "upsmon.h"

extern int errno;
extern int __debug;
extern int __ncurr;

extern void DbLine(char *str);

/////////////////////////////////////////////////////////////////////////////
CNetDatagram::CNetDatagram()
{
	//m_UPSSrv=NULL;
	m_Socket=0;
} // CNetDatagram::CNetDatagram


/////////////////////////////////////////////////////////////////////////////
CNetDatagram::~CNetDatagram()
{
	if(m_Socket!=0)
		Disconnect();
} // CNetDatagram::~CNetDatagram


/////////////////////////////////////////////////////////////////////////////
bool CNetDatagram::Connect( unsigned int Port, unsigned int serverPort)	//Z0006, LT - rowniez port serwera
{
	//m_UPSSrv=UPSSrv;

	//printf("CNetDatagram::Connect\n");
	if(m_Socket!=0)
		Disconnect();
	m_Socket=socket(AF_INET,SOCK_DGRAM,0);
	if(__debug)
		printf("CNetDatagram m_Socket %d Porty: client=%d server=%d\n", m_Socket, Port, sPort);

	if(m_Socket<0)
	{
//Z0020, LT		printf("Blad otwarcia socketa\n");
//Z0020, LT		if(__debug)
		perror("socket");
		return FALSE;
	}
	//Z0020, LT - zabezpieczenie gdyby socket jeszcze nie byl zwolniony
	int i;
	if(setsockopt(m_Socket, SOL_SOCKET, SO_REUSEADDR, &i, sizeof(int)) < 0)
	{
	    perror("setsockopt");
	    return FALSE;
	}
	//Z0020, LT - koniec

	add_ser.sin_family=AF_INET;
	add_ser.sin_addr.s_addr=htonl(INADDR_ANY); //odbieranie
	add_ser.sin_port=htons(Port);
	memset(&(add_ser.sin_zero),0,8);
	serlen=sizeof(add_ser);
	int res=bind(m_Socket,(struct sockaddr *)&add_ser,serlen);
	if(res==-1)
	{
		perror("bind");
		if(close(m_Socket) < 0)
		    perror("close");
		m_Socket=0;
		return FALSE;
	}
	sPort = serverPort;		//Z0006, LT - numer portu serwera pobrany z konfiguracji
	return TRUE;
 } // CNetDatagram::Connect

/////////////////////////////////////////////////////////////////////////////
void CNetDatagram::Disconnect()
{
	int res=0;
	if(m_Socket!=0)
	{
		//delete m_Socket;
		int sok = m_Socket;
		m_Socket=0;
		res=close(sok);
//		m_Socket=0;
		if(res==-1)
			perror("Close Socket :");
	}
	if(__debug)
		printf("Close socket s=%d r=%d \n",m_Socket,res);
	Acknowledge();
} // CNetDatagram::Disconnect


/////////////////////////////////////////////////////////////////////////////
BOOL CNetDatagram::SendTo(LPCTSTR Addr, BYTE Type, BYTE *Data, int DataLen)
{
	if(m_Socket==0)
		return FALSE;

//	printf("SendTo %d\n", (int)Type);	//tymcz
	//printf("sendTo socket=%d 2\n",m_Socket);
	struct hostent *he;
	BYTE buff[UDP_MAX_PACKET_LEN];
	buff[0]=Type;
	buff[1]=(BYTE)DataLen;
	if(DataLen>0)
		memcpy(buff+2,Data,DataLen);
	unsigned short crc=CalcCRC(buff,2+DataLen);
	memcpy(buff+2+DataLen,&crc,2);

	struct sockaddr_in	add;
	if( (he=gethostbyname(Addr))==NULL)
	{
		perror("gethostbyname 1 ");
		if(__debug)
			printf("Addr -%s-\n",Addr);
		return FALSE;
	}
	add.sin_addr=*((struct in_addr *)he->h_addr);
	add.sin_family=AF_INET;
//	add.sin_port=htons(UPSmon_SRV_PORT);
	add.sin_port = htons(sPort);	//Z0006, LT - port serwera odczytany z konfiguracji
	memset(&(add.sin_zero),0,8);

	int res=sendto(m_Socket,buff,4+DataLen,0,(struct sockaddr *)&add,sizeof(sockaddr));
	if(res==-1)
	{
		if(__debug)
			printf("sendTo Error %s\n",Addr);
		perror("SendTo ");
		return FALSE;
	}
	return TRUE;
} // CNetDatagram::SendTo

static BYTE buff[UDP_MAX_PACKET_LEN];
volatile int len;

/////////////////////////////////////////////////////////////////////////////
int CNetDatagram::Receive()
{
	clilen=sizeof(struct sockaddr);
	memset((void *)&add_cli,0,sizeof(add_cli));
	int res;
	res=recvfrom(m_Socket,buff,UDP_MAX_PACKET_LEN-1,0,(struct sockaddr *)&add_cli,(socklen_t *)&clilen);
//	printf("Receive %02X len=%d\n", (int)buff[0], res);
	if(m_Socket == 0)		//ju zamkniety
	{
		if(__debug)
			printf("Socket zamknity\n");
		return -1;
	}
	//printf("Rec res=%d\n",res);
	if(res==-1)
	{
		if(__debug)
			printf("Rec res=%d\n\r",res);
		perror("Recvfrom ");
		return res;
	}
	len=res;
	while(len)
		usleep(50000);
	return 1;
}

/////////////////////////////////////////////////////////////////////////////
int CNetDatagram::OnReceive(UCHAR *Addr,UCHAR *buff_in,int *DataLen)
{
	static int offset=0;
//	char add[50];
	int port;
//	strcpy(add,inet_ntoa(add_cli.sin_addr));
	//printf("Odebralem dane z portu %d %d\n",add_cli.sin_port,ntohs(add_cli.sin_port));
	//port=add_ser.sin_port=htons(8881); dane przychodza z portu 8881
	//port=8882;  //CO TO
	port=ntohs(add_cli.sin_port);
	if(len>0)
	{
		offset = 0;		//tymcz
		offset+=len;
		if(CheckPacket(buff,offset))
		{
//			strcpy((char *)Addr,add);
			strcpy((char *)Addr, inet_ntoa(add_cli.sin_addr));
			memcpy(buff_in,buff,len);
			*DataLen=len;
			offset=0;
			return TRUE;
		}
		printf("Blad crc %02X%02X%02X len=%d\n",
			(int)buff[0], (int)buff[1], (int)buff[2], len);
		return false;
	}
	return FALSE;
} // CNetDatagram::OnReceive

void	CNetDatagram::Acknowledge()
{
	len = 0;
}


/////////////////////////////////////////////////////////////////////////////
BOOL CNetDatagram::CheckPacket(BYTE *Buff, int Len)
{
	if(Len<4)
		return FALSE;
	if(Len!=((int)Buff[1]+4))
		return FALSE;
	unsigned short crc, calcCrc=CalcCRC(Buff,Len-2);
	memcpy(&crc,Buff+(Len-2),2);
	if(crc!=calcCrc)
		return FALSE;
	//printf("Mam pakiet -%s- %02X %02X %02X %02X OK\n",Buff,Buff[0],Buff[1],Buff[2],Buff[3]);
	return TRUE;
} // CNetDatagram::CheckPacket


/////////////////////////////////////////////////////////////////////////////
unsigned short CNetDatagram::CalcCRC(BYTE *Buff, int Len)
{
	unsigned short crc=0;
	for(int i=0; i<Len; i++)
	{
		crc+=(unsigned short)Buff[i];
		//printf("Crc=%04X, %02X\n",crc,Buff[i]);
	}
	return crc;
} // CNetDatagram::CalcCRC


// EOF //////////////////////////////////////////////////////////////////////


