///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/08 15:08:46 $
//         $Locker:  $
//         $Revision: 1.9 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Analiza pliku konfiguracji
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: upsconfig.cpp,v $
// Revision 1.9  2004/07/08 15:08:46  ltokarski
// Z0014 - poprawione bledy w CString
//
// Revision 1.8  2004/06/23 14:07:10  ltokarski
// no message
//
// Revision 1.7  2004/06/23 08:40:32  ltokarski
// Z0006 - zmienne numery portow
//
// Revision 1.5  2004/06/09 11:31:07  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////

#include <string.h>
#include "cstr.h"
#include "linux_ty.h"
#include "upsmon.h"
#include "html.h"
#include "upsconfig.h"

extern int __debug;

//IMPLEMENT_SERIAL(CUPSEventCfg,CObject,1)
//IMPLEMENT_SERIAL(CUPSConfig,CObject,1)
//IMPLEMENT_SERIAL(CUPSMonConfig,CObject,1)

/////////////////////////////////////////////////////////////////////////////
CUPSEventCfg::CUPSEventCfg()
{
//printf("CUPSEventCfg::CUPS\n");
	SetDefaultLog();
	SetDefaultWarning();
	SetDefaultRun();
	SetDefaultSendMail();
	SetDefaultCloseSystem();
} // CUPSEventCfg::CUPSEventCfg

/////////////////////////////////////////////////////////////////////////////
void CUPSEventCfg::SetDefaultLog()
{
	m_WriteToLog=EVENT_DEF_WRITE_TO_LOG;
} // CUPSEventCfg::SetDefaultLog

/////////////////////////////////////////////////////////////////////////////
void CUPSEventCfg::SetDefaultWarning()
{
	m_Warning=EVENT_DEF_WARNING;
	m_WarningText=EVENT_DEF_WARNING_TEXT;
	m_WarningFirstDelay=EVENT_DEF_WARNING_FIRST_DELAY;
	m_WarningShowNext=EVENT_DEF_WARNING_SHOW_NEXT;
	m_WarningNextDelay=EVENT_DEF_WARNING_NEXT_DELAY;
} // CUPSEventCfg::SetDefaultWarning

/////////////////////////////////////////////////////////////////////////////
void CUPSEventCfg::SetDefaultRun()
{
	m_Run=EVENT_DEF_RUN;
	m_RunProg=EVENT_DEF_RUN_PROG;
	m_RunDelay=EVENT_DEF_RUN_DELAY;
} // CUPSEventCfg::SetDefaultRun

/////////////////////////////////////////////////////////////////////////////
void CUPSEventCfg::SetDefaultSendMail()
{
	m_SendMail=EVENT_DEF_SEND_MAIL;
	m_SendMailDelay=EVENT_DEF_SEND_MAIL_DELAY;
	m_SendMailTo=EVENT_DEF_SEND_MAIL_TO;
	m_SendMailSMTP=EVENT_DEF_SEND_MAIL_SMTP;
	m_SendMailFrom=EVENT_DEF_SEND_MAIL_FROM;
	m_SendMailSubject=EVENT_DEF_SEND_MAIL_SUBJECT;
	m_SendMailMessage=EVENT_DEF_SEND_MAIL_MESSAGE;
//#define EVENT_DEF_SEND_MAIL                 0   // wyslanie mail/SMS: 0-nie, 1-tak
//#define EVENT_DEF_SEND_MAIL_DELAY           10  // opoznienie wyslania mail/SMS (sek.)
//#define EVENT_DEF_SEND_MAIL_TO              ""  // odbiorca wiadomosci
//#define EVENT_DEF_SEND_MAIL_SMTP            ""  // adres serwera SMTP
//#define EVENT_DEF_SEND_MAIL_FROM            ""  // nadawca wiadomosci
//#define EVENT_DEF_SEND_MAIL_SUBJECT         ""  // temat wiadomosci
//#define EVENT_DEF_SEND_MAIL_MESSAGE         ""  // tekst wiadomosci

} // CUPSEventCfg::SetDefaultSendMail


/////////////////////////////////////////////////////////////////////////////
void CUPSEventCfg::SetDefaultCloseSystem()
{
	m_CloseSystem=EVENT_DEF_CLOSE_SYSTEM;
	m_CloseSystemDelay=EVENT_DEF_CLOSE_SYSTEM_DELAY;
	m_CloseSystemMode=EVENT_DEF_CLOSE_SYSTEM_MODE;
	m_CloseSystemRunUPS=EVENT_DEF_CLOSE_SYSTEM_RUN_UPS;
	m_CloseSystemTurnOffUPS=EVENT_DEF_CLOSE_SYSTEM_TURN_OFF_UPS;

} // CUPSEventCfg::SetDefaultCloseSystem

/////////////////////////////////////////////////////////////////////////////
BOOL CUPSEventCfg::IsDifferentLog(const CUPSEventCfg &Event)
{
	if(m_WriteToLog!=Event.m_WriteToLog)
		return TRUE;
	return FALSE;
} // CUPSEventCfg::IsDifferentLog


/////////////////////////////////////////////////////////////////////////////
BOOL CUPSEventCfg::IsDifferentWarning(const CUPSEventCfg &Event)
{
//	if(m_Warning!=Event.m_Warning) return TRUE;
//	if(m_Warning==0) return FALSE;
//	if(m_WarningText!=Event.m_WarningText) return TRUE;
//	if(m_WarningFirstDelay!=Event.m_WarningFirstDelay) return TRUE;
//	if(m_WarningShowNext!=Event.m_WarningShowNext) return TRUE;
//	if(m_WarningNextDelay!=Event.m_WarningNextDelay) return TRUE;
//	return FALSE;
	return TRUE;
} // CUPSEventCfg::IsDifferentWarning


/////////////////////////////////////////////////////////////////////////////
BOOL CUPSEventCfg::IsDifferentRun(const CUPSEventCfg &Event)
{
//	if(m_Run!=Event.m_Run) return TRUE;
//	if(m_Run==0) return FALSE;
//	if(m_RunProg!=Event.m_RunProg) return TRUE;
//	if(m_RunDelay!=Event.m_RunDelay) return TRUE;
//	return FALSE;
	return TRUE;
} // CUPSEventCfg::IsDifferentRun


/////////////////////////////////////////////////////////////////////////////
BOOL CUPSEventCfg::IsDifferentSendMail(const CUPSEventCfg &Event)
{
//	if(m_SendMail!=Event.m_SendMail) return TRUE;
//	if(m_SendMail==0) return FALSE;
//	if(m_SendMailDelay!=Event.m_SendMailDelay) return TRUE;
//	if(m_SendMailTo!=Event.m_SendMailTo) return TRUE;
//	if(m_SendMailSMTP!=Event.m_SendMailSMTP) return TRUE;
//	if(m_SendMailFrom!=Event.m_SendMailFrom) return TRUE;
//	if(m_SendMailSubject!=Event.m_SendMailSubject) return TRUE;
//	if(m_SendMailMessage!=Event.m_SendMailMessage) return TRUE;
//	return FALSE;
	return TRUE;
} // CUPSEventCfg::IsDifferentSendMail


/////////////////////////////////////////////////////////////////////////////
BOOL CUPSEventCfg::IsDifferentCloseSystem(const CUPSEventCfg &Event)
{
//	if(m_CloseSystem!=Event.m_CloseSystem) return TRUE;
//	if(m_CloseSystem==0) return FALSE;
//	if(m_CloseSystemDelay!=Event.m_CloseSystemDelay) return TRUE;
//	if(m_CloseSystemMode!=Event.m_CloseSystemMode) return TRUE;
//	if(m_CloseSystemRunUPS!=Event.m_CloseSystemRunUPS) return TRUE;
//	if(m_CloseSystemTurnOffUPS!=Event.m_CloseSystemTurnOffUPS) return TRUE;
//	return FALSE;
	return TRUE;
} // CUPSEventCfg::IsDifferentCloseSystem

/////////////////////////////////////////////////////////////////////////////
CUPSConfig::CUPSConfig()
{
	m_UPSId=0;
	for(int i=0;i<SIZE_ODCZYT;i++)
		m_Odczyty[i]=ODCZYT_WYLACZONY;
	for(int i=0;i<SIZE_PANEL;i++)
		m_Panele[i]=PANEL_WYLACZONY;

	m_GetHostByName=0;
	m_IsIPInitialized=0;
	m_IsLocal=0;

	m_Status=STATUS_GETTING_DATA;
	m_CurrEvent=-1;
	m_LogDone=1;
	m_WarningDone=1;
	m_RunDone=1;
	m_SendMailDone=1;
	m_CloseSystemDone=1;

	m_TurnOffPacketOut=0;
	m_TurnOffPacketOutNum=0;
	InitData();
	//printf("CupsConfgi start3\n");
	//getchar();
} // CUPSConfig::CUPSConfig


/////////////////////////////////////////////////////////////////////////////
CUPSConfig::~CUPSConfig()
{
	//if(m_GetHostByName!=0)
	//   WSACancelAsyncRequest(m_GetHostByName);
	//if(m_WarningWindow) m_WarningWindow->DestroyWindow();
} // CUPSConfig::~CUPSConfig

/////////////////////////////////////////////////////////////////////////////
void CUPSConfig::InitData()
{
	m_NormalPacketOutType=UDP_PACKET_CONNECT;
	m_NormalPacketOutNum=0;
	m_CanAutostart=0;
	m_CanTurnOff=0;
	//m_PacketOut=0;
	strcpy(m_Manufacturer,STR_VAL_GETTING_DATA);
	strcpy(m_Model,STR_VAL_GETTING_DATA);
	strcpy(m_SoftVer,STR_VAL_GETTING_DATA);
	m_BatCondition=VAL_GETTING_DATA;
	m_BatStatus=VAL_GETTING_DATA;
	m_BatVol=VAL_GETTING_DATA;
	m_InVol=VAL_GETTING_DATA;
	m_OutCurrent=VAL_GETTING_DATA;
	m_OutLoad=VAL_GETTING_DATA;
	m_OutPower=VAL_GETTING_DATA;
	m_OutSource=VAL_GETTING_DATA;
	m_OutVol=VAL_GETTING_DATA;

} // CUPSConfig::InitData


/////////////////////////////////////////////////////////////////////////////
void CUPSConfig::CopyEvents(const CUPSConfig *Cfg)
{
	if(__debug)
		printf("CopyEvents \n");
	getchar();
	for(int i=0;i<SIZE_EVENTS;i++)
		m_Events[i]=Cfg->m_Events[i];
} // CUPSConfig::CopyEvents

/////////////////////////////////////////////////////////////////////////////
CUPSMonConfig::CUPSMonConfig()
{
	m_PortTCP=UPSmon_SRV_PORT;
	m_MyPortTCP=UPSmon_CLN_PORT;	//Z0006, LT
	m_ReadOnly=0;
	m_HideMonTab=0;
	m_CurrUPS=-1;

} // CUPSMonConfig::CUPSMonConfig

/////////////////////////////////////////////////////////////////////////////
CTaskConfig::CTaskConfig()
{
	m_Task=TASK_NONE;
} // CTaskConfig::CTaskConfig



// EOF //////////////////////////////////////////////////////////////////////
