///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/30 16:43:16 $
//         $Locker:  $
//         $Revision: 1.7 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Analiza plikw konfiguracji
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: upsconfig.h,v $
// Revision 1.7  2004/06/30 16:43:16  ltokarski
// Z0009 - uporzadkowanie pamieci dzielonej
//
// Revision 1.6  2004/06/23 14:07:10  ltokarski
// no message
//
// Revision 1.5  2004/06/23 08:40:32  ltokarski
// Z0003 - czytanie pliku options.cfg
//
// Revision 1.3  2004/06/09 11:31:07  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////

#ifndef _UPSConfig_h_
#define _UPSConfig_h_

//#include <sys/times.h>
#include <time.h>

class CTaskConfig
{
public:
   BYTE         m_Task;        // zadanie do wykonania (jedna ze stalych TASK_)
   long         m_TurnOnDelay; // istotne tylko gdy m_Task==TASK_RESTART
   BYTE         m_Period;      // okres wykonywania zadania (jedna ze stalych PERIOD_)
   //COleDateTime m_DateTime;    // data i czas wykonania zadania
   time_t 		m_DateTime ;    // data i czas wykonania zadania
   int 			GetSize;
   //DECLARE_SERIAL(CTaskConfig)
   CTaskConfig();
   //void Serialize(CArchive& Ar);
};

class CUPSEventCfg
{
public:
   BYTE m_WriteToLog;                  // ==1 gdy mamy zapisac do log

   BYTE m_Warning;                     // ==1 gdy mamy ostrzegac
   CString m_WarningText;              // tekst ostrzezenia
   UINT m_WarningFirstDelay;           // opoznienie pierwszego ostrzezenia
   UINT m_WarningShowNext;             // czy nalezy pokazywac kolejne ostrzezenia
   UINT m_WarningNextDelay;            // opoznienie kolejnych ostrzezen

   BYTE m_Run;                         // ==1 gdy mamy uruchomic program
   CString m_RunProg;                  // program do uruchomienia
   UINT m_RunDelay;                    // opoznienie uruchomienia programu

   BYTE m_SendMail;                    // ==1 gdy mamy wyslac mail/SMS
   UINT m_SendMailDelay;               // opoznienie wyslania mail/SMS
   CString m_Balast;               // odbiorca
   CString m_SendMailTo;               // odbiorca
   CString m_SendMailSMTP;             // adres serwera SMTP
   CString m_SendMailFrom;             // nadawca
   CString m_SendMailSubject;          // temat
   CString m_SendMailMessage;          // wiadomosc

   BYTE m_CloseSystem;                 // ==1 gdy mamy zamknac system
   UINT m_CloseSystemDelay;            // opoznienie zamkniecia systemu (sek.)
   UINT m_CloseSystemMode;             // tryb zamkniecia systemu (normal/forced)
   UINT m_CloseSystemRunUPS;           // ==1 gdy UPS ma byc automatycznie uruchomiony
   UINT m_CloseSystemTurnOffUPS;       // ==1 gdy mamy wylaczyc UPS

   //DECLARE_SERIAL(CUPSEventCfg)
   CUPSEventCfg();

   void SetDefaultLog();
   void SetDefaultWarning();
   void SetDefaultRun();
   void SetDefaultSendMail();
   void SetDefaultCloseSystem();

   BOOL IsDifferentLog(const CUPSEventCfg &Event);
   BOOL IsDifferentWarning(const CUPSEventCfg &Event);
   BOOL IsDifferentRun(const CUPSEventCfg &Event);
   BOOL IsDifferentSendMail(const CUPSEventCfg &Event);
   BOOL IsDifferentCloseSystem(const CUPSEventCfg &Event);
};


class CUPSConfig
{
public:

	char m_Address[100];
	//CString m_Location;                 // lokalizacja
	char m_Location[100];
	CString m_pathLog;				// sciezka do loga
    CString m_pathLogWWW;				// sciezka do loga www

	DWORD m_UPSId;                      // Id UPS'a, gdy ==0 to UPS nie ma jeszcze Id
	BYTE m_Odczyty[SIZE_ODCZYT];        // informacje wyswietlane w Odczyty
	BYTE m_Panele[SIZE_PANEL];          // typy wyswietlanych paneli
	CUPSEventCfg m_Events[SIZE_EVENTS]; // konfiguracja zdarzen

	char m_HostName[MAX_HOST_NAME+1];   // bufor na nazwe hosta
#define MAXGETHOSTSTRUCT 100
	char m_HostEntry[MAXGETHOSTSTRUCT]; // bufor przekazywany do WSAAsyncGetHostByName()
	HANDLE m_GetHostByName;             // HANDLE zwracany przez WSAAsyncGetHostByName()

	int   m_task_max;
	char  m_IP[100];
	BYTE m_IsIPInitialized;             // okresla czy pole m_IP jest zainicjowane
	BYTE m_IsLocal;                     // okresla czy UPS jest lokalny (ma ten sam IP co UPS monitor)
	BYTE m_DataReady;

	BYTE m_NormalPacketOutType;         // typ pakietu do wyslania (wysylanego cyklicznie)
	int  m_NormalPacketOutNum;           // okresla ile razy zostal wyslany pakiet m_NormalPacketOutType
	int  m_PacketOut;					// licznik pakietow bez odpoweidzo

	BYTE m_TurnOffPacketOut;            // okresla czy aktualnie jest wyslany pakiet majacy na celu wylaczenie UPS
	int m_TurnOffPacketOutNum;          // okresla ile razy zostal wyslany pakiet m_TurnOffPacketOut
	BYTE m_TurnOffPacketOutBuff[3];     // bufor na parametry dla pakietu m_TurnOffPacketOut
	BYTE m_CloseSystemMode;             // tryb zamkniecia systemu

	BYTE m_DoTaskPacketOut;             // okresla czy aktualnie jest wyslany pakiet realizujacy zadanie z terminarza
	int m_DoTaskPacketOutNum;           // okresla ile razy zostal wyslany pakiet m_DoTaskPacketOut
	BYTE m_DoTaskPacketOutBuff[7];      // bufor na parametry dla pakietu m_DoTaskPacketOut



	BYTE m_Status;                      // status UPS'a
	int m_CurrEvent;                   // obowazujece zdarzenie, ktorego akcje nalezy wykonac,
	                               // ==-1 gdy brak akcji do wykonania
	clock_t m_EventTime;                // czas wystapienia zdarzenia m_CurrEvent (ma znaczenie
	                               // tylko gdy m_CurrEvent!=-1)
	BYTE m_LogDone;                     // ==1 gdy wykonano zapis do logu (ma znaczenie tylko gdy m_CurrEvent!=-1)
	BYTE m_WarningDone;                 // ==1 gdy zakonczono ostrzeganie (ma znaczenie tylko gdy m_CurrEvent!=-1)
	BYTE m_RunDone;                     // ==1 gdy uruchomiono program (ma znaczenie tylko gdy m_CurrEvent!=-1)
	BYTE m_SendMailDone;                // ==1 gdy wyslano mail/SMS (ma znaczenie tylko gdy m_CurrEvent!=-1)
	BYTE m_CloseSystemDone;             // ==1 gdy zamknieto system (ma znaczenie tylko gdy m_CurrEvent!=-1)
	clock_t m_WarningShowTime;          // czas kiedy nalezy pokazac okno z ostrzezeniem (ma znaczenie tylko gdy m_CurrEvent!=-1)

	BYTE m_CanAutostart;

	int m_MeterMaxBatVol;               // skala napiecia akumulatora (wykorzystywane do skalowania kontrolki CUPSMeter)
	int m_MeterMaxCurrent;              // skala pardu wyjsciowego (wykorzystywane do skalowania kontrolki CUPSMeter)
	int m_MeterMaxPower;                // skala mocy wyjsciowej (wykorzystywane do skalowania kontrolki CUPSMeter)

	//BYTE m_CanBeRestarted;              // ==1 gdy mozna programowo ustawic automatyczne wylaczenie UPS'a
	//BYTE m_CanShutDown;                 // ==1 gdy mozna programowo wylaczyc UPS'a
	BYTE m_CanTurnOff;                  // ==1 gdy mozna programowo wyla
	//CString m_Manufacturer;             // 55 - Manufacturer
	char m_Manufacturer[100];
	char m_Model[100];                    // 56 - Model
	char m_SoftVer[100];                  // 84 - Software Version

	char m_BatCondition;                // 19 - Battery Condition
	char m_BatStatus;                   // 22 - Battery Status
	short m_BatVol;                     // 24 - Battery Voltage
	short m_InVol;                      // 51 - Input Voltage 1
	short m_OutCurrent;                 // 65 - Output Current 1
	short m_OutLoad;                    // 69 - Output Load 1
	long m_OutPower;                    // 73 - Output Power 1
	char m_OutSource;                   // 76 - Output Source
	short m_OutVol;                     // 77 - Output Voltage 1
	long m_SecToClose;                  // czas pozostaly do wylaczenia
	long m_BatAutonomy;					// (2003.01.02, MW)
	short m_UPSStatus;					// (2003.01.02, MW)

	long m_UPSShutdownTime;             // ilosc sekund do wylaczenia UPS po wydaniu rozkazu

	BYTE m_UPSDoShutdown;               // ==1 gdy UPS jest wylaczany na nasze zadanie (poprzeze akcje
	                               // zamkniecia systemu)
	CUPSConfig();
	~CUPSConfig();
	void InitData();
	void CopyEvents(const CUPSConfig *Cfg);
	//void copyUpsConfig(CUPSConfig &Mail_UPS,CUPSConfig *UPS);
	//void Serialize(CArchive& Ar);
};


class CUPSMonConfig
{
public:
   CString m_pathCfg;			//Z0003, LT - nowa zmienna: sciezka do konfiguracji
   CString m_pathBinary;		//Z0009, LT - sciezka np. do skryptu shutdown
   CString m_pathLog;				// sciezka do loga
   CString m_pathLogWWW;				// sciezka do loga www
   unsigned int  m_PortTCP;                    // numer portu UPSmonS
   UINT m_MyPortTCP;            //Z0003, LT - nowa zmienna: moj numer portu (upsmonc)
   UINT m_refresh;              //Z0003, LT - nowa zmienna: czestosc odswiezania www
   BYTE m_ReadOnly;                   // ==0 gdy wolno zmieniac ustawienia
   BYTE m_HideMonTab;                 // ==0 gdy pokazywana jest zakladka "Monitoring"

    char m_Password[100];

//CStringArray m_IP;                 // adresy IP klienta (moze on miec kilka adresow)
	char m_IP[100][100];

   int m_CurrUPS;                     // indeks w m_AllUPS aktualnie wybranego UPS'a

   //DECLARE_SERIAL(CUPSMonConfig)
   CUPSMonConfig();
   //void Serialize(CArchive& Ar);

protected:
   //void EncodePassword();
   //void DecodePassword();
};

class CUPSModelConfig
{
public:
   CString m_Manufacturer;     // producent
   CString m_Model;            // model
   int m_MaxBatVol;            // maksymalne napiecie akumulatora (==0 gdy nalezy pozostawic wartosci domyslne)
   int m_MaxCurrent;           // maksymalny pard wyjsciowy (==0 gdy nalezy pozostawic wartosci domyslne)
   int m_MaxPower;             // maksymalna moc wyjsciowa (==0 gdy nalezy pozostawic wartosci domyslne)

   CUPSModelConfig()
   {
      m_MaxBatVol=0;  // zakladamy ze nalezy pozostawic wartosci domyslne
      m_MaxCurrent=0; // zakladamy ze nalezy pozostawic wartosci domyslne
      m_MaxPower=0;   // zakladamy ze nalezy pozostawic wartosci domyslne
   }
};



#endif // _UPSConfig_h_

// EOF //////////////////////////////////////////////////////////////////////
