///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/09 11:20:47 $
//         $Locker:  $
//         $Revision: 1.14 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Makrodefinicje globalne
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: upsmon.h,v $
// Revision 1.14  2004/07/09 11:20:47  ltokarski
// Z0015 - dodane pozostale parametry do statusu
//
// Revision 1.13  2004/07/07 15:07:35  ltokarski
// Z0013 - wartosci domyslne parametrow w ups.cfg (zaraz po UPS_NR, przed eventami)
//
// Revision 1.12  2004/07/05 11:20:57  ltokarski
// Z0012 - wyswietlanie statusu na zadanie
//
// Revision 1.11  2004/06/30 16:43:16  ltokarski
// Z0009 - uporzadkowanie pamieci dzielonej
//
// Revision 1.10  2004/06/29 16:16:09  ltokarski
// Z0008 - przechodzenie do tla dopiero po zainicjowaniu i zwracanie kodu bledu
//
// Revision 1.9  2004/06/23 14:07:10  ltokarski
// no message
//
// Revision 1.8  2004/06/23 08:40:32  ltokarski
// Z0005 - zmienne sciezki instalacji
//
// Revision 1.6  2004/06/09 14:16:29  ltokarski
// Z0002 - zwracanie bdw do KillAll
//
// Revision 1.5  2004/06/09 11:31:07  ltokarski
// nagwki CVS
// standard plikw Unix
// polskie znaki w iso
//
///////////////////////////////////////////////////////

#ifndef _UPSmon_h_
#define _UPSmon_h_

/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////

//Z0008, LT - wyciete niepotrzebne stale
#define SHARED_MEM_OFFSET           3
#define SHARED_MEM_VALUE            30
#define SHARED_MEM_RESULT			20	//Z0008, LT - lokacja na exit code

#define UPS_SRV_UPDATE_TIME         (CLOCKS_PER_SEC/2) // okres uaktualniania zmiennych w UPSmonS

#define ACTION_NO_BREAK             0    // kontynuowanie pracy (musi byc 0)
#define ACTION_TERMINATE            1    // zakonczenie pracy
#define ACTION_SET_AUTOSTART        2    // wlaczenie opcji autostartu
#define ACTION_UNSET_AUTOSTART      3    // wylaczenie opcji autostartu
#define ACTION_TURN_OFF_AUTOSTART   4    // wylaczenie UPS z ustawieniem opcji autostartu
#define ACTION_TURN_OFF             5    // wylaczenie UPS bez zmiany opcji autostartu
#define ACTION_RESTART              6    // wylaczenie UPS z ponownym wlaczeniem

#define UPS_SHUTDOWN_TIME           30   // opoznienie (w sek.) wylaczenia UPS

#define UPSmon_SRV_PORT             8881
#define UPSmon_CLN_PORT             8882

#define UDP_MAX_PACKET_LEN          260  // maksymalna dlugosc pakietow
                                         // przesylanych miedzy serwerem i klientem
#define UDP_TYPE_REQUEST            0x00 // request
#define UDP_TYPE_ANSWER             0x80 // answer
#define UDP_MASK_ANSWER_REQUEST     0x80 // maska bitu answer/request
#define UDP_MASK_PACKET_TYPE        0x7F // maska typu pakietu
#define UDP_PACKET_CONNECT          0x01 // polaczenie
#define UDP_PACKET_GET_STATIC_DATA  0x02 // pobranie danych statycznych
#define UDP_PACKET_GET_DYNAMIC_DATA 0x03 // pobranie danych dynamicznych
#define UDP_PACKET_UPS_OFF          0x04 // wylaczenie UPSa w trakcie zamkniecia systemu
#define UDP_PACKET_DO_TASK          0x05 // wykonanie akcji zdefiniowanej w terminarzu


/////////////////////////////////////////////////////////////////////////////
#define WM_USER_UPS_NOTIFICATION   (WM_USER+1) // w parametrze WPARAM przesylany jest status
#define WM_USER_UPSMON_START       (WM_USER+2)
#define WM_USER_GETHOSTBYNAME      (WM_USER+3)
#define WM_USER_MAILGETHOSTBYNAME  (WM_USER+4)
#define WM_APP_NOTIFYICON_S        (WM_APP+1)
#define WM_APP_NOTIFYICON_C        (WM_APP+2)

/////////////////////////////////////////////////////////////////////////////
#define SRV_INI_FILE_NAME          "upsmons.ini"

//#define UPSMONC_MODELS_FILE        "/etc/ups/upsmonc.dat"
//#define UPS_CFG_FILE 				"/etc/ups/ups.cfg"

//Z0005, LT - teraz sciezki czytam z pliku opcji
#define UPSMONC_MODELS_FILE		"upsmonc.dat"
#define UPS_CFG_FILE 		    "ups.cfg"
//Z0005, LT - koniec
#define UPS_SHUTDOWN_SCRIPT		"shutdown.sh"	//Z0009, LT - do odczytanej sciezki do konfiguracji dodaje to
#define UPS_STATUS_FILE			"statusc.dat"	//Z0012, Z0015, LT - zapis biezacego statusu wszystkich UPSow

#define SRV_INI_SECTION            "UPSmon"
#define SRV_INI_ENTRY_PORT         "Port"
#define SRV_INI_ENTRY_LOC          "Lokalizacja"
#define SRV_INI_ENTRY_AUTOSTART    "Automatycznie uruchom po powrocie zasilania"

//Z0005, LT - teraz sciezki czytam z pliku opcji
//#define UPS_MON_REG_KEY            "Software\\Fideltronik\\UPS Monitor 3.0"
//#define REG_KEY_SERVER_PATH        "sUpsServerPath"
//#define REG_KEY_CLIENT_PATH        "sUpsClientPath"
//#define UPSMONC_CONFIG_FILE        "/etc/ups/upsmonc.cfg"
#define LOG_FILE_NAME				"upsmonc.log"	//"/etc/ups/upsmonc.log"
//#define LOGTMP_FILE_NAME           "upsmonc.tmp"
#define OPTIONS_FILE				"/etc/ups/fideltronik/options.cfg"
//Z0005, LT - koniec

#define MAX_HOST_NAME              256  // maksymalna dlugosc nazwy hosta
#define MAX_LOC_LEN                32   // maksymalna dlugosc tekstu Lokalizacja

#define LEN_MAN                    32   // dlugosc pola 55 - Manufacturer
#define LEN_MODEL                  64   // dlugosc pola 56 - Model
#define LEN_SOFT_VER               32   // dlugosc pola 84 - Software Version

#define MAX_PARAM                  89   // maksymalna ilosc parametrow
#define MAX_UPS_PACKET_LEN         133  // maksymalna dlugosc pakietow z UPSa

#define RESPONSE_TIMEOUT           (CLOCKS_PER_SEC*2) // czas oczekiwania na pakiet z UPS'a
#define RESPONSE_RETRY             2    // ilosc retransmisji pakietu przed wyslaniem UPS_NO_COMMUNICATION

#define UPS_TYPE_NONE              0    // typy UPS'a - nie wykryto UPS'a
#define UPS_TYPE_SMARTMON          1    // smartmon
#define UPS_TYPE_JOINT             2    // stykowy

#define UPSMON_MAX_RETRY           3    // maksymalna ilosc transmisji pakietu pomiedzy klientem
                                        // a serwerem przed zgloszeniem bledu "brak komunikacji"

#define SEND_MAIL_TIMEOUT          60 //(CLOCKS_PER_SEC*60) // timeout na wyslanie e-mail/SMS

/////////////////////////////////////////////////////////////////////////////
#define EVENT_NORMAL                0
#define EVENT_BAT                   1
#define EVENT_BAT_LOW               2
#define EVENT_SYS_CLOSE             3
#define EVENT_NO_COMMUNICATION      4
#define EVENT_PRG_START             5
#define EVENT_PRG_STOP              6
#define EVENT_NO_COMM_BAT           7
#define EVENT_AVR_START             8
#define EVENT_UPS_GOING_OFF         9
#define EVENT_BYPASS                10
#define EVENT_DEFAULT               11		//Z0013, LT - tu trzymam ustawienia domyslne dla wszystkich akcji

#define EVENT_NORMAL_TEXT           "Praca sieciowa"
#define EVENT_BAT_TEXT              "Awaria zasilania"
#define EVENT_BAT_LOW_TEXT          "Baterie rozadowane"
#define EVENT_SYS_CLOSE_TEXT        "Zamknicie systemu"
#define EVENT_NO_COMMUNICATION_TEXT "Utrata komunikacji"
#define EVENT_PRG_START_TEXT        "Rozpoczcie pracy programu"
#define EVENT_PRG_STOP_TEXT         "Zakoczenie pracy programu"
#define EVENT_NO_COMM_BAT_TEXT      "Utrata komunikacji na bateriach"
#define EVENT_AVR_START_TEXT        "Praca AVR"
#define EVENT_UPS_GOING_OFF_TEXT    "Planowe wyczenie zasilacza"
#define EVENT_BYPASS_TEXT           "Praca bypass"
#define EVENT_SETTINGS_FOR_ALL_TEXT "Ustawienia dla wszystkich zasilaczy"

// wartosci domyslne poszczegolnych akcji
#define EVENT_DEF_WRITE_TO_LOG              0   // zapis do loga: 0-nie, 1-tak
#define EVENT_DEF_WARNING                   0   // wyswietlenie ostrzezenia: 0-nie, 1-tak
#define EVENT_DEF_WARNING_TEXT              ""  // tekst ostrzezenia
#define EVENT_DEF_WARNING_FIRST_DELAY       10  // opoznienie pierwszego ostrzezenia (sek.)
#define EVENT_DEF_WARNING_SHOW_NEXT         0   // pokazywac nastepne ostrzezenia: 0-nie, 1-tak
#define EVENT_DEF_WARNING_NEXT_DELAY        60  // opoznienie nastepnych ostrzezen (sek.)
#define EVENT_DEF_RUN                       0   // uruchomienie programu: 0-nie, 1-tak
#define EVENT_DEF_RUN_PROG                  ""  // program do uruchomienia
#define EVENT_DEF_RUN_DELAY                 10  // opoznienie uruchomienia programu (sek.)
#define EVENT_DEF_SEND_MAIL                 0   // wyslanie mail/SMS: 0-nie, 1-tak
#define EVENT_DEF_SEND_MAIL_DELAY           10  // opoznienie wyslania mail/SMS (sek.)
#define EVENT_DEF_SEND_MAIL_TO              ""  // odbiorca wiadomosci
#define EVENT_DEF_SEND_MAIL_SMTP            ""  // adres serwera SMTP
#define EVENT_DEF_SEND_MAIL_FROM            ""  // nadawca wiadomosci
#define EVENT_DEF_SEND_MAIL_SUBJECT         ""  // temat wiadomosci
#define EVENT_DEF_SEND_MAIL_MESSAGE         ""  // tekst wiadomosci
#define EVENT_DEF_CLOSE_SYSTEM              0   // zamkniecie systemu: 0-nie, 1-tak
#define EVENT_DEF_CLOSE_SYSTEM_DELAY        600 // opoznienie zamkniecia systemu (sek.)
#define EVENT_DEF_CLOSE_SYSTEM_MODE         0   // tryb zamkniecia systemu: 0-normal, 1-forced
#define EVENT_DEF_CLOSE_SYSTEM_RUN_UPS      0   // ==1 gdy UPS ma byc automatycznie uruchomiony
#define EVENT_DEF_CLOSE_SYSTEM_TURN_OFF_UPS 0   // ==1 gdy mamy wylaczyc UPS

/////////////////////////////////////////////////////////////////////////////
#define PERIOD_ONCE                         0   // jeden raz
#define PERIOD_DAILY                        1   // codziennie
#define PERIOD_WEEKLY                       2   // co tydzien

#define TASK_NONE                           0   // brak zadania do wykonania
#define TASK_TURN_OFF                       1   // wylaczenie UPS
#define TASK_RESTART                        2   // wylaczenie UPS z ponownym wlaczeniem

/////////////////////////////////////////////////////////////////////////////
#define TYPE_INT                   0   // wartosc calkowita
#define TYPE_FLOAT                 1   // wartosc podawana w 0.1
#define TYPE_TEXT                  2   // text

/////////////////////////////////////////////////////////////////////////////
#define TAB_MONITORING             "Monitoring"
#define TAB_ZASILACZE_UPS          "Zasilacze UPS"

/////////////////////////////////////////////////////////////////////////////
#define VAL_UNAVAILABLE            -1
#define VAL_GETTING_DATA           -2
#define VAL_NOT_APPLY              -3

#define STR_VAL_UNAVAILABLE        "niedostpne"
#define STR_VAL_GETTING_DATA       ""
#define STR_VAL_NOT_APPLY          "nie dotyczy"

#define SIZE_ODCZYT                4
#define SIZE_PANEL                 3
#define SIZE_EVENTS                20
//#define MAX_NO_RESPONSE			   5

////////////////////////////////////////////////////////////////////////////
#define COLOR_URL                  RGB(0,0,255)

#define COLOR_VALUE_ODCZYT         RGB(0,0,155)

////////////////////////////////////////////////////////////////////////////
#define FACE_FONT_STATUS           "Arial"
#define SIZE_FONT_STATUS           28
#define STYLE_FONT_STATUS          FW_BOLD

#define STATUS_NORMAL              0   // stan normalny
#define STATUS_BAT                 1   // awaria zasilania
#define STATUS_BAT_LOW             2   // baterie niskie
#define STATUS_AVR_UP              3   // AVR gorny
#define STATUS_AVR_DOWN            4   // AVR dolny
#define STATUS_OFF                 5   // wylaczony
#define STATUS_UPS_GOING_OFF       6   // UPS ma byc wylaczony
#define STATUS_BYPASS              7   // praca bypass
#define STATUS_NO_COMMUNICATION    8   // brak komunikacji
#define STATUS_GETTING_DATA        9   // pobieranie danych


/////////////////////////////////////////////////////////////////////////////
#define TASKBAR_NORMAL_TEXT            "UPS Monitor Serwer 3.0 - Stan normalny"
#define TASKBAR_BAT_TEXT               "UPS Monitor Serwer 3.0 - Awaria zasilania"
#define TASKBAR_BAT_LOW_TEXT           "UPS Monitor Serwer 3.0 - Baterie niskie"
#define TASKBAR_AVR_UP_TEXT            "UPS Monitor Serwer 3.0 - AVR grny"
#define TASKBAR_AVR_DOWN_TEXT          "UPS Monitor Serwer 3.0 - AVR dolny"
#define TASKBAR_NO_COMMUNICATION_TEXT  "UPS Monitor Serwer 3.0 - Brak komunikacji"
#define TASKBAR_OTHER_TEXT             "UPS Monitor Serwer 3.0"

#define TASKBAR_UPS_MON_TEXT           "UPS Monitor Klient 3.0"

/////////////////////////////////////////////////////////////////////////////
#define COLOR_METER_BACKGROUND     RGB(120,120,120)
#define COLOR_VALUE_OK             RGB(0,240,0)
#define COLOR_VALUE_WARNING        RGB(250,250,0)
#define COLOR_VALUE_LOW            RGB(200,0,0)
#define COLOR_METER_LINE           RGB(0,0,0)

#define FACE_FONT_SCALE            "Arial"
#define SIZE_FONT_SCALE            14
#define STYLE_FONT_SCALE           FW_NORMAL
#define COLOR_FONT_SCALE           RGB(0,0,155)

#define FACE_FONT_VALUE            "Arial"
#define SIZE_FONT_VALUE            20
#define STYLE_FONT_VALUE           FW_BOLD
#define COLOR_FONT_VALUE           RGB(0,0,155)

#define PANEL_NAPIECIE_ZASILANIA   0   // musi byc numerowane kolejno
#define PANEL_AKUMULATOR           1   // rozpoczynajac od 0
#define PANEL_PRAD_WYJSCIOWY       2
#define PANEL_MOC_WYJSCIOWA        3
#define PANEL_NAPIECIE_WYJSCIOWE   4
#define PANEL_CZAS_PRACY           5
#define PANEL_WYLACZONY            6   // musi byc jako ostatnia pozycja

// dla kazdej powyzszej pozycji sa zdefiniowane nastepujace stale:
// ..._CAPTION       - tytul okna
// ..._UNIT          - jednostka
// ..._TYPE          - typ wartosci (jedna ze stalych TYPE_)
// ..._SCALE         - wartosci podzialek
// ..._RANGE_OK      - granice przedzialu OK
// ..._RANGE_WARNING - granice przedzialu Warning
// dla PANEL_NAPIECIE_ZASILANIA
#define PANEL_NZ_CAPTION           "Napicie zasilania"
#define PANEL_NZ_UNIT              "[V]"
#define PANEL_NZ_TYPE              TYPE_FLOAT
#define PANEL_NZ_SCALE             {1500, 1800, 2100, 2400, 2700}
#define PANEL_NZ_RANGE_OK          {1800, 2600}
#define PANEL_NZ_RANGE_WARNING     {1700, 2600}
// dla PANEL_AKUMULATOR
#define PANEL_A_CAPTION            "Akumulator"
#define PANEL_A_UNIT               "[V]"
#define PANEL_A_TYPE               TYPE_FLOAT
#define PANEL_A_SCALE              {350, 450, 550, 650, 750}
#define PANEL_A_RANGE_OK           {500, 600}
#define PANEL_A_RANGE_WARNING      {400, 700}
// dla PANEL_PRAD_WYJSCIOWY
#define PANEL_PW_CAPTION           "Prd wyjciowy"
#define PANEL_PW_UNIT              "[A]"
#define PANEL_PW_TYPE              TYPE_FLOAT
#define PANEL_PW_SCALE             {0, 25, 50, 75, 100}
#define PANEL_PW_RANGE_OK          {0, 50}
#define PANEL_PW_RANGE_WARNING     {50, 75}
// dla PANEL_MOC_WYJSCIOWA
#define PANEL_MW_CAPTION           "Moc wyjciowa"
#define PANEL_MW_UNIT              "[W]"
#define PANEL_MW_TYPE              TYPE_INT
#define PANEL_MW_SCALE             {0, 500, 1000, 1500, 2000}
#define PANEL_MW_RANGE_OK          {0, 1000}
#define PANEL_MW_RANGE_WARNING     {1000, 1500}
// dla PANEL_NAPIECIE_WYJSCIOWE
#define PANEL_NW_CAPTION           "Napicie wyjciowe"
#define PANEL_NW_UNIT              "[V]"
#define PANEL_NW_TYPE              TYPE_FLOAT
#define PANEL_NW_SCALE             {1500, 1800, 2100, 2400, 2700}
#define PANEL_NW_RANGE_OK          {1800, 2500}
#define PANEL_NW_RANGE_WARNING     {1700, 2600}
// dla PANEL_CZAS_PRACY
#define PANEL_CP_CAPTION           "Czas pracy"
#define PANEL_CP_UNIT              "[sek.]"
#define PANEL_CP_TYPE              TYPE_INT
#define PANEL_CP_SCALE             {0, 600, 1200, 1800, 2400}
#define PANEL_CP_RANGE_OK          {600, 9999}
#define PANEL_CP_RANGE_WARNING     {600, 9999}
// dla PANEL_WYLACZONY
#define PANEL_W_CAPTION            "Wyczony"
#define PANEL_W_UNIT               ""
#define PANEL_W_TYPE               TYPE_INT
#define PANEL_W_SCALE              {0, 0, 0, 0, 0}
#define PANEL_W_RANGE_OK           {0, 0}
#define PANEL_W_RANGE_WARNING      {0, 0}

/////////////////////////////////////////////////////////////////////////////
#define UPS_LIST_LOC               "Lokalizacja"
#define UPS_LIST_ADDR              "Adres"
#define UPS_LIST_STATUS            "Status"

#define LOG_BROWSE_ALL_TEXT        "Historia wszystkich zasilaczy UPS"

/////////////////////////////////////////////////////////////////////////////
#define LOG_EVENT_NORMAL           "Praca sieciowa"
#define LOG_EVENT_BAT              "Awaria zasilania"
#define LOG_EVENT_BAT_LOW          "Baterie rozadowane"
#define LOG_EVENT_SYS_CLOSE        "Zamknicie systemu"
#define LOG_EVENT_NO_COMMUNICATION "Utrata komunikacji"
#define LOG_EVENT_PRG_START        "Rozpoczcie pracy programu"
#define LOG_EVENT_PRG_STOP         "Zakoczenie pracy programu"
#define LOG_EVENT_NO_COMM_BAT      "Utrata komunikacji na bateriach"
#define LOG_EVENT_AVR_START        "Praca AVR"
#define LOG_EVENT_BYPASS           "Praca bypass"

#define LOG_EVENT_UPS_GOING_OFF    "Planowe wyczenie zasilacza"
#define LOG_ERR_RUN                "Bd uruchomienia programu: %s"
#define LOG_ERR_RUN_EMPTY          "Bd uruchomienia programu (nie podano programu)"
#define LOG_ERR_SEND_MAIL          "Bd wysania e-mail/SMS"
#define LOG_ERR_SEND_MAIL_ABORT    "Bd wysania e-mail/SMS (zakoczono prac programu)"
#define LOG_ERR_CLOSE_SYSTEM_UPS   "Bd wyczenia UPS w trakcie zamknicia systemu"
#define LOG_ERR_DO_TASK            "Bd wykonania zadania z terminarza"


/////////////////////////////////////////////////////////////////////////////
//	Dodanie definicji stanw UPS-a (2003.01.02, MW)
#define UPS_BCHARGER_FAULT			0x01
#define	UPS_BATTERY_FAULT			0x02
#define	UPS_JOINT_ACTIVE			0x80	// 2003.01.10, M

//Z0002, LT definicje kodw bdw
#define ERR_FOPEN_CONFIG                -2
#define ERR_CONVERTDATETASK1            -3
#define ERR_CONVERTDATETASK2            -4
#define ERR_CONVERTDATETASK3            -5
#define ERR_GETHOSTBYNAME               -6
#define ERR_CONNECT                     -7
#define ERR_THREADCREATE_ONREAD         -8
#define ERR_THREADCREATE_ONTIMERTASK    -9
#define ERR_DOACTION_SENDEMAIL          -10
#define ERR_DOACTION_CLOSESYSTEM        -11
#define ERR_FOPEN_INDEX                 -12
#define ERR_ONTIMEROFF                  -13
#define ERR_ONTIMERTASK                 -14
#define ERR_ANALIZETURNOFFPACKET        -15
#define ERR_ANALIZENORMALPACKET         -16
#define ERR_INTERPROCESSTIMEOUT			-17		//Z0008, LT
#define ERR_FORK						-18		//Z0008, LT
#define ERR_FOPEN_GLOBAL_CONFIG			-19
#endif // _UPSmon_h_

// EOF //////////////////////////////////////////////////////////////////////
