///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/29 10:19:25 $
//         $Locker:  $
//         $Revision: 1.6 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Obsuga portu szeregowego
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: comport.cpp,v $
// Revision 1.6  2004/06/29 10:19:25  ltokarski
// Z0008 - wejscie w tlo po zainicjowaniu komunikacji i zwracanie kodu bledu
//
// Revision 1.5  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <termios.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <errno.h>
#include <signal.h>
#include "linux_ty.h"
#include "comport.h"
#include "upsmon.h"
#include "thread.h"
#include "smem.h"	//Z0008, LT - do przekazania kodu bledu do procesu macierzystego

//#define  debug_rs

extern int errno;

/////////////////////////////////////////////////////////////////////////////
const int RS_IO_BUFF_LEN=1024;
extern int __debug;

/////////////////////////////////////////////////////////////////////////////
CComPort::CComPort()
{
	m_PortNum=0;
	m_RSHandle=0;
} // CComPort::CComPort


/////////////////////////////////////////////////////////////////////////////
CComPort::~CComPort()
{
	if(IsOpen())
		Close();
} // CComPort::~CComPort


struct termios portset_save;

/////////////////////////////////////////////////////////////////////////////
//BOOL CComPort::Open(int Port,char *str)
BOOL CComPort::Open(char *port, char *str)
{
	if(IsOpen())
		Close();
	int i;
//	char port[10];

	// uzaleznic od str
	int dtr = TIOCM_DTR;
	int rts = TIOCM_RTS;
	//speed_t speed=B1200;
	struct termios portset;

#ifdef debug_rs
	m_RSHandle=1;
	return TRUE;
#endif

//	sprintf(port,"/dev/ttyS%d",Port);
	if(__debug)
		printf("  Open port %s \n",port);
	m_RSHandle=0;
	m_RSHandle = open(port, O_RDWR | O_NOCTTY|  O_NDELAY);	/* open serial port */
	//printf("Open port m_RSHandle=%d\n",m_RSHandle);
	if(m_RSHandle<0)
	{
		m_Info->shmem->Set(EXIT_COM_ERROR, 1, SHARED_MEM_RESULT);	//Z0008, LT - kod bledu dla proc mac.
//		printf("- Open port %s error (%d)\n",port,m_RSHandle);
		printf("- Blad otwarcia portu %s\n",port);
		if(__debug)
			perror("Error open              ");
		ThreadCounter &= ~THREAD_RS;
		raise(SIGTERM);
		exit(0);
		return FALSE;
	}

	//takie ustawienia aby nie wylaczec UPS-a stykowwego
	int res=ioctl(m_RSHandle,TIOCMBIC,&rts);		/* DTR = +12V */
	if(res==-1)
	{
		m_Info->shmem->Set(EXIT_COM_ERROR, 1, SHARED_MEM_RESULT);	//Z0008, LT - kod bledu dla proc mac.
//		printf("- Port %s ERROR\n",port);
		printf("- Blad przy konfigurowaniu portu %s\n",port);
		if(__debug)
			perror("Set RST failure                 ");
		ThreadCounter &= ~THREAD_RS;
		raise(SIGTERM);
		exit(0);
		return FALSE;
	}
	res=ioctl(m_RSHandle,TIOCMBIS,&dtr);		/* DTR = +12V */
	if(res==-1)
	{
		m_Info->shmem->Set(EXIT_COM_ERROR, 1, SHARED_MEM_RESULT);	//Z0008, LT - kod bledu dla proc mac.
//		printf("- Port %s ERROR\n",port);
		printf("- Blad przy konfigurowaniu portu %s\n",port);
		if(__debug)
			perror("Set DTR failure                 ");
		ThreadCounter &= ~THREAD_RS;
		raise(SIGTERM);
		exit(0);
		return FALSE;
	}
//	 m_PortNum=Port+1;
    m_PortNum = 1;

	i=tcgetattr(m_RSHandle,&portset_save);
	bzero(&portset,sizeof(portset));
	if(i==-1)
	{
		m_Info->shmem->Set(EXIT_COM_ERROR, 1, SHARED_MEM_RESULT);	//Z0008, LT - kod bledu dla proc mac.
//		printf("- Port %s ERROR\n",port);
		printf("- Blad przy konfigurowaniu portu %s\n",port);
		if(__debug)
		{
			perror("TCGetAttr Error                 ");
			printf("- tcget i=%d o=%d\n",portset.c_ispeed,portset.c_ospeed);
		}
		ThreadCounter &= ~THREAD_RS;
		raise(SIGTERM);
		exit(0);
		return FALSE;
	}
//#define TEST

#ifndef TEST
	//portset.c_cflag=0;
	//         enable receiver ignore modem lines
	if(strcmp(str,"1200,N,8,1")==0)
		portset.c_cflag = B1200 |CS8 | CREAD ;
	else
	{
		if(strcmp(str,"9600,N,8,1")==0)
			portset.c_cflag = B9600 |CS8 | CREAD ;
		else
		{
			if(strcmp(str,"2400,N,8,1")==0)
				portset.c_cflag = B2400 |CS8 | CREAD;
			else
				portset.c_cflag = B9600 |CS8 | CREAD;
		}
	}
	portset.c_cflag &= ~CRTSCTS;    //no control mode signals
	portset.c_cflag |=CLOCAL; //bez DCD
	portset.c_lflag =0;// ICANON;
	portset.c_oflag = 0;
	portset.c_iflag = IGNPAR;
	portset.c_cc[VTIME]=0;
	portset.c_cc[VMIN]=0;
#endif
	i=tcflush(m_RSHandle,TCIFLUSH);
	if(i==-1)
	{
		m_Info->shmem->Set(EXIT_COM_ERROR, 1, SHARED_MEM_RESULT);	//Z0008, LT - kod bledu dla proc mac.
//		printf("- Port %s ERROR\n",port);
		printf("- Blad przy konfigurowaniu portu %s\n",port);
		if(__debug)
		{
			printf("TCFlush Error           ");
			printf("  tcflush \n");
		}
		ThreadCounter &= ~THREAD_RS;
		raise(SIGTERM);
		exit(0);
		return FALSE;
	}

#ifndef TEST
	i=tcsetattr(m_RSHandle,TCSANOW,&portset);
	if(i==-1)
	{
		m_Info->shmem->Set(EXIT_COM_ERROR, 1, SHARED_MEM_RESULT);	//Z0008, LT - kod bledu dla proc mac.
//		printf("- Port %s ERROR\n",port);
		printf("- Blad przy konfigurowaniu portu %s\n",port);
		if(__debug)
		{
			perror("TCSetAttr Error         ");
			printf("  res setatt\n");
		}
		ThreadCounter &= ~THREAD_RS;
		raise(SIGTERM);
		exit(0);
		return FALSE;
	}
#endif
	if(__debug)
		printf("+ Open port %s SUCCESS\n",port);
	return TRUE;
} // CComPort::Open

/////////////////////////////////////////////////////////////////////////////
BOOL CComPort::IsOpen()
{
	return m_PortNum!=0;
} // CComPort::IsOpen


/////////////////////////////////////////////////////////////////////////////
void CComPort::Close()
{

#ifdef debug_rs
	m_PortNum=0;
	return;
#endif
	if(m_PortNum==0)
		return;
	/*
	CloseHandle(m_RSHandle);
	*/

	int res=tcsetattr(m_RSHandle,TCSANOW,&portset_save);
	if(res==-1)
		perror("Set port ");
	res=close(m_RSHandle);
	if(res==-1)
		perror("Close port ");
	m_RSHandle=0;
	m_PortNum=0;
} // CComPort::Close


/////////////////////////////////////////////////////////////////////////////
// zwraca -1 jezeli nie odczytano znaku, lub odczytany znak
int CComPort::ReadChar()
{
	BYTE readBuff[10];
	int readOK;

#ifdef debug_rs
	return -1;
#endif
//   DWORD  errors;
  // ssize_t bytesRead;
	readOK=read(m_RSHandle,      readBuff,1);
	if(readOK==1)
	{
		//printf("Read %02X ",readBuff[0]);
		return readBuff[0];
	}
	else
	{
		if(readOK==0)
			return -1;
		else
		{
			if(__debug)
				printf("Read %d %c %02X handle %d errno=%d\n",readOK,readBuff[0],readBuff[0],m_RSHandle,errno);
			perror("Blad ");
			//getchar();
		}
	}
	/*
	if(!readOK) ClearCommError(m_RSHandle,&errors,NULL);
	*/
	return -1;
} // CComPort::ReadChar


/////////////////////////////////////////////////////////////////////////////
BOOL CComPort::WriteChar(BYTE Char)
{
	DWORD bytesWrite;
#ifdef debug_rs
	return TRUE;
#endif

	bytesWrite=write(m_RSHandle,(void *)&Char,1);
	if(__debug)
		printf("Write char %c %ld\n",Char,bytesWrite);
	return TRUE;
} // CComPort::WriteChar


/////////////////////////////////////////////////////////////////////////////
BOOL CComPort::WriteStr(BYTE *Str, int Len)
{
//   DWORD bytesWrite, errors;
	int bytesOut=0;

#ifdef debug_rs
	return TRUE;
#endif
	//do
	//{
		//printf("WriteStr %s handle=%d\n",Str,m_RSHandle);
		//if(!WriteFile(m_RSHandle,Str,Len,&bytesWrite,NULL))
	bytesOut=write(m_RSHandle,Str,Len);
	if(bytesOut!=Len)
	{
		//ClearCommError(m_RSHandle,&errors,NULL);
		perror("Write Str Len ");
		return FALSE;
	}
	if(bytesOut==-1)
	{
		perror("Write Str ");
		return FALSE;
	}
	tcdrain(m_RSHandle);
	//bytesOut+=bytesWrite;
	//} while(bytesOut<Len);

	return TRUE;
} // CComPort::WriteChar


/////////////////////////////////////////////////////////////////////////////
BOOL CComPort::SetState(BYTE RTS, BYTE DTR)
{

	int dtr = TIOCM_DTR;
	int rts = TIOCM_RTS;

#ifdef debug_rs
	return TRUE;
#endif
	if(!IsOpen())
		return FALSE;
	int res;
	if(RTS)
		res=ioctl(m_RSHandle,TIOCMBIS,&rts);		/*  = +12V */
	else
		res=ioctl(m_RSHandle,TIOCMBIC,&rts);		/*  = -12 */

	if(res==-1)
		perror("ioctl RTS ");
	if(DTR)
		res=ioctl(m_RSHandle,TIOCMBIS,&dtr);		/*  = +12V */
	else
		res=ioctl(m_RSHandle,TIOCMBIC,&dtr);		/*  = +12V */
	if(res==-1)
		perror("ioctl DTR ");

	return TRUE;
} // CComPort::SetState


/////////////////////////////////////////////////////////////////////////////
BOOL CComPort::GetState(BYTE &CTS, BYTE &DCD)
{
	int status;
	int cts=0;
	int dcd=0;
	int rng=0;

#ifdef debug_rs
	return TRUE;
#endif

	int res=ioctl(m_RSHandle,TIOCMGET,&status);
	if(res==-1)
	{
		if(__debug)
			printf("Errno %d %X m_ %d\n",errno,errno,m_RSHandle);
		perror("Get stat :");
	}
	//if(status&MS_CTS_ON) CTS=1; else CTS=0;
	//if(status&MS_RLSD_ON) DCD=1; else DCD=0;
  // printf("Status get %04X TIOCM_CTS=%04X TIOCM_CAR=%04X =TIOCM_RNG%04X\n",status,TIOCM_CTS,TIOCM_CAR,TIOCM_RNG);
	//printf("%d %d %d %d %d\n",EBADF,EFAULT,ENOTTY,EINVAL,0);

	// jak rozpiete to blad !!!!!!!!!!!1
	if(status & TIOCM_CTS)
		cts=1;
	if(status & TIOCM_CAR)
		dcd=1;
	if(status & TIOCM_RNG)
		rng=1;
	if(cts==1 && dcd==1)
	{ //normal
		//printf("Normal state\n");
		CTS=DCD=1;
	}
	if(cts==0 && dcd==1)
	{
		//printf("Power fail\n");
		CTS=0;
		DCD=1;
	}
	if(cts==0 && dcd==0)
	{
		//printf("Bat low\n");
		CTS=0;
		DCD=0;
	}
	return TRUE;
} // CComPort::GetState

// EOF //////////////////////////////////////////////////////////////////////

