///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/23 13:49:32 $
//         $Locker:  $
//         $Revision: 1.23 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Funkcja main, funkcja gwna wtku timera i pomocnicze
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: main.cpp,v $
// Revision 1.23  2004/07/23 13:49:32  ltokarski
// Z0015 - w analizie opcji poprawione "LOCATION" na "UPS_NAME"
//
// Revision 1.22  2004/07/20 10:18:55  ltokarski
// Z0013 - wypisywanie w statusie protokolu komunikacji
//
// Revision 1.21  2004/07/19 12:05:16  ltokarski
// poprawka literwki
//
// Revision 1.20  2004/07/09 11:32:01  ltokarski
// Z0012 - zapis biezacego statusu do pliku
//
// Revision 1.19  2004/06/30 16:44:31  ltokarski
// Z0009 - uporzadkowanie pamieci dzielonej
//
// Revision 1.18  2004/06/29 10:19:25  ltokarski
// Z0008 - wejscie w tlo po zainicjowaniu komunikacji i zwracanie kodu bledu
//
// Revision 1.17  2004/06/25 11:42:18  ltokarski
// Z0007 - przywrocenie zapisu do upsoff.conf
//
// Revision 1.16  2004/06/24 12:20:08  ltokarski
// Z0006 - konfigurowany czas opoznienia do wylaczenia (oprocz stykowych)
//
// Revision 1.15  2004/06/23 15:40:24  ltokarski
// Z0005 - sprawdzanie wybranego protokolu
//
// Revision 1.14  2004/06/23 12:30:06  ltokarski
// Z0003 - uzywanie portow IP pobranych z pliku opcji
//
// Revision 1.13  2004/06/15 11:34:55  ltokarski
// Z0002 - czytanie pliku konfiguracyjnego "options.cfg"
//
// Revision 1.12  2004/06/09 12:22:35  ltokarski
// Z0001 poprawiona analiza parametru wywo3ania 'c'
//
// Revision 1.11  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
// W poprzednim projekcie:
//
// 0.91 2002.11.19
// dodano zapis do pliku wylaczajacego UPS joint.cpp
// 2003.01.21 ver 3.0.0.2
// poprawne wylaczanie ups-a stykowego
//
// 2003.02.10   ver 3.0.0.4
// drobne zmiany
////////////////////////////////////////////////////////

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <pthread.h>
#include <signal.h>

#include "linux_ty.h"
#include "comport.h"
#include "upsmon.h"
#include "ups.h"
#include "thread.h"
#include "netdatag.h"
#include "smem.h"
#include "upssrv.h"

#define delay(d)	usleep((d)*1000)

char ver[]="3.1.0";
char dat_build[]="2004.07.09";


BOOL DlgMain_m_JointTurnOffFlag=FALSE; // flaga wykorzystywana przy wylaczaniu UPSa z interfejsem stykowym dla wersji 9x
BOOL DlgMain_m_JointTurnOffUPSOnly=FALSE; // 2003.01.15, MW, flaga wylaczania UPS-a stykowego, bez zamykania systemu

#define BUFFER_SIZE     1024

int __debug=0;

int volatile	ThreadCounter = 0;
int volatile	ThreadCancel = 0;

int volatile	SearchUPSRetries = 2;	//Z0008, LT - po tylu probach znalezienia UPSa wchodzi do tla

BYTE		GlobalStatus = STATUS_GETTING_DATA;		//Z0012, LT
BYTE		GlobalProtocol = 0;		//Z0013, LT
char		GlobalStatusPath[100];					//Z0012, LT - sciezka do pliku ze statusem

/////////////////////////////////////////////////////////////////////////////
//void *UPSThreadMain(LPVOID pParam /* CUPSThreadInfo* */)
void *onTimer(LPVOID UpsSrv1)
{
	CUPSSrv	*UpsSrv=(CUPSSrv *)UpsSrv1;

	do
	{
    // dla wersji NT cyklicznie odswiezamy ikone (bo mogla zniknac po wylogowaniu)
		sleep(1);

		// gdy jest ustawiona flaga m_JointTurnOffFlag to zlecamy wylaczenie UPSa
		// czekamy 1 sek. a pozniej probujemy do skutku
		static int i=0;
		//printf("OnTimer OffFlag=%d OffOnly=%d ",UpsSrv->GetJointTurnOffFlag(),UpsSrv->GetJointTurnOffUPSOnly());

		if(UpsSrv->GetJointTurnOffFlag() && i++)
			UpsSrv->DoJointTurnOff(1);

//	2003.01.15, MW, poprawa obslugi wylaczania UPS-a bez zamykania systemu
	 	static int k = 0, l = 0;
//		printf(" OffOnly=%d Dlg_Off=%d\n",UpsSrv->GetJointTurnOffUPSOnly(),DlgMain_m_JointTurnOffUPSOnly);
		if((UpsSrv->GetJointTurnOffUPSOnly()==TRUE)&&(DlgMain_m_JointTurnOffUPSOnly==FALSE))
		{
			DlgMain_m_JointTurnOffUPSOnly = TRUE;
//			k = UPS_SHUTDOWN_TIME;
			k = UpsSrv->GetTurnOffDelay();	//Z0006, LT
			l = 10;
		}
		if(DlgMain_m_JointTurnOffUPSOnly)
		{
//			printf("k=%d l=%d\n",k,l);
			if(k!=0)				// odmierzanie zadanej ilosci sekund do wylaczania UPS-a stykowego
			{
				if(--k==0)
					UpsSrv->DoJointTurnOff(3);
			}
			if((k==0)&&(--l==0))	// odmierzanie 10 sekund podczas wylaczania UPS-a stykowego
			{
				UpsSrv->DoJointTurnOff(4);
				DlgMain_m_JointTurnOffUPSOnly = FALSE;  // zadanie wykonane
				i=0;
			}
		}
		//	2003.01.15, MW, koniec
		GlobalStatus = UpsSrv->GetStatus();	//Z0012, LT
		GlobalProtocol = UpsSrv->GetProtocol();		//Z0013, LT
	}
	while(!ThreadCancel);
	return (void *)0;
} // CDlgMain::OnTimer

//Z0012, LT - nowa funkcja do wypisywania statusu UPSa do pliku
void	printStatus()
{
	const char *statusText[] = {
		STATUS_NORMAL_TEXT,
		STATUS_BAT_TEXT,
		STATUS_BAT_LOW_TEXT,
		STATUS_AVR_UP_TEXT,
		STATUS_AVR_DOWN_TEXT,
		STATUS_OFF_TEXT,
		STATUS_UPS_GOING_OFF_TEXT,
		STATUS_BYPASS_TEXT,
		STATUS_NO_COMMUNICATION_TEXT,
		"Brak",
		""
	};
	const char *protocolText[] = {
	    "-",
	    "stykowy",
	    "SEC 2.6",
	    "Megatec",
	    "Newave",
	    "???",
	    "???",
	    "???",
	    "???",
	    };
	FILE *f = fopen(GlobalStatusPath, "w");
	if(f == NULL)
	{
		perror(UPS_STATUS_FILE);
		return;
	}
	fprintf(f, "--------------------------------------------------------\n");
	fprintf(f, "|              UPS Monitor Serwer wersja %-10s    |\n",ver);
	fprintf(f, "--------------------------------------------------------\n");//\n\n");
	fprintf(f, "Stan pracy:             %s\n", statusText[GlobalStatus]);
	//Z0013, LT - dodaje informacje o protokole komunikacji
	fprintf(f, "Protok:               %s\n", protocolText[GlobalProtocol]);
	fprintf(f, "\n");
	fclose(f);
}
//Z0012, LT - koniec

void funcsig(int type)
{
	//Z0012, LT - zanim dodam kolejna obsluge sygnalu, przeniose sie do jednej funkcji
	switch(type)
	{
	case SIGTERM:
		ThreadCancel = 1;
		break;
	case SIGCHLD:
		wait(NULL);
		ThreadCancel = 1;
		break;
	case SIGUSR1:	//Z0012, LT - wypisywanie biezacego statusu
		printStatus();
		break;
	}
	//Z0012, LT - koniec
}

void info(void)
{
//	printf("\n\n\n\n");
	printf("--------------------------------------------------------\n");
//	printf("|                                                      |\n");
	printf("|      UPS Monitor Serwer wersja %-10s            |\n",ver);
	printf("|      Fideltronik www.fideltronik.com                 |\n");
//	printf("|                                                      |\n");
	printf("|                                  Krakow %-12s |\n",dat_build);
//	printf("|                                                      |\n");
	printf("--------------------------------------------------------\n");	//\n\n");
}

//Z0002, LT - odczyt konfiguracji
#define LINE_LEN    80
#define VALUE_LEN   60

int readOptions(UINT *sPortIP, UINT *cPortIP, char *serialPort, char *location, UINT *shTime, char *protocol,
	char *cfg)	//Z0007, LT - sciezka do konfiguracji
{
    FILE *f = fopen("/etc/ups/fideltronik/options.cfg", "r");   //sciezka na sztywno!
    if(f == NULL)
    {
		perror("Blad w funkcji readOptions");
        return -1;
    }
    char    variable[LINE_LEN];
    while(fgets(variable, LINE_LEN, f))
    {
        if(variable[0] == '#')      //komentarz lub pusta
            continue;
        char *value = strchr(variable, '=');
        if(value == NULL)       //nie jest to przypisanie zmiennej (np. pusta)
            continue;
        //wyodrebnienie zmiennej i wartosci przez wyciecie '=' '"' i '\n'
        *value = 0;
        value++;
        char *p = strchr(value, '\n');
        if(p)
            *p = 0;
        p = strchr(value, '\"');
        if(p)
        {
            value = p + 1;
            p = strrchr(value, '\"');
            if(p)
                *p = 0;
        }
        //przepisanie wartoci do odpowiedniej zmiennej w programie
        if(strcmp(variable, "SERVER_PORT_IP") == 0)
            *sPortIP = atoi(value);
        else if(strcmp(variable, "CLIENT_PORT_IP") == 0)
            *cPortIP = atoi(value);
        else if(strcmp(variable, "SERIAL_PORT") == 0)
            strncpy(serialPort, value, VALUE_LEN);
        else if(strcmp(variable, "UPS_NAME") == 0)
            strncpy(location, value, VALUE_LEN);
        else if(strcmp(variable, "SHUTDOWN_TIME") == 0)
            *shTime = atoi(value);
        else if(strcmp(variable, "PROTOCOL") == 0)
            strncpy(protocol, value, VALUE_LEN);
        else if(strcmp(variable, "PATH_CONFIG") == 0)	//Z0007, LT
            strncpy(cfg, value, VALUE_LEN);
//        if(__debug)
//            printf("variable: %s, value: %s\n", variable, value);
    }
    return 0;
}
//Z0002 koniec

//Z0008, LT - wydzielone przejscie do tla

//Z0012, LT - przenosze sie do jednej funkcji funcsig z casem
//void sigchild(int type)
//{
//	wait(NULL);
//	ThreadCancel = 1;
//}

void	background(CSharedMemory *shmem)
{
	if(__debug==0)
	{
		int pid=fork();
		if(pid<0)
		{
			if(__debug)
				printf("Error start deamon\n");
			perror("Start ");
			exit(EXIT_FORK_ERROR);
		}
		if(pid>0)
		{ //parent
//			printf("Parent pid=%d\n",pid);
			//Z0012, LT - byl sigchild, a teraz jedna funkcja do sygnalow z casem
			signal(SIGCHLD, funcsig);		//bede informowany o padnieciu childa przez ThreadCancel
			//teraz sprawdzam czy nie padl z powodu bledu
			shmem->Set(EXIT_TIMEOUT_ERROR, 1, SHARED_MEM_RESULT);
			int timeout = 30;
			while(--timeout)
			{
				unsigned char	mem;
				shmem->Read(&mem, 1, SHARED_MEM_RESULT);
				if(mem != EXIT_TIMEOUT_ERROR)
				{
//					shmem->Destroy();	//Z0009, LT - nie moge tego wolac, jesli wolam exit, bo zmniejsza o 2
					exit(mem);		//zwracam kod wykonania operacji polaczenia z UPSem (w tym 0)
				}
				sleep(1);
			}
//			shmem->Destroy();	//Z0009, LT - nie moge tego wolac, jesli wolam exit, bo zmniejsza o 2
			exit(EXIT_TIMEOUT_ERROR);
		}
		//dalszy kod dotyczy childa
		sleep(1);
		if(daemon(1, 1))
			perror("Tworzenie daemona");
		(void)setsid();
		setpgrp();
		signal(SIGCHLD,SIG_IGN);
		umask(0);
	}
}
//Z0008 - koniec

int main(int argc,char *argv[])
{
	info();
	FILE *fdShutOff;

	//Z0007, LT - czyszczenie pliku z flaga wylaczenia przeniesione dalej
//	int Port=-1;
    char    Port[VALUE_LEN] = "/dev/ttyS0";     //Z0002, LT - zwiekszam dugosc
	char    loc[VALUE_LEN] = "UPS server";      //Z0002, LT - zwiekszam dugosc
	//Z0002, LT - nowe zmienne
    UINT    serverPortIP = 0;
    UINT    clientPortIP = 0;
    UINT    shutdownTime = 60;
    char    protocol[VALUE_LEN] = "any";
    //Z0002 - koniec
	char	cfg[VALUE_LEN];	//Z0007, LT - sciezka do konfiguracji
    if(readOptions(&serverPortIP, &clientPortIP, Port, loc, &shutdownTime, protocol, cfg) < 0) //Z0002, LT - odczyt konfiguracji
    {
        printf("Blad odczytu konfiguracji\n");
        exit(EXIT_CFG_ERROR);	//Z0008, LT
    }
	//Z0012, LT - utworzenie sciezki na status
	strncpy(GlobalStatusPath, cfg, sizeof(GlobalStatusPath));
	strncat(GlobalStatusPath, UPS_STATUS_FILE, sizeof(GlobalStatusPath)-strlen(GlobalStatusPath)-1);
	//Z0012, LT - koniec
	//Z0007, LT - czyszczenie pliku z flaga wylaczenia
	strcat(cfg, SHM_FILE);
	fdShutOff = fopen(cfg, "w");
	if (fdShutOff != NULL)
	{
		fprintf(fdShutOff,"0 0\n");	//nie bedzie wy1aczal
		fclose(fdShutOff);
	}
	else
		perror(cfg);
	//Z0007, LT - koniec
	//Z0005, LT - konwersja nazwy protokolu na maske bitowa
	UINT prot = ~0;
	if(strcmp(protocol, "SEC26") == 0)
		prot = PROTOCOL_SEC26;
	else if(strcmp(protocol, "MEGATEC") == 0)
		prot = PROTOCOL_MEGATEC;
	else if(strcmp(protocol, "NEWAVE") == 0)
		prot = PROTOCOL_NEWAVE;
	else if(strcmp(protocol, "JOINT") == 0)
		prot = PROTOCOL_JOINT;
	//Z0005, LT - koniec
    int i;
    for(i = 1; i < argc; i++)
    {
        if(argv[i][0] == '-')
        {
            switch(argv[i][1])
            {
                case 'c':
//Z0001, LT - by3o %d i indeksy 1 zamiast i
        			if(strlen(argv[i]) == 4)
        				sprintf(Port, "/dev/ttyS%c", argv[i][3]);
        			else
        			    strncpy(Port, argv[i]+3, VALUE_LEN);    //Z0002, LT - ograniczam dlugosc
        			break;
                case 'l':
                    strncpy(loc, argv[i]+3, VALUE_LEN);     //Z0002, LT - ograniczam dlugosc
                    break;
                case 'd':
                    __debug = 1;
                    break;
            }
        }
        else
        {
            strcat(loc, " ");
            strncat(loc, argv[i], VALUE_LEN-strlen(loc));   //Z0002, LT - ograniczam dlugosc
        }
    }
//	if(argc>=3)
//	{
//		if(strcmp(argv[1],"-c=0")==0)
//			Port=0;
//		if(strcmp(argv[1],"-c=1")==0)
//			Port=1;
//		if(strcmp(argv[1],"-c=2")==0)
//			Port=2;
//		if(strcmp(argv[1],"-c=3")==0)
//			Port=3;
//		if(strcmp(argv[2],"-d")==0) //debug
//			__debug=1;
//	}
//	else
//	{
//		printf("Podaj numer portu -c= i lokalizacje -l=..\n");
//		exit(0);
//	}
//	if(Port==-1)
//	{
//		printf("Podaj opcje port -c=numer_portu\n");
//	}
//	char loc[255]={0};
//	char *str;
//	if(__debug && argc<=3)
//	{
//		printf("Podaj lokalizacje -l=...\n");
//		exit(0);
//	}
//	str=strstr(argv[2+__debug],"-l=");
//	if(str!=NULL)
//	{
//		str=argv[2+__debug];
//		strcpy(loc,str+3);
//		//printf("Mam -=l -%s-\n",str);
//	}
////////////////////////////// uruchomienie systemu jako demon
	CUPSSrv			UpsSrv;		//Z0008, LT - przenioslem wczesniej, zeby miec juz pamiec dzielona
//Z0009, LT - wyciete bo jest w konstruktorze	UpsSrv.m_SharedMem.Create();	//Z0008, LT - teraz wczesniej
	//Z0008, LT - wejscie w tlo ujete w funkcje
	background(&UpsSrv.m_SharedMem);

	ThreadCounter |= THREAD_MAIN;
	signal(SIGTERM, funcsig);
	signal(SIGUSR1, funcsig);		//Z0012, LT
/////////////////////////////
//Z0008, LT - wczesniej		CUPSSrv			UpsSrv;
	UpsSrv.SetTurnOffDelay(shutdownTime);	//Z0006, LT
	UpsSrv.SetCfgPath(cfg);					//Z0007, LT
	pthread_t mythread;
//	int i;
	for(i=1; i<argc-2-__debug; i++)
	{
		strcat(loc," ");
		//printf("Param i=%d -%s- \n",i,argv[2+i]);
		strcat(loc,argv[2+i+__debug]);
	}
	//printf("Loc -%s-\n",loc);
	if(__debug)
		printf("Debug Version %d\n",__debug);
	if ( pthread_create(&mythread,(pthread_attr_t  *)0,onTimer,(void *)&UpsSrv))
	{ //watek obsluguje RS
		UpsSrv.m_SharedMem.Set(EXIT_THREAD_ERROR, 1, SHARED_MEM_RESULT);	//Z0008, LT - kod bledu dla proc mac.
		perror("error creating thread.");
		exit(0);	//Z0008, LT - raczej nie ma sensu dalej dzialac
	}

//	printf("UPS Monitor Serwer wersja %s data %s\n", ver, dat_build);
	//Z0003, Z0005, LT - nowe parametry: porty IP, protokol
	if(!UpsSrv.Init(Port, loc, serverPortIP, clientPortIP, prot))
	{
//		return 1;
		UpsSrv.m_SharedMem.Set(EXIT_NET_ERROR, 1, SHARED_MEM_RESULT);	//Z0008, LT - poinf proc macierz o bledzie
		exit(0);
	}
	while(ThreadCancel == 0)
	{ //czekam na unload
//		ThreadSwitch();
		delay(100);
	}
	//czekam na zamkniecie pozosta3ych w1tkw z timeoutem 3s
	for(i = 0; i < 30 && ThreadCounter != THREAD_MAIN; i++)
	{
//		ThreadSwitch();
		delay(100);
	}
	UpsSrv.m_Net.Disconnect();	//je?li siea ci1gle czeka zabijam socketa na chama
	while(ThreadCounter != THREAD_MAIN)
	{
//		ThreadSwitch();
		delay(100);
	}
//	m_Info->m_CS.Destroy();		//zamykam to co otworzylem w tym watku
//Z0009, LT		UpsSrv.m_SharedMem.Destroy();
	ThreadCounter &= ~THREAD_MAIN;	//teraz obsluga signala moze konczya
//	return 1;
	exit(0);	//Z0009, LT - zamiast Destroy, przynajmniej wiem, e zmniejsza raz
}

