///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/23 13:46:37 $
//         $Locker:  $
//         $Revision: 1.9 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Komunikacja sieciowa
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: netdatag.cpp,v $
// Revision 1.9  2004/07/23 13:46:37  ltokarski
// Z0014 - poprawiony sporadyczny blad zwiazany z niezwolnieniem socketa i perror po Connect
//
// Revision 1.8  2004/06/29 10:19:25  ltokarski
// Z0008 - wejscie w tlo po zainicjowaniu komunikacji i zwracanie kodu bledu
//
// Revision 1.7  2004/06/23 12:30:06  ltokarski
// Z0003 - uzywanie portow IP pobranych z pliku opcji
//
// Revision 1.6  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/un.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <pthread.h>
#include "linux_ty.h"
#include "comport.h"
#include "upsmon.h"
#include "thread.h"
#include "netdatag.h"
#include "smem.h"
#include "upsmon.h"
#include "upssrv.h"

extern int errno;
extern int __debug;

/////////////////////////////////////////////////////////////////////////////
void *OnReceiveThread(LPVOID UpsSrv1)
{
	CUPSSrv	*UpsSrv=(CUPSSrv *)UpsSrv1;
	ThreadCounter |= THREAD_NET;
	do
	{
		UpsSrv->m_Net.OnReceive(0);
	}
	while(!ThreadCancel);
	ThreadCounter &= ~THREAD_NET;
	return (void *)0;
}

CNetDatagram::CNetDatagram()
{
	m_UPSSrv=NULL;
	m_Socket=0;
} // CNetDatagram::CNetDatagram


/////////////////////////////////////////////////////////////////////////////
CNetDatagram::~CNetDatagram()
{
	if(m_Socket!=0)
		  Disconnect();
} // CNetDatagram::~CNetDatagram


/////////////////////////////////////////////////////////////////////////////
BOOL CNetDatagram::Connect(CUPSSrv *UPSSrv, UINT sPort, UINT cPort)	//Z0003, LT - nowe parametry: porty IP
{
	m_UPSSrv=UPSSrv;
//   printf("CNetDatagram::Connect\n");
	if(m_Socket!=0)
		Disconnect();
	//m_Socket=new CDatagramSock(this);
	//new CDatagramSock(this);
	//printf("CNetDatagram CDatagramSock %ld\n",m_Socket);
	//if(m_Socket==0) return FALSE;
	m_Socket=socket(AF_INET,SOCK_DGRAM,0);
	//printf("CNetDatagram CDatagramSock m_Socket %d\n",m_Socket);
	if(m_Socket<0)
	{
//      printf("- Socket create ERROR\n");
//		printf("- Blad utworzenia socketa\n");
		perror("socket");
		return FALSE;
	}
	//Z0014, LT - zabezpieczenie gdyby socket jeszcze nie byl zwolniony
	int i;
	if(setsockopt(m_Socket, SOL_SOCKET, SO_REUSEADDR, &i, sizeof(int)) < 0)
	{
	    perror("setsockopt");
	    return FALSE;
	}
	//Z0014, LT - koniec
//   printf("CNetDatagram CDatagramSock m_Socket %d\n",m_Socket);
	//printf("OnReceive socket=%d\n",m_Socket);
	add_ser.sin_family=AF_INET;
	//printf("sin_family %d\n",add_ser.sin_family);
	add_ser.sin_addr.s_addr=htonl(INADDR_ANY);
	//printf("add=%d\n",add_ser.sin_addr.s_addr);
//	add_ser.sin_port=htons(8881);
	add_ser.sin_port=htons(sPort);	//Z0003, LT
	memset(&(add_ser.sin_zero),0,8);
	serlen=sizeof(add_ser);
	int res=bind(m_Socket,(struct sockaddr *)&add_ser,serlen);
	if(res==-1)
	{
//      printf("- Bind ERROR \n");
//		printf("- Blad instrukcji bind \n");
//		perror("Ustanawianie polaczenia sieciowego");
		perror("bind");
		if(close(m_Socket) < 0)
		    perror("close");	//Z0014, LT
		return FALSE;
	}
//  printf("+ Connect on port            %d\n",8881);
	if(__debug)
		printf("+ Polaczenie na porcie            %d\n", sPort);	//Z0003, LT - bylo 8881);
	clientPortIP = cPort;	//Z0003, LT
//	while(1)
//		OnReceive(0);
	pthread_t mythread;
	if(pthread_create(&mythread, NULL, OnReceiveThread, UPSSrv) != 0)
	{
		perror("error creating thread.");
		return false;
	}
	return true;
} // CNetDatagram::Connect



/////////////////////////////////////////////////////////////////////////////
void CNetDatagram::Disconnect()
{
	if(m_Socket!=0)
	{
	  //delete m_Socket;
		m_Socket=0;
	}
} // CNetDatagram::Disconnect


/////////////////////////////////////////////////////////////////////////////
BOOL CNetDatagram::SendTo(LPCTSTR Addr, BYTE Type, BYTE *Data, int DataLen)
{
	if(m_Socket==0)
	{
		if(__debug)
			printf("Proba wyslania na socket 0\n");
		return FALSE;
	}
	BYTE buff[UDP_MAX_PACKET_LEN];
	buff[0]=Type;
	buff[1]=(BYTE)DataLen;
	if(DataLen>0)
		memcpy(buff+2,Data,DataLen);
	unsigned short crc=CalcCRC(buff,2+DataLen);
	memcpy(buff+2+DataLen,&crc,2);

	struct sockaddr_in	add;
//	add.sin_port=htons(UPSmon_CLN_PORT);
	add.sin_port=htons(clientPortIP);	//Z0003, LT
	add.sin_addr=add_cli.sin_addr;

	add.sin_family=AF_INET;
	memset(&(add.sin_zero),0,8);
	if(__debug)
		printf("Wysylanie do %u\n", clientPortIP);
	sendto(m_Socket,buff,4+DataLen,0,(struct sockaddr *)&add,sizeof(sockaddr));
	return TRUE;
} // CNetDatagram::SendTo


/////////////////////////////////////////////////////////////////////////////
void CNetDatagram::OnReceive(int nErrorCode)
{
	if(nErrorCode)
		return;
	static BYTE buff[UDP_MAX_PACKET_LEN];
	static int offset=0;
	int len;
	char add[50];
//	int port;
	UINT port;
	clilen=sizeof(struct sockaddr);
	int res=recvfrom(m_Socket,buff,UDP_MAX_PACKET_LEN-1,0,(struct sockaddr *)&add_cli,(socklen_t *)&clilen);
	if(res==-1)
		perror("Recvfrom ");
	len=res;
	strcpy(add,inet_ntoa(add_cli.sin_addr));
	port=htons(add_cli.sin_port);
	if(len>0)
	{
		offset+=len;
		if(CheckPacket(buff,offset))
		{
			m_UPSSrv->OnRead(add,port,buff,offset);
			offset=0;
		}
	}
} // CNetDatagram::OnReceive


/////////////////////////////////////////////////////////////////////////////
BOOL CNetDatagram::CheckPacket(BYTE *Buff, int Len)
{
	if(Len<4)
		return FALSE;
	if(Len!=((int)Buff[1]+4))
		return FALSE;
	unsigned short crc, calcCrc=CalcCRC(Buff,Len-2);
	memcpy(&crc,Buff+(Len-2),2);
	if(crc!=calcCrc)
		return FALSE;
	//printf("Mam pakiet -%s- %02X %02X %02X %02X OK\n",Buff,Buff[0],Buff[1],Buff[2],Buff[3]);
	return TRUE;
} // CNetDatagram::CheckPacket


/////////////////////////////////////////////////////////////////////////////
unsigned short CNetDatagram::CalcCRC(BYTE *Buff, int Len)
{
	unsigned short crc=0;
	for(int i=0; i<Len; i++)
	{
		crc+=(unsigned short)Buff[i];
		//printf("Crc=%04X, %02X\n",crc,Buff[i]);
	}
	return crc;
} // CNetDatagram::CalcCRC

// EOF //////////////////////////////////////////////////////////////////////


