///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/20 10:18:55 $
//         $Locker:  $
//         $Revision: 1.8 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Pami dzielona
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: smem.cpp,v $
// Revision 1.8  2004/07/20 10:18:55  ltokarski
// Z0013 - wypisywanie w statusie protokolu komunikacji
//
// Revision 1.7  2004/07/01 10:10:59  ltokarski
// Z0010 - poprawienie wypisywania producenta i modelu
//
// Revision 1.6  2004/06/30 16:44:31  ltokarski
// Z0009 - uporzadkowanie pamieci dzielonej
//
// Revision 1.5  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <pthread.h>
#include <signal.h>
#include <termios.h>

#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>

#include "linux_ty.h"
#include "smem.h"

extern int __debug;

/////////////////////////////////////////////////////////////////////////////
CSharedMemory::CSharedMemory()
{
   ShMem=(void *)0;
   shmid=-1;
   Create();	//Z0009, LT - wyciete nieuzywane parametry

} // CSharedMemory::CSharedMemory


/////////////////////////////////////////////////////////////////////////////
CSharedMemory::~CSharedMemory()
{

} // CSharedMemory::~CSharedMemory


/////////////////////////////////////////////////////////////////////////////
BOOL CSharedMemory::Create()	//Z0009, LT - wyciete nieuzywane parametry
{
	//printf("Create Sharem mem\n");
   	shmid=shmget((key_t)1234,SIZE_SH_MEM,0666 | IPC_CREAT);

	if(shmid==-1)
	{
		perror("shmget");
		return FALSE;
	}

	ShMem=shmat(shmid,(void *)0,0);
	if(ShMem == (void *)-1)
	{
		perror("shmat");
		return FALSE;
	}
	struct shmid_ds s;
	if(shmctl(shmid, IPC_STAT, &s) < 0)
		perror("IPC_STAT");
//	printf("shmid = %d, ilosc = %d\n", shmid, (int)s.shm_nattch);
	return TRUE;
} // CSharedMemory::Create


/////////////////////////////////////////////////////////////////////////////
void CSharedMemory::Destroy()
{
	if(shmdt(ShMem)==-1)
	{
		perror(" shmdt");
		return;
	}
	if(shmctl(shmid,IPC_RMID,0)==-1)
	{
		perror(" shmctl");
		return;
	}
} // CSharedMemory::Destroy


/////////////////////////////////////////////////////////////////////////////
BOOL CSharedMemory::Set(BYTE Ch, DWORD Len, DWORD Offset)
{
	ShMemS=(struct ShMemStr *)ShMem;
	ShMemS->flag=1;
	memset(ShMemS->t+Offset,Ch,Len);
	return TRUE;
} // CSharedMemory::Set


/////////////////////////////////////////////////////////////////////////////
BOOL CSharedMemory::Write(BYTE *Buff, DWORD Len, DWORD Offset)
{
	if(__debug)
		printf("Sharem mem write \n");
    ShMemS=(struct ShMemStr *)ShMem;
	ShMemS->flag=1;
	memcpy(ShMemS->t+Offset,Buff,Len);
	return TRUE;
} // CSharedMemory::Write


/////////////////////////////////////////////////////////////////////////////
BOOL CSharedMemory::Read(BYTE *Buff, DWORD Len, DWORD Offset)
{
   ShMemS=(struct ShMemStr *)ShMem;

	if(ShMemS->flag==1)
	{
		if(__debug)
			printf("Read flag=%d,str=%s\n",ShMemS->flag,ShMemS->t);
		memcpy(Buff,ShMemS->t+Offset,Len);
		ShMemS->flag=0;
		return TRUE;
	}
	return FALSE;
} // CSharedMemory::Read

// EOF //////////////////////////////////////////////////////////////////////
