///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/20 10:18:55 $
//         $Locker:  $
//         $Revision: 1.12 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Klasa poredniczca z wtkiem komunikacji RS
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: thread.cpp,v $
// Revision 1.12  2004/07/20 10:18:55  ltokarski
// Z0013 - wypisywanie w statusie protokolu komunikacji
//
// Revision 1.11  2004/06/29 10:19:25  ltokarski
// Z0008 - wejscie w tlo po zainicjowaniu komunikacji i zwracanie kodu bledu
//
// Revision 1.10  2004/06/23 15:40:24  ltokarski
// Z0005 - sprawdzanie wybranego protokolu
//
// Revision 1.9  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include <signal.h>
#include <termios.h>
#include <string.h>
#include "linux_ty.h"
#include "comport.h"
#include "upsmon.h"
#include "thread.h"
#include "ups.h"
#include "smem.h"

#define FALSE 0
#define TRUE  1

extern int __debug;
extern int SearchUPSRetries;

/////////////////////////////////////////////////////////////////////////////
void *UPSThreadMain(LPVOID pParam /* CUPSThreadInfo* */)
{
	ThreadCounter |= THREAD_RS;
	CUPS UPS((CUPSThreadInfo*)pParam);
//   printf("Ups start--------------------------------------------\n");
	UPS.Start();
	//printf("Run start--------------------------------------------\n"); //odczyty z poru szeregowego
	sleep(1);	//Z0008, LT - zeby nie szukal UPSa, jak jest blad zainicjowania sieci
	while(!ThreadCancel)
	{
	    UPS.Run(((CUPSThreadInfo*)pParam)->protocol);	//Z0005, LT
		if(--SearchUPSRetries == 0)		//Z0008, LT - zliczam proby polaczen, potem foreground wyjdzie z bledem
			//ale kontynuuje dzialanie, bo moze potem nawiazac komunikacje
		{
			((CUPSThreadInfo*)pParam)->shmem->Set(EXIT_SEARCH_ERROR, 1, SHARED_MEM_RESULT);
		}
	}
	//printf("End start--------------------------------------------\n");
	UPS.End();
	ThreadCounter &= ~THREAD_RS;
	return 0;
} // UPSThreadMain


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
CUPSThreadInfo::CUPSThreadInfo()
{
	//m_MainWnd=NULL;
//	m_RSPort=-1;
    m_RSPort[0] = 0;
	m_IsRunning=0;
	m_ActionInProgress=FALSE;
	m_ActionType=ACTION_NO_BREAK;
	m_RetVal=FALSE;
	m_BatAutonomy = -1;	// 2003.01.06, MW
	m_UPSStatus = -1;	// 2003.01.06, MW


} // CUPSThreadInfo::CUPSThreadInfo


/////////////////////////////////////////////////////////////////////////////
CUPSThreadInfo::~CUPSThreadInfo()
{
} // CUPSThreadInfo::~CUPSThreadInfo


/////////////////////////////////////////////////////////////////////////////
//void CUPSThreadInfo::Init(int RSPort)
void CUPSThreadInfo::Init(char *RSPort)
{
	//m_MainWnd=AfxGetMainWnd()->m_hWnd;
//	m_RSPort=RSPort;
	strncpy(m_RSPort, RSPort, 20);
	m_CommunicationOK=FALSE;
	m_Protocol = 0;	//Z0013, LT
//   for(int i=1; i<=MAX_PARAM; i++) m_AvailPar[i]=0;
} // CUPSThreadInfo::Init


/////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////


/////////////////////////////////////////////////////////////////////////////
CUPSThread::CUPSThread()
{
	m_Info=NULL;
} // CUPSThread::CUPSThread


/////////////////////////////////////////////////////////////////////////////
CUPSThread::~CUPSThread()
{
} // CUPSThread::~CUPSThread


/////////////////////////////////////////////////////////////////////////////
//BOOL CUPSThread::Start(CUPSThreadInfo *Info, int RSPort)
//BOOL CUPSThread::Start(CUPSThreadInfo *Info, int RSPort)
BOOL CUPSThread::Start(CUPSThreadInfo *Info, char *RSPort)
{
	pthread_t mythread;
	m_Info=Info;
	//	printf("CUPS Start port %d\n",RSPort);
	m_Info->Init(RSPort);

	//if(!AfxBeginThread(UPSThreadMain,Info)) return FALSE;
// int  pthread_create(pthread_t *thread, pthread_attr_t  *attr,void  *(*start_routine)(void *),void *arg);

	//printf("Create thread\n");
	if ( pthread_create( &mythread,(pthread_attr_t  *)0,UPSThreadMain,(void *)Info))
	{
		perror("error creating thread.");
		ThreadCounter &= ~THREAD_MAIN;
		m_Info->shmem->Set(EXIT_THREAD_ERROR, 1, SHARED_MEM_RESULT);	//Z0008, LT - kod bledu dla proc mac.
		raise(SIGTERM);
		exit(0);
	}

	// czekamy az watek rozpocznie prace
  //UPSThreadMain(Info);


	int isRunning=0;
	//printf("\t\t\t\t\t\tRS is running\n\t\t\t\t\tWait thread %d\n",isRunning);
	while(isRunning==0)
	{
	  m_Info->m_CS.Lock();
	  isRunning=m_Info->m_IsRunning;
	  m_Info->m_CS.Unlock();
	  //printf("Thread O %d\n",m_Info->m_IsRunning);
	}
	//printf("\t\t\t\t\tThread RS OK %d\n",m_Info->m_IsRunning);
	// powiadamiamy watek ze wiemy o rozpoczeciu pracy
	m_Info->m_CS.Lock();
	m_Info->m_IsRunning=2;
	m_Info->m_CS.Unlock();

	return TRUE;
} // CUPSThread::Start


/////////////////////////////////////////////////////////////////////////////
//LT: nieuzywany
//void CUPSThread::Stop()
//{
//   if(m_Info==NULL) return; // watek nie byl uruchomiony
//
//  m_Info->m_ActionType=ACTION_TERMINATE;
//
//
//   // powiadamiamy watek zeby zakonczyl prace
//   //m_Info->m_CS.Lock();
//   //m_Info->m_Terminate=TRUE;
//   //m_Info->m_CS.Unlock();
//
//   // czekamy na zakonczenia pracy watku
//   int isRunning=2;
//   while(isRunning>0)
//   {
//      m_Info->m_CS.Lock();
//      isRunning=m_Info->m_IsRunning;
//      m_Info->m_CS.Unlock();
//   }
//} // CUPSThread::Stop


/////////////////////////////////////////////////////////////////////////
BOOL CUPSThread::DoAction(BYTE ActionType, long ActionData)
{
	if(m_Info==NULL)
		return FALSE; // watek nie byl uruchomiony

	// sprawdzamy czy jest komunikacja z UPS
	/////////
	m_Info->m_CS.Lock();
	BOOL retVal=TRUE;
	if(!m_Info->m_CommunicationOK)
		retVal=FALSE;
	m_Info->m_CS.Unlock();
	if(!retVal)
		return FALSE; // brak komunikacji, wiec nie ma sensu wykonywac akcji
	/////////
//	if(!m_Info->m_CommunicationOK)
//		return FALSE; // brak komunikacji, wiec nie ma sensu wykonywac akcji
	/////////

	// powiadamiamy watek zeby wykonal akcje
	m_Info->m_CS.Lock();
	m_Info->m_ActionInProgress=TRUE;
	m_Info->m_ActionType=ActionType;
	m_Info->m_ActionData=ActionData;
	m_Info->m_RetVal=FALSE;
//	m_Info->m_ActionType=ActionType;
	m_Info->m_CS.Unlock();

	// czekamy na wykonanie akcji
	////////////////////////
	BOOL actionInProgress=TRUE;
	while(actionInProgress)
	{
	  m_Info->m_CS.Lock();
	  actionInProgress=m_Info->m_ActionInProgress;
	  m_Info->m_CS.Unlock();
	  sleep(1);
	}

	// pobieramy wynik
	m_Info->m_CS.Lock();
	retVal=m_Info->m_RetVal;
	m_Info->m_CS.Unlock();
//	if(__debug)
//		printf("CUPSThread::DoAction return %d\n", retVal);

	return retVal;
	////////////////////////
//	while(m_Info->m_ActionInProgress)
//		usleep(100000);
//	if(__debug)
//		printf("CUPSThread::DoAction return %d\n", m_Info->m_RetVal);
//	return m_Info->m_RetVal;
} // CUPSThread::DoAction

void CCriticalSection::Lock(void)
{
}

void CCriticalSection::Unlock(void)
{
}

// EOF //////////////////////////////////////////////////////////////////////
