///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/20 10:18:55 $
//         $Locker:  $
//         $Revision: 1.12 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Klasa poredniczca z wtkiem komunikacji RS
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: thread.h,v $
// Revision 1.12  2004/07/20 10:18:55  ltokarski
// Z0013 - wypisywanie w statusie protokolu komunikacji
//
// Revision 1.11  2004/07/09 11:32:01  ltokarski
// Z0012 - zapis biezacego statusu do pliku
//
// Revision 1.10  2004/06/29 10:19:25  ltokarski
// Z0008 - wejscie w tlo po zainicjowaniu komunikacji i zwracanie kodu bledu
//
// Revision 1.9  2004/06/25 11:42:18  ltokarski
// Z0007 - przywrocenie zapisu do upsoff.conf
//
// Revision 1.8  2004/06/24 12:20:08  ltokarski
// Z0006 - konfigurowany czas opoznienia do wylaczenia (oprocz stykowych)
//
// Revision 1.7  2004/06/23 15:40:24  ltokarski
// Z0005 - sprawdzanie wybranego protokolu
//
// Revision 1.6  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#ifndef _Thread_h_
#define _Thread_h_

extern int volatile	ThreadCounter;
extern int volatile	ThreadCancel;

#define THREAD_MAIN		1
#define THREAD_NET		2
#define THREAD_RS		4

/////////////////////////////////////////////////////////////////////////////
void *UPSThreadMain(LPVOID pParam /* CUPSThreadInfo* */);


class CCriticalSection
{
	public:
		void Lock(void);
		void Unlock(void);
};

/////////////////////////////////////////////////////////////////////////////
class CUPSThreadInfo
{
public:
	CUPSThreadInfo();
	~CUPSThreadInfo();

//	void Init(int RSPort);
	void Init(char *RSPort);

	void	SetTurnOffDelay(UINT d) { TurnOffDelay = d; };	//Z0006, LT
	UINT	GetTurnOffDelay() { return TurnOffDelay; };		//Z0006, LT
	void	SetCfgPath(char *cfg) { configPath = cfg; };	//Z0007, LT
	char	*GetCfgPath() { return configPath; };			//Z0007, LT

	CCriticalSection m_CS;       // sekcja krytyczna
	//HWND m_MainWnd;              // handler glownego okna
//	int m_RSPort;                // numer portu do ktorego podlaczony jest UPS
	char m_RSPort[20];           // numer portu do ktorego podlaczony jest UPS
	BOOL m_Autostart;            // wartosc opcji automatycznego startu po powrocie zasilania

	BOOL /*volatile*/ m_ActionInProgress;     // jezeli TRUE to akcja jest wykonywana
	BYTE /*volatile*/ m_ActionType;           // jedna ze stalych ACTION_ sluzy do komunikacji
										// pomiedzy watkiem glownym i roboczym
	long /*volatile*/ m_ActionData;	// dodatkowe dane, w zaleznosci od m_ActionType
	BOOL /*volatile*/ m_RetVal;			// okresla czy akcja sie powiodla
	int m_IsRunning;             // jezeli >0 to watek jest uruchomiony
	BOOL m_JointTurnOffFlag;     // flaga wylaczenia UPSa z interfejsem stykowym
	BOOL m_JointTurnOffUPSOnly; // 2003.01.15, MW, flaga wylaczania UPS-a stykowego, bez zamykania systemu


	BOOL m_CommunicationOK;      // jezeli FALSE to brak komunikacji z UPSem
	// zmienne informujace o stanie UPS'a
	//   char m_AvailPar[MAX_PARAM+1];// dostepne parametry (ID takie jak w protokole)
	char m_CanAutostart;         // ==1 gdy UPS mozna programowo ustawic aby
	                        // automatycznie wlaczal sie po powrocie zasilania
	char m_CanTurnOff;           // ==1 gdy UPS mozna programowo wylaczyc
	char m_AvpMan;               // ==1 gdy zmienna 55 - Manufacturer jest dostepna
	char m_AvpMod;               // ==1 gdy zmienna 56 - Model jest dostepna
	char m_AvpSoftVer;           // ==1 gdy zmienna 84 - Software Version jest dostepna


	char m_Manufacturer[LEN_MAN];// 55 - Manufacturer
	char m_Model[LEN_MODEL];     // 56 - Model
	char m_SoftVer[LEN_SOFT_VER];// 84 - Software Version
	char m_BatCondition;         // 19 - Batter Condition
	char m_BatStatus;            // 22 - Battery Status
	short m_BatVol;              // 24 - Battery Voltage
	short m_InVol;               // 51 - Input Voltage 1
	short m_OutCurrent;          // 65 - Output Current 1
	short m_OutLoad;             // 69 - Output Load 1
	long m_OutPower;             // 73 - Output Power 1
	char m_OutSource;            // 76 - Output Source
	short m_OutVol;              // 77 - Output Voltage 1
	long m_BatAutonomy;			// (2003.01.02, MW)
	short m_UPSStatus;			// (2003.01.02, MW)
	BYTE	m_Status;			//Z0012, LT - nie wiedziec czemu to nie bylo dotad przesylane
	UINT	protocol;	//Z0005, LT
	UINT	TurnOffDelay;	//Z0006, LT - z OGROMNA przykroscia dodaje kolejna zmienna
							//poniewaz nie jestem w stanie zrozumiec dokonan poprzednikow i uproscic tego
	char	*configPath;	//Z0007, LT
	class CSharedMemory *shmem;	//Z0008, LT
	BYTE m_Protocol;	//Z0013, LT
};


/////////////////////////////////////////////////////////////////////////////
class CUPSThread
{
public:
   CUPSThread();
   ~CUPSThread();

//   BOOL Start(CUPSThreadInfo *Info, int RSPort);
   BOOL Start(CUPSThreadInfo *Info, char *RSPort);
   BOOL DoAction(BYTE ActionType, long ActionData =-1);
//   void Stop();

protected:
   CUPSThreadInfo *m_Info;      // wskaznik na obiekt komunikacyjny
};

#endif // _Thread_h_

// EOF //////////////////////////////////////////////////////////////////////
