///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/20 10:18:55 $
//         $Locker:  $
//         $Revision: 1.7 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Wsplna obsuga rnych modeli UPSw
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: ups.h,v $
// Revision 1.7  2004/07/20 10:18:55  ltokarski
// Z0013 - wypisywanie w statusie protokolu komunikacji
//
// Revision 1.6  2004/06/25 11:42:18  ltokarski
// Z0007 - przywrocenie zapisu do upsoff.conf
//
// Revision 1.5  2004/06/23 15:40:24  ltokarski
// Z0005 - sprawdzanie wybranego protokolu
//
// Revision 1.4  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#ifndef _UPS_h_
#define _UPS_h_

#define UPS_NO_UPS

#define SHM_FILE	"upsoff.conf"	//Z0006, LT - teraz zmienna sciezka "/etc/ups/scripts/upsoff.conf"

class CUPSThreadInfo;

class CUPS
{
public:
   CUPS(CUPSThreadInfo *Info);
   ~CUPS();

   void Start();
   void Run(UINT protocol);	//Z0005, LT - wybor protokolu
   void End();

protected:
   CUPSThreadInfo *m_Info;      // wskaznik na obiekt komunikacyjny
};


class CUPSGeneric
{
public:
   CUPSGeneric(CUPSThreadInfo *Info);
   virtual ~CUPSGeneric();

   BOOL StartMonitoring();

protected:
   CUPSThreadInfo *m_Info;      // wskaznik na obiekt komunikacyjny
   CComPort m_ComPort;          // obsluguje komunikacje z portem RS
   BOOL m_CommunicationOK;      // jezeli FALSE to brak komunikacji z UPSem
   BYTE m_Status;               // stan UPS
   char m_BatStatus;            // 22 - Battery Status (kopia z m_Info)
   char m_OutSource;            // 76 - Output Source (kopia z m_Info)

   void UpdateUPSStatus();
   BYTE CheckAction(BYTE &ActionType);
   void DoAction(BYTE ActionType);

   virtual BOOL OpenUPS() = 0;
   virtual void CloseUPS() = 0;
   virtual BOOL GetStaticData() = 0;
   virtual BOOL GetDynamicData() = 0;
   virtual BOOL DoSetAutostart(BOOL Autostart) = 0;
    virtual BOOL DoTurnOff(BOOL SetAutostart, BYTE JointCloseOpt=0) = 0;
   virtual BOOL DoRestart() = 0;
   BYTE m_Protocol;	//Z0013, LT
};



#endif // _UPS_h_

// EOF //////////////////////////////////////////////////////////////////////
