///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/09 11:32:03 $
//         $Locker:  $
//         $Revision: 1.3 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Komunikacja z zasilaczami Saturn
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: upssatur.h,v $
// Revision 1.3  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#ifndef _UPSSaturn_h_
#define _UPSSaturn_h_

class CUPSSaturn : public CUPSGeneric
{
public:
   CUPSSaturn(CUPSThreadInfo *Info);
   ~CUPSSaturn();

protected:
   short m_MaxCurr;                 // maksymalne natezenie (w 0.1 A), gdy ==-1 to niedostepne
   short m_CellsInBat;              // ilosc cel w bateriach, gdy ==-1 to niedostepne
   long m_MaxPower;

   BOOL OpenUPS();
   void CloseUPS();
   BOOL GetStaticData();
   BOOL GetDynamicData();
   BOOL DoSetAutostart(BOOL Autostart);
   BOOL DoTurnOff(BOOL SetAutostart,BYTE JointCloseOpt=0);
   BOOL DoRestart();

   BOOL SendAndGetResponse(LPCTSTR Cmd, BYTE *Buff, int &Len);
   void SendPacket(LPCTSTR Cmd);
   BOOL GetPacket(BYTE *Buff, int &Len, LPCTSTR Cmd);
   BOOL CheckPacket(BYTE *Buff, int Len, LPCTSTR Cmd);
   long GetNum(BYTE *Buff, int &Offset);
   time_t m_clock();
};

#endif // _UPSSaturn_h_

// EOF //////////////////////////////////////////////////////////////////////
