///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/23 13:46:37 $
//         $Locker:  $
//         $Revision: 1.18 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Odpowiednik serwisu w Windows
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: upssrv.cpp,v $
// Revision 1.18  2004/07/23 13:46:37  ltokarski
// Z0014 - poprawiony sporadyczny blad zwiazany z niezwolnieniem socketa i perror po Connect
//
// Revision 1.17  2004/07/06 12:11:55  ltokarski
// Z0011 - ignorowanie CLOSE_SYSTEM_RUNUPS w stykowcach
//
// Revision 1.16  2004/06/30 16:44:31  ltokarski
// Z0009 - uporzadkowanie pamieci dzielonej
//
// Revision 1.15  2004/06/29 10:19:25  ltokarski
// Z0008 - wejscie w tlo po zainicjowaniu komunikacji i zwracanie kodu bledu
//
// Revision 1.14  2004/06/25 11:42:18  ltokarski
// Z0007 - przywrocenie zapisu do upsoff.conf
//
// Revision 1.13  2004/06/24 12:20:08  ltokarski
// Z0006 - konfigurowany czas opoznienia do wylaczenia (oprocz stykowych)
//
// Revision 1.12  2004/06/23 15:40:24  ltokarski
// Z0005 - sprawdzanie wybranego protokolu
//
// Revision 1.11  2004/06/23 12:30:07  ltokarski
// Z0003 - uzywanie portow IP pobranych z pliku opcji
//
// Revision 1.10  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#include <stdio.h>
#include <string.h>
#include <time.h>
#include "linux_ty.h"
#include "upsmon.h"
#include "thread.h"
#include "netdatag.h"
#include "smem.h"
#include "upssrv.h"

extern BOOL DlgMain_m_JointTurnOffFlag; // flaga wykorzystywana przy wylaczaniu UPSa z interfejsem stykowym dla wersji 9x
extern BOOL DlgMain_m_JointTurnOffUPSOnly; // 2003.01.15, MW, flaga wylaczania UPS-a stykowego, bez zamykania systemu
extern int __debug;

/////////////////////////////////////////////////////////////////////////////
CUPSSrv::CUPSSrv()
{
	TurnOffDelay = UPS_SHUTDOWN_TIME;	//Z0006, LT - zainicjowanie na wypadek braku odczytu z konfiguracji
} // CUPSSrv::CUPSSrv


/////////////////////////////////////////////////////////////////////////////
CUPSSrv::~CUPSSrv()
{
} // CUPSSrv::~CUPSSrv


//////////////////////////
// zwraca ilosc sekund od poczatku pracy programu
time_t CUPSSrv::m_clock()
{
	time_t tm;
	static time_t tm_s;
	static time_t t_start=0;

	time(&tm);
	if(t_start==0)
	{
		t_start=1;
		time(&tm_s);
		return 0;
	}
	else
		return tm-tm_s;
}


/////////////////////////////////////////////////////////////////////////////
//BOOL CUPSSrv::Init(int Port, char * Location)
BOOL CUPSSrv::Init(char *Port, char * Location, UINT sPortIP, UINT cPortIP,	//Z0003, LT - nowe parametry: porty IP
	UINT protocol)	//Z0005, LT - kolejny nowy parametr, protokol UPSa
{
	memset(m_Location,0,MAX_LOC_LEN);
	strncpy(m_Location,Location,MAX_LOC_LEN);

//Z0008, LT - przeniesione wczesniej do main	m_SharedMem.Create(SHARED_MEM_NAME,SHARED_MEM_SIZE);

	m_SharedMem.Set(0xcc, 1, SHARED_MEM_OFFSET);	//Z0009, LT - tylko 1 bajt
//Z0009, LT	m_SharedMem.Write((unsigned char *)"Server Start",(long)12,(long)SHARED_MEM_OFFSET);
	m_Info.protocol = protocol;				//Z0005, LT
	m_Info.SetTurnOffDelay(TurnOffDelay);	//Z0006, LT
	m_Info.SetCfgPath(configPath);			//Z0007, LT
	m_Info.shmem = &m_SharedMem;			//Z0008, LT
	m_UPS.Start(&m_Info,Port);

	m_LastUpdateTime=m_clock()-(2*UPS_SRV_UPDATE_TIME); // aby na poczatku uaktualnic zmienne
	m_CommunicationOK=FALSE;
	m_CanAutostart=0;
	m_CanTurnOff=0;
	m_AvpMan=0;
	m_AvpMod=0;
	m_AvpSoftVer=0;
	memset(m_Manufacturer,0xFF,LEN_MAN);
	memset(m_Model,0xFF,LEN_MODEL);
	memset(m_SoftVer,0xFF,LEN_SOFT_VER);
	m_BatCondition=-1;
	m_BatStatus=-1;
	m_BatVol=-1;
	m_InVol=-1;
	m_OutCurrent=-1;
	m_OutLoad=-1;
	m_OutPower=-1;
	m_OutSource=-1;
	m_OutVol=-1;
	m_BatAutonomy = -1;				//	(2003.01.02, MW)
	m_UPSStatus = -1;				//	(2003.01.02, MW)
	m_ShutdownTimeDelay=-1;
	m_UPSShutdownTime=-1;
	m_Info.m_JointTurnOffFlag=FALSE;
	m_Info.m_JointTurnOffUPSOnly = FALSE; // 2003.01.15, MW, poprawa obslugu wylaczania UPS-a stykowego bez zamykania systemu
//	if(!m_Net.Connect(this,UPSmon_SRV_PORT))
	if(!m_Net.Connect(this, sPortIP, cPortIP))	//Z0003, LT
	{
//		printf("Connect Error\n");
//Z0014, LT - teraz wewnatrz		printf("Blad ustanowienia polaczenia sieciowego\n");
		return FALSE;
	}
	clientPortIP = cPortIP;	//Z0003, LT - pamietam w swojej zmiennej w celu filtrowania przychodzacych
	if(__debug)
		printf("Connect CupsSrv Init Success: \n");
	return TRUE;
} // CUPSSrv::Init


/////////////////////////////////////////////////////////////////////////////
//LT: nieuzywany
//void CUPSSrv::Stop()
//{
//	m_UPS.Stop();
//	m_Net.Disconnect();
//	m_SharedMem.Destroy();
//} // CUPSSrv::Stop

/////////////////////////////////////////////////////////////////////////////
void CUPSSrv::DoJointTurnOff(BYTE Mode, DWORD Time /*=0*/)
{
	//	2003.01.16, MW, poprawa obsugi wylaczania UPS-a stykowego bez zamykania OS
	//if(Mode==1) m_UPS.DoAction(ACTION_JOINT_TURN_OFF_9X);
	//else m_UPS.DoAction(ACTION_JOINT_TURN_OFF_NT,Time);
	if(__debug)
		printf("SRV DoJointOff mode %d\n",Mode);
	if(Mode==1)
		m_UPS.DoAction(ACTION_JOINT_TURN_OFF_9X); //6
	if(Mode==2)
		m_UPS.DoAction(ACTION_JOINT_TURN_OFF_NT,Time); //7
	if(Mode==3)
		m_UPS.DoAction(ACTION_TURN_OFF_JUPS_ONLY);//9
	if(Mode==4)
	{
		m_UPS.DoAction(ACTION_END_TURN_OFF_JUPS);    //10
		m_Info.m_CS.Lock();
		m_Info.m_JointTurnOffUPSOnly = FALSE;
		m_Info.m_CS.Unlock();
	}
	//	2003.01.16, MW, koniec

} // CUPSSrv::DoJointTurnOff



/////////////////////////////////////////////////////////////////////////////
void CUPSSrv::OnRead(LPCTSTR Addr, UINT Port, BYTE *Buff, int Len)
{
//	if(Port!=UPSmon_CLN_PORT)
	if(Port != clientPortIP)	//Z0003, LT
	{
		if(__debug)
			printf("ERROR PORT\n");
		return; // obslugujemy tylko pakiety od klientow
	}

	// do serwera nie powinien byc przeslany pakiet typu ANSWER, ignorujemy
	// takie pakiety
	if((Buff[0]&UDP_MASK_ANSWER_REQUEST)!=UDP_TYPE_REQUEST)
	{
		if(__debug)
			printf("Non-request received\n");
		return;
	}
	BYTE type=Buff[0]&(~UDP_MASK_ANSWER_REQUEST);
	BYTE data[UDP_MAX_PACKET_LEN];
	int len=0;
	// sprawdzamy czy nie nalezy uaktualnic na podstawie m_Info zmiennych
	// lokalnych (stosujemy aby przyspieszyc odpowiedzi na pakiety)
	//printf("Czy update %d  > %d\n",m_clock()-m_LastUpdateTime,1);
	if((m_clock()-m_LastUpdateTime)>=1/*UPS_SRV_UPDATE_TIME*/)
		UpdateLocalData();
		// gdy nie ma komunikacji z UPSem to nie odpowiadamy, wtedy
		// klient zglosi "brak komunikacji"
	if(!m_CommunicationOK)
	{
		if(__debug)
			printf("Brak CommunicationOK\n");
		return;
	}

	if(type==UDP_PACKET_CONNECT)
	{
		//printf("Len %d, %20X,%02X,%02X - MAX_LOC_LEN=%d %d,%d,%d\n",Len,data[0],data[1],data[2],MAX_LOC_LEN,m_Info.m_AvailPar[17],m_Info.m_AvailPar[82],m_Info.m_AvailPar[83]);
		if(Len!=4)
		{
			if(__debug)
				printf("Blad dlugosci pakietu 1\n");
			return;
		}
		memcpy(data,m_Location,MAX_LOC_LEN);
		data[MAX_LOC_LEN]=m_CanAutostart;
		data[MAX_LOC_LEN+1]=m_CanTurnOff;
		len=MAX_LOC_LEN+2;
		m_Net.SendTo(Addr,UDP_PACKET_CONNECT|UDP_TYPE_ANSWER,data,len);
	}
	else if(type==UDP_PACKET_GET_STATIC_DATA)
	{
		if(Len!=4)
		{
			if(__debug)
				printf("Blad dlugosci pakietu 2\n");
			return;
		}
		data[0]=m_AvpMan;
		memcpy(data+1,m_Manufacturer,LEN_MAN);
		data[1+LEN_MAN]=m_AvpMod;
		memcpy(data+2+LEN_MAN,m_Model,LEN_MODEL);
		data[2+LEN_MAN+LEN_MODEL]=m_AvpSoftVer;
		memcpy(data+3+LEN_MAN+LEN_MODEL,m_SoftVer,LEN_SOFT_VER);
		len=3+LEN_MAN+LEN_MODEL+LEN_SOFT_VER;
		m_Net.SendTo(Addr,UDP_PACKET_GET_STATIC_DATA|UDP_TYPE_ANSWER,data,len);
	}
	else if(type==UDP_PACKET_GET_DYNAMIC_DATA)
	{
		if(Len!=4)
		{
			if(__debug)
				printf("Blad dlugosci pakietu 3\n");
			return;
		}
		len = 27;	 //// dodatkowo m_BatAutonomy(4) i m_UPSStatus(2) (2003.01
		memcpy(data,m_DynamicDataBuff,len);
		m_Net.SendTo(Addr,UDP_PACKET_GET_DYNAMIC_DATA|UDP_TYPE_ANSWER,data,len);
	}
	else if(type==UDP_PACKET_UPS_OFF)
	{
		if(__debug)
			printf("Mam pakiet UPS_OFF len=%d\n",Len);
		if(Len!=6)
		{
			if(__debug)
				printf("Blad dlugosci pakietu 4\n");
			return;
		}
		//Z0009, LT - nie ma potrzeby uzywania 10 bajtow
		BYTE memBuff;
		m_SharedMem.Read(&memBuff, 1, SHARED_MEM_OFFSET);
		// zerujemy pamiec dzielona
		if(__debug)
			printf("Mem %d\n", (int)memBuff);
		m_SharedMem.Set(0xFF,1,SHARED_MEM_OFFSET);
		if(memBuff != SHARED_MEM_VALUE)
		{
//			printf("to zadanie nie przyszlo od lokalnego klienta: memBuff = %d\n", (int)memBuff);
			return; // to zadanie nie przyszlo od lokalnego klienta
		}
		//Z0009, LT - koniec
		if(__debug)
			printf("MAm pakiet UPS_OFF auto=%d, tutn=%d\n",Buff[2],Buff[3]);
		// ustawiamy odpowiednie zmienne
		char autostart=Buff[2];
		char turnoff=Buff[3];
		BOOL retVal=FALSE;
		if(turnoff)
		{
			if(autostart)
				retVal=m_UPS.DoAction(ACTION_TURN_OFF_AUTOSTART);
			else
				retVal=m_UPS.DoAction(ACTION_TURN_OFF);
		}
		else
		{
			if(autostart)
				retVal=m_UPS.DoAction(ACTION_SET_AUTOSTART);
			else
				retVal=m_UPS.DoAction(ACTION_UNSET_AUTOSTART);
		}
		//printf("retval %d\n", retVal);
		if(retVal)
		{
			m_Net.SendTo(Addr,UDP_PACKET_UPS_OFF|UDP_TYPE_ANSWER);
			if(turnoff)
			{
				// gdy mamy wylaczyc UPS to uaktualniamy czas do wylaczenia UPS
				m_StartShutdownTime=m_clock();
//				m_ShutdownTimeDelay=UPS_SHUTDOWN_TIME;
				m_ShutdownTimeDelay = TurnOffDelay;	//Z0006, LT
			}
			else
				m_ShutdownTimeDelay=-1;
				// m_UPSShutdownTime wyliczany jest w UpdateLocalData();
			UpdateLocalData();
		}
	}
	else if(type==UDP_PACKET_DO_TASK)
	{
//	2003.01.13, MW, zmiana formatu pakietu w zwiazku z dodaniem flagi z informacja
//  czy oprocz zamykania UPS-a bedzie tez zamykany system (wazne w przypadku wspolpracy
//  z UPS-ami stykowymi
		if(Len!=10)
		{
			if(__debug)
				printf("Blad dlugosci pakietu 5\n");
			return;
		}
		char tasktype = Buff[2];
		char CloseSystem = Buff[3];
		u_long ul;
		memcpy(&ul,Buff+4,4);
//	2003.01.13, MW, koniec

		long data=(long)ntohl(ul);
		BYTE memBuff[10];
		if(__debug)
		{
			printf("Odeb pakiet do task len=%d data=%ld %02X,%02X,%02X,%02X \n",Len,data,Buff[0],Buff[1],Buff[2],Buff[3]);
			printf("%02X,%02X,%02X,%02X ul=%ld data=%ld\n",Buff[4],Buff[5],Buff[6],Buff[7],ul,data);
		}
		// poniewaz mamy wylaczyc UPS to sprawdzamy pamiec dzielona
//// test

		m_SharedMem.Read(memBuff,1,SHARED_MEM_OFFSET);
		// zerujemy pamiec dzielona
		if(memBuff[0]!=SHARED_MEM_VALUE)
		{
			if(__debug)
				printf("Blad ustawienia sharedMem %d-%d\n",memBuff[0],SHARED_MEM_VALUE);
			m_SharedMem.Set(0,1,SHARED_MEM_OFFSET);
			return; // to zadanie nie przyszlo od lokalnego klienta
		}
		m_SharedMem.Set(0,1,SHARED_MEM_OFFSET);
		// wykonujemy akcje, gdy sie powiodlo to odpowiadamy
		BOOL retVal=FALSE;
		//m_Net.SendTo(Addr,UDP_PACKET_DO_TASK|UDP_TYPE_ANSWER);
		if(__debug)
		{
			printf("Task type %d i OFF=%d, RES=%d time_start=%d\n",tasktype,TASK_TURN_OFF,TASK_RESTART,(int)m_clock());
			printf("m_Info.m_UPSStatus=%X UPS_JOINT_ACTIVE=%X\n",m_Info.m_UPSStatus,UPS_JOINT_ACTIVE);
		}
		//	2003.01.16, MW, poprawa obslugi wylaczania UPS-a stykowego bez zamykania systemu
		////	2003.01.13, MW, dodana specjalna obsluga wylaczania UPS-a stykowego
		////	bez wylaczania systemu operacyjnego
		//if((tasktype==TASK_TURN_OFF)&&(CloseSystem==0))
		//{	// W takim przypadku UPS-a wylaczamy bez opoznienia
		//	retVal = m_UPS.DoAction(ACTION_TURN_OFF_JUPS_ONLY);
		//	if(retVal)
		//		m_Net.SendTo(Addr,UDP_PACKET_DO_TASK|UDP_TYPE_ANSWER);
		//
		//	return;
		//}
		//else
		////	2003.01.13, MW, koniec
		//	2003.01.16, MW, koniec

		//	2003.01.15, MW, poprawa obslugi wylaczania UPS-a stykowego bez zamykania systemu
		if(__debug)
			printf("SRV Task type %d %d CloseSytem=%d status=%d\n",tasktype,TASK_TURN_OFF,CloseSystem,m_Info.m_UPSStatus);
		if(tasktype==TASK_TURN_OFF)
		{
			m_Info.m_CS.Lock();
			if(m_Info.m_UPSStatus != -1 && (m_Info.m_UPSStatus & UPS_JOINT_ACTIVE))
			{
				if(__debug)
					printf("SRV OffOnly=1 Stat i mask =%X\n",(m_Info.m_UPSStatus & UPS_JOINT_ACTIVE));
				if(CloseSystem==0)
					m_Info.m_JointTurnOffUPSOnly = TRUE;
				else
				{
					//LT: Nie dopuszczam zamykania z wyczeniem, dlatego musz
					//"zwrci" FALSE
					m_Info.m_CS.Unlock();
					retVal = FALSE;
					if(__debug)
						printf("Zamykanie z wyczeniem, time=%d\n", (int)m_clock());
					return;
				}
			}
			m_Info.m_CS.Unlock();
			retVal = TRUE;
		}
		if(GetJointTurnOffUPSOnly()!=TRUE)
		{
		//	2003.01.15, MW, koniec
			if(tasktype==TASK_TURN_OFF)
				retVal = m_UPS.DoAction(ACTION_TURN_OFF);
			else if(tasktype==TASK_RESTART)
				retVal = m_UPS.DoAction(ACTION_RESTART,data);
		}	//	2003.01.15, MW, poprawa obslugi wylaczania UPS-a stykowego bez zamykania systemu

///*
//		if((tasktype==TASK_TURN_OFF)&&(CloseSystem==0))
//		{	// W takim przypadku UPS-a wylaczamy bez opoznienia
//			retVal = m_UPS.DoAction(ACTION_TURN_OFF_JUPS_ONLY);
//			if(retVal)
//				m_Net.SendTo(Addr,UDP_PACKET_DO_TASK|UDP_TYPE_ANSWER);
//			return;
//		}
//		else
//		//	2003.01.13, MW, koniec
//	  if(tasktype==TASK_TURN_OFF)     retVal=m_UPS.DoAction(ACTION_TURN_OFF);
//	  else if(tasktype==TASK_RESTART) retVal=m_UPS.DoAction(ACTION_RESTART,data);
//*/
		if(__debug)
			printf("Wynik zadania %d time=%d\n",retVal,(int)m_clock());
		if(retVal)
		{
			m_Net.SendTo(Addr,UDP_PACKET_DO_TASK|UDP_TYPE_ANSWER);
			// mamy wylaczyc UPS wiec uaktualniamy czas do wylaczenia UPS
			m_StartShutdownTime=m_clock();
//			m_ShutdownTimeDelay=UPS_SHUTDOWN_TIME;
			m_ShutdownTimeDelay = TurnOffDelay;	//Z0006, LT
			if(__debug)
				printf("Wylaczenie UPS %ld, delay=%ld\n",m_StartShutdownTime,m_ShutdownTimeDelay);
			// m_UPSShutdownTime wyliczany jest w UpdateLocalData();
			UpdateLocalData();
		}
	}
} // CUPSSrv::OnRead

/////////////////////////////////////////////////////////////////////////////
void CUPSSrv::UpdateLocalData()
{
//printf("Update local B=%d In=%d\n",m_Info.m_BatVol,m_Info.m_InVol);

	m_LastUpdateTime=m_clock();
	m_Info.m_CS.Lock();
	m_CommunicationOK=m_Info.m_CommunicationOK;
	m_CanAutostart=m_Info.m_CanAutostart;
	m_CanTurnOff=m_Info.m_CanTurnOff;
	m_AvpMan=m_Info.m_AvpMan;
	m_AvpMod=m_Info.m_AvpMod;
	m_AvpSoftVer=m_Info.m_AvpSoftVer;
	memcpy(m_Manufacturer,m_Info.m_Manufacturer,LEN_MAN);
	memcpy(m_Model,m_Info.m_Model,LEN_MODEL);
	memcpy(m_SoftVer,m_Info.m_SoftVer,LEN_SOFT_VER);
	m_BatCondition=m_Info.m_BatCondition;
	m_BatStatus=m_Info.m_BatStatus;
	m_BatVol=m_Info.m_BatVol;
	m_InVol=m_Info.m_InVol;
	m_OutCurrent=m_Info.m_OutCurrent;
	m_OutLoad=m_Info.m_OutLoad;
	m_OutPower=m_Info.m_OutPower;
	m_OutSource=m_Info.m_OutSource;
	m_OutVol=m_Info.m_OutVol;
	m_BatAutonomy = m_Info.m_BatAutonomy;	// (2003.01.02, MW)
	m_UPSStatus = m_Info.m_UPSStatus;		// (2003.01.02, MW)
	m_Info.m_CS.Unlock();
	// przygotowujemy bufor zawierajacy dane dla pakietu UDP_PACKET_GET_DYNAMIC_DATA
	memcpy(m_DynamicDataBuff,&m_BatStatus,1);
	u_short us=htons((u_short)m_BatVol);
	memcpy(m_DynamicDataBuff+1,&us,2);
	us=htons((u_short)m_InVol);
	memcpy(m_DynamicDataBuff+3,&us,2);
	us=htons((u_short)m_OutCurrent);
	memcpy(m_DynamicDataBuff+5,&us,2);
	us=htons((u_short)m_OutLoad);
	memcpy(m_DynamicDataBuff+7,&us,2);
	u_long ul=htonl((u_long)m_OutPower);
	memcpy(m_DynamicDataBuff+9,&ul,4);
	memcpy(m_DynamicDataBuff+13,&m_OutSource,1);
	us=htons((u_short)m_OutVol);
	memcpy(m_DynamicDataBuff+14,&us,2);
	memcpy(m_DynamicDataBuff+16,&m_BatCondition,1);


	// wyliczamy m_UPSShutdownTime
	if(m_ShutdownTimeDelay<=-1)
		m_UPSShutdownTime=-1;
	else
	{
		m_UPSShutdownTime=m_ShutdownTimeDelay-((m_clock()-m_StartShutdownTime)/*/CLOCKS_PER_SEC*/);
//printf("Czas t=%ld \n",m_UPSShutdownTime);
		if(m_UPSShutdownTime<0)
		{
			//	2003.01.16, MW, poprawa obslugi wylaczania UPS-a stykowego bez zamykania systemu
			//	Zeby usunac brak synchronizacji pomiedzy OnTimer w DlgMain i obliczaniem
			//	opoznienia do wylaczenia tutaj, nie wylacza odmierzania czasu az do zakonczenia
			//	operacji. Inaczej pomiedzy stanem "Planowe wylaczanie UPS-a" a stanem "wylaczony"
			//	pojawia sie stan "Praca sieciowa"
			//	 m_UPSShutdownTime=-1;
			//	 m_ShutdownTimeDelay=-1;
//printf("Srv odliczone UpsOff %d\n",m_Info.m_JointTurnOffUPSOnly);
			m_Info.m_CS.Lock();
			BOOL m_JointTurnOffUPSOnly  = m_Info.m_JointTurnOffUPSOnly;
			m_Info.m_CS.Unlock();
			if(m_JointTurnOffUPSOnly==TRUE)
				m_UPSShutdownTime = 0;
			else
			{
				m_UPSShutdownTime=-1;
				m_ShutdownTimeDelay=-1;
			}
			//	2003.01.16, MW, koniec
		}
	}
	ul=htonl((u_long)m_UPSShutdownTime);
	memcpy(m_DynamicDataBuff+17,&ul,4);
 	// obsuga zmiennych m_BatAutonomy i m_UPSStatus (2003.01.02, MW)
	ul = htonl((u_long)m_BatAutonomy);
	//printf("m_BatAutonomy =%ld,%ld\n",m_BatAutonomy,ul);
	memcpy(m_DynamicDataBuff+21,&ul,4);
	us = htons((u_short)m_UPSStatus);
	memcpy(m_DynamicDataBuff+25,&us,2);
	// koniec zmian (2003.01.02, MW)

} // CUPSSrv::UpdateLocalData

/////////////////////////////////////////////////////////////////////////////
void CUPSSrv::OnUPSNotification(int Code)
{
} // CUPSSrv::OnUPSNotification

//	2003.01.15, MW, poprawa obslugi wylaczania UPS-a bez zamykania systemu
//	Funkcja zwraca wartosc flagi sygnalizujacej wylaczenie UPS-a stykowego
//	bez zamykania systemu (TRUE - UPS ma byc wylaczony, FALSE - w przeciwnym
//	wypadku
BOOL CUPSSrv::GetJointTurnOffUPSOnly()
{
	m_Info.m_CS.Lock();
	BOOL retVal=m_Info.m_JointTurnOffUPSOnly;
	m_Info.m_CS.Unlock();
	return retVal;
} // CUPSSrv::GetJointTurnOffUPSOnly

//	2003.01.15, MW, poprawa obslugi wylaczania UPS-a bez zamykania systemu
//	Funkcja konczy proces wylaczania UPS-a ez zamykania systemu
void CUPSSrv::DoEndJointTurnOffUPSOnly()
{
	m_UPS.DoAction(ACTION_END_TURN_OFF_JUPS);
}

BOOL CUPSSrv::GetJointTurnOffFlag()
{
	m_Info.m_CS.Lock();
	BOOL retVal=m_Info.m_JointTurnOffFlag;
	m_Info.m_CS.Unlock();
	return retVal;
}


// EOF //////////////////////////////////////////////////////////////////////
