///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/07/20 10:18:55 $
//         $Locker:  $
//         $Revision: 1.12 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Odpowiednik serwisu w Windows
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: upssrv.h,v $
// Revision 1.12  2004/07/20 10:18:55  ltokarski
// Z0013 - wypisywanie w statusie protokolu komunikacji
//
// Revision 1.11  2004/07/09 11:32:02  ltokarski
// Z0012 - zapis biezacego statusu do pliku
//
// Revision 1.10  2004/06/29 10:19:25  ltokarski
// Z0008 - wejscie w tlo po zainicjowaniu komunikacji i zwracanie kodu bledu
//
// Revision 1.9  2004/06/25 11:42:18  ltokarski
// Z0007 - przywrocenie zapisu do upsoff.conf
//
// Revision 1.8  2004/06/24 12:20:08  ltokarski
// Z0006 - konfigurowany czas opoznienia do wylaczenia (oprocz stykowych)
//
// Revision 1.7  2004/06/23 15:40:24  ltokarski
// Z0005 - sprawdzanie wybranego protokolu
//
// Revision 1.6  2004/06/23 12:43:05  ltokarski
// Z0003 - uzywanie portow IP pobranych z pliku opcji
//
// Revision 1.5  2004/06/09 11:32:03  ltokarski
// nagwki CVS
// standard plikw Unix
//
///////////////////////////////////////////////////////

#ifndef _UPSSrv_h_
#define _UPSSrv_h_

#define clock_t time_t

class CUPSSrv
{
public:
   CUPSSrv();
   ~CUPSSrv();
	void DoEndJointTurnOffUPSOnly();
//   BOOL Init(int Port, char * Location);
   BOOL Init(char *Port, char * Location, UINT sPortIP, UINT cPortIP,	//Z0003, LT - nowe parametry: porty IP
		UINT protocol);													//Z0005, LT - protokol komun. z UPSem
//   void Stop();

   void OnRead(LPCTSTR Addr, UINT Port, BYTE *Buff, int Len);
   void OnUPSNotification(int Code);
   void UpdateLocalData();
   time_t m_clock();

	BOOL GetJointTurnOffFlag();
	BOOL GetJointTurnOffUPSOnly(); //	2003.01.15, MW, poprawa obslugi wylaczania UPS-a bez zamykania systemu
	void DoJointTurnOff(BYTE Mode, DWORD Time=0);

	void	SetTurnOffDelay(UINT d) { TurnOffDelay = d; };	//Z0006, LT
	UINT	GetTurnOffDelay() { return TurnOffDelay; };		//Z0006, LT
	void	SetCfgPath(char *cfg) { configPath = cfg; };	//Z0007, LT
	BOOL	CommunicationOK() { return m_Info.m_CommunicationOK; };	//Z0008, LT
   CNetDatagram m_Net;
   CSharedMemory m_SharedMem;
   BYTE	GetStatus() { return m_Info.m_Status; };			//Z0012, LT
   BYTE GetProtocol() { return m_Info.m_Protocol; };		//Z0013, LT

protected:
   CUPSThreadInfo m_Info;
   CUPSThread m_UPS;
   char m_Location[MAX_LOC_LEN];
// nowe
	clock_t m_LastUpdateTime;    // czas ostatniego uaktualnienia zmiennych lokalnych
   // kopia zestawu zmiennych zdefiniowanych w CUPSThreadInfo
   BOOL m_CommunicationOK;      // jezeli FALSE to brak komunikacji z UPSem
   char m_CanAutostart;         // ==1 gdy UPS mozna programowo ustawic aby
                                // automatycznie wlaczal sie po powrocie zasilania
   char m_CanTurnOff;           // ==1 gdy UPS mozna programowo wylaczyc
   char m_AvpMan;               // ==1 gdy zmienna 55 - Manufacturer jest dostepna
   char m_AvpMod;               // ==1 gdy zmienna 56 - Model jest dostepna
   char m_AvpSoftVer;           // ==1 gdy zmienna 84 - Software Version jest dostepna
   // zmienne informujace o stanie UPS'a
   char m_Manufacturer[LEN_MAN];// 55 - Manufacturer
   char m_Model[LEN_MODEL];     // 56 - Model
   char m_SoftVer[LEN_SOFT_VER];// 84 - Software Version
   char m_BatCondition;         // 19 - Batter Condition
   char m_BatStatus;            // 22 - Battery Status
   short m_BatVol;              // 24 - Battery Voltage
   short m_InVol;               // 51 - Input Voltage 1
   short m_OutCurrent;          // 65 - Output Current 1
   short m_OutLoad;             // 69 - Output Load 1
   long  m_OutPower;             // 73 - Output Power 1
   char  m_OutSource;            // 76 - Output Source
   short m_OutVol;              // 77 - Output Voltage 1
   long  m_BatAutonomy;			// Autonomia baterii (MW, 2003.01.02)
   short m_UPSStatus;			// Stan UPS-a (MW, 2003.01.02)

   clock_t m_StartShutdownTime; // czas wydania rozkazu wylaczenia UPS
                                // (wykorzystywane tylko gdy m_ShutdownTimeDelay!=-1)
   long m_ShutdownTimeDelay;    // opoznienie (w sek.) wylaczenia UPS
                                // (==-1 gdy UPS nie ma byc wylaczony)
   long m_UPSShutdownTime;      // ilosc sekund do wylaczenia UPS
                                // (==-1 gdy UPS nie ma byc wylaczony)
	UINT	TurnOffDelay;	//Z0006, LT - z OGROMNA przykroscia dodaje kolejna zmienna
							//poniewaz nie jestem w stanie zrozumiec dokonan poprzednikow i uproscic tego

   BYTE m_DynamicDataBuff[UDP_MAX_PACKET_LEN]; // bufor zawierajacy dane dla pakietu UDP_PACKET_GET_DYNAMIC_DATA
   UINT	clientPortIP;	//Z0003, LT
   char	*configPath;	//Z0007, LT
};

#endif // _UPSSrv_h_

// EOF //////////////////////////////////////////////////////////////////////
