///////////////////////////////////////////////////////
// Fideltronik R&D Department, Copyright (c)2003
//         $Author: ltokarski $
//         $Date: 2004/06/30 16:51:31 $
//         $Locker:  $
//         $Revision: 1.3 $
///////////////////////////////////////////////////////
//	Opis funkcjonalny moduu:
//          Wylaczanie UPSow stykowych przy zamykaniu systemu
///////////////////////////////////////////////////////
// Historia zmian:
// $Log: upsoff.c,v $
// Revision 1.3  2004/06/30 16:51:31  ltokarski
// Z0002 - nie mial czytac portu z upsoff.conf
//
// Revision 1.2  2004/06/25 11:35:51  ltokarski
// Z0001 - analiza pliku options.cfg
//
////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <sys/ioctl.h>

#define OPTIONS_FILE	"/etc/ups/fideltronik/options.cfg"	//Z0001, LT - sciezka do opcji jest stala

//#define SHM_FILE "/etc/ups/scripts/upsoff.conf"	/* plik trybu zamykania systemu */
#define SHM_FILE "upsoff.conf"	//Z0001, LT - sciezka jest zmienna, czytana z opcji

#define LINE_LEN	80

int main(int argc,char *argv[])
{
	int p,d;
	int iPort;
	FILE *fd;
	int sFlag;
	char sPort[50];
	char cfg[50];	//Z0001, LT

	if(argc>1)
	{
		strcpy(sPort,argv[1]);
		printf("Wylaczam ups na porcie %s\n",sPort);

	}
	else
	{
		//Z0001, LT - proba odczytu pliku z opcjami
	    FILE *f = fopen(OPTIONS_FILE, "r");
        char    variable[LINE_LEN];
	    if(f == NULL)
    	{
			perror(OPTIONS_FILE);
        	return -1;
    	}
    	while(fgets(variable, LINE_LEN, f))
    	{
    	    char *p;
    	    char *value;
        	if(variable[0] == '#')      //komentarz lub pusta
            	continue;
        	value = strchr(variable, '=');
        	if(value == NULL)       //nie jest to przypisanie zmiennej (np. pusta)
	            continue;
    	    //wyodrebnienie zmiennej i wartosci przez wyciecie '=' '"' i '\n'
	        *value = 0;
    	    value++;
        	p = strchr(value, '\n');
        	if(p)
	            *p = 0;
        	p = strchr(value, '\"');
        	if(p)
        	{
	            value = p + 1;
            	p = strrchr(value, '\"');
            	if(p)
	                *p = 0;
        	}
        	//przepisanie wartosci do odpowiedniej zmiennej w programie
			if(strcmp(variable, "SERIAL_PORT") == 0)
	            strncpy(sPort, value, 50);
        	else if(strcmp(variable, "PATH_CONFIG") == 0)
	            strncpy(cfg, value, LINE_LEN);
	    }
		strncat(cfg, SHM_FILE, LINE_LEN-strlen(cfg));
		//Z0001, LT - koniec
		/*** odczyt pliku z flaga wylaczenia i nazwa portu */
		if ((fd = fopen(cfg, "r")) == NULL )
		{
			perror(cfg);
			return -1;
		}
		fscanf(fd,"%d",&sFlag);
		//Z0002, LT - portu juz nie czytam
		fclose(fd);

//LT - teraz kasuje na poczatku serwera
//		if ((fd = fopen(SHM_FILE,"w")) == NULL )
//		{
//			printf("UPS: Blad dostepu do pliku %s\n",SHM_FILE);
//		}
//		fprintf(fd,"%s\n","0"); //kolejny raz nie wylaczam
//		fprintf(fd,"%s\n",sPort);
//		fclose(fd);
		if (sFlag == 0)
		{ /* nie wylaczam pradu... */
			printf ("UPS: Bez wylaczania ...\n");
			return 1;
		}
		/**** rozpoczynamy wylaczenie UPS-a */
	}
	if(strlen(sPort) == 1)  //sam numer portu
	{
	    char p = sPort[0];
	    sprintf(sPort, "/dev/ttyS%c", p);
	}

	iPort = open(sPort, O_RDWR | O_NOCTTY | O_NDELAY);		/* otwarcie portu */
	if (iPort == -1)
	{
		printf("Blad dostepu do portu szeregowego !!!!\n");
		return -1;
	}
	/**** wylaczam.... */
	printf ("UPS: Wylaczam zasilanie...\n");
	p = TIOCM_RTS;
	d = TIOCM_DTR;
	ioctl(iPort,TIOCMBIC,&d);
	ioctl(iPort,TIOCMBIS,&p);
		/***** 10 sekund na wylaczenie zasilania */
//LT	if(argc>1)
		sleep (10);
	/**** problem... */
	//printf("UPS: Problem z wylaczeniem UPS\n");
	//close(iPort);
	exit(0);
	return 0;

}
